/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.automaticprocessing;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

/**
 *
 * @author user
 */
public class AutomaticProcessingFileHandler {

    private static AutomaticProcessingFileHandler instance = null;
    private static boolean isActive = false;
    private AutomaticProcessingFileHandlerWorker worker;

    private AutomaticProcessingFileHandler() {
    }

    public static AutomaticProcessingFileHandler getInstance() {
        if (instance == null) {
            instance = new AutomaticProcessingFileHandler();
        }
        return instance;
    }

    public static boolean isActive() {
        if (instance == null) {
            return false;
        } else {
            return isActive;
        }
    }
        
    public void setActivityStatus(boolean stat) {
        if (instance != null) {
            isActive = stat;
        }
    }

    public synchronized void processSpectroscopyFile(File newfile, List<String> refUIDS) {
        
        notifyActionListeners( this, ADD_NEW_FILE_TO_PROCESS, newfile.getAbsolutePath( ) );
        
        if (worker != null && !worker.isDone()&& !worker.isCancelled()) {
//            worker.pause();
            worker.addSpectroscopyFileToProcess(newfile, refUIDS);
//            worker.resume();
        } else {
            
            worker = new AutomaticProcessingFileHandlerWorker( this );            
            worker.addSpectroscopyFileToProcess(newfile, refUIDS);
            worker.execute();
        }
        
    }

    public void workerFinished() {
        worker = null;
    }
    
    /**
     * Notifies actionEvent to all registered listeners
     */
    private void notifyActionListeners( Object obj, int eventType, String actionCommand ) {
        Iterator it = m_actionListeners.iterator();
        while (it.hasNext()) {
            ((ActionListener) it.next()).actionPerformed(new ActionEvent(obj, eventType, actionCommand));
        }
    }
    
    /**
     * Adds an ActionListener to the list of listeners
     * @param listener
    */
    public void addActionListener( ActionListener listener )
    {
        m_actionListeners.add( listener );
    }
    
    // Listeners to this object
    private Vector<ActionListener> m_actionListeners = new Vector<>();
    
    public final static int ADD_NEW_FILE_TO_PROCESS = 0;
    public final static int PROCESSING_SPECTROSCOPY_FILE = 1;
    public final static int PROCESSING_SPECTROSCOPY_FILE_READY = 2;

}
