/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.autoqualitycontrol;

import java.awt.Component;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.TreeSet;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.text.DefaultFormatter;
import org.spectrim.model.GlobalModel;

/**
 *
 * @author nunopbarros
 */
public class MismatchLabellingAssistant extends javax.swing.JFrame implements KeyListener, LabellingPopupInterface {

    File currentFile;
    File currentReferenceFile;
    String newFile = "";
    LabellingListener listener;
    HashMap<String, String> unsavedLabels = new HashMap<>();
    HashMap<String, ArrayList<Double>> features;
    GlobalModel model;
    HashMap<String, String> oldQLabels = new HashMap<>();
    HashMap<String, Integer> newQLabels = new HashMap<>();
    HashMap<String, Double> qscores = new HashMap<>();
    TreeSet<String> mismatch = new TreeSet<>();

    /**
     * Creates new form PopupLabelling
     */
    public MismatchLabellingAssistant(final LabellingListener listener, File currentFile, File currentRefFile, GlobalModel model, Component component) {
        if (model.isQScoresEmpty()) {
            JOptionPane.showMessageDialog(this, "Please, classify Spectral Quality before!", "Warning", JOptionPane.NO_OPTION);
            this.dispose();
        } else {
            initComponents();
            qscores = model.getSpectra().getQualityScores();
            this.features = features;
            this.model = model;
            this.currentFile = currentFile;
            this.listener = listener;
            this.setVisible(true);
            this.addKeyListener(this);
            ((DefaultFormatter) jFormattedTextFieldLabel.getFormatter()).setCommitsOnValidEdit(true);
            jFormattedTextFieldLabel.setValue(0);
            this.setDefaultCloseOperation(javax.swing.JFrame.DO_NOTHING_ON_CLOSE);
            final Component comp = this;
            WindowListener exitListener = new WindowAdapter() {
                @Override
                public void windowClosing(WindowEvent e) {
                    int confirm = JOptionPane.showOptionDialog(comp, "Are You Sure to Close the Labelling Assistant?", "Exit Confirmation", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, null);
                    if (confirm == 0) {
                        listener.finish();
                        dispose();
                    }
                }
            };
            this.addWindowListener(exitListener);
            this.currentReferenceFile = currentRefFile;
            this.setLocationRelativeTo(component);
        }

    }

    public void initialization() {
        if (currentReferenceFile != null) {
            setReferenceFile(new File[]{currentReferenceFile});
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jFormattedTextFieldLabel = new javax.swing.JFormattedTextField();
        jButtonOK = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldCoord = new javax.swing.JTextField();
        jProgressBar1 = new javax.swing.JProgressBar();
        jLabelProgress = new javax.swing.JLabel();
        jTextFieldOldFile = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldPreviousLabel = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jTextFieldQScore = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("SpectrIm - Mismatch Labelling Assistant");
        setAlwaysOnTop(true);

        jLabel1.setText("New Label");

        jFormattedTextFieldLabel.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat(""))));
        jFormattedTextFieldLabel.addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
                jFormattedTextFieldLabelInputMethodTextChanged(evt);
            }
        });
        jFormattedTextFieldLabel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jFormattedTextFieldLabelKeyPressed(evt);
            }
        });

        jButtonOK.setText("OK");
        jButtonOK.setEnabled(false);
        jButtonOK.setSelected(true);
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKActionPerformed(evt);
            }
        });

        jLabel3.setText("Voxel");

        jTextFieldCoord.setEditable(false);
        jTextFieldCoord.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCoord.setText("0 0 0");

        jLabelProgress.setText("0/0 voxels labelled");

        jTextFieldOldFile.setEditable(false);
        jTextFieldOldFile.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTextFieldOldFileMouseClicked(evt);
            }
        });
        jTextFieldOldFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldOldFileActionPerformed(evt);
            }
        });

        jLabel4.setText("File containing Reference Labelling-Session(s) for detecting Mismatch with Classifier:");

        jLabel5.setText("Previous Label(s)");

        jTextFieldPreviousLabel.setEditable(false);
        jTextFieldPreviousLabel.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldPreviousLabel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldPreviousLabelActionPerformed(evt);
            }
        });

        jLabel6.setText("QScore");

        jTextFieldQScore.setEditable(false);
        jTextFieldQScore.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(305, 305, 305)
                        .addComponent(jButtonOK, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jProgressBar1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelProgress, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel4)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addComponent(jTextFieldCoord, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextFieldQScore, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel6))
                        .addGap(34, 34, 34)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextFieldPreviousLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 220, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jFormattedTextFieldLabel)))
                    .addComponent(jTextFieldOldFile))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextFieldOldFile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jLabel6)
                    .addComponent(jLabel5)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldCoord, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldPreviousLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldQScore, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jFormattedTextFieldLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelProgress, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButtonOK)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
        OKPressed();
    }//GEN-LAST:event_jButtonOKActionPerformed

    private void OKPressed() {
        newQLabels.put(this.jTextFieldCoord.getText(), Integer.valueOf(this.jFormattedTextFieldLabel.getText()));

        this.jProgressBar1.setValue(jProgressBar1.getValue() + 1);
        this.jLabelProgress.setText(jProgressBar1.getValue() + "/" + jProgressBar1.getMaximum() + " voxels labelled");
        this.jButtonOK.setEnabled(false);
        if (jProgressBar1.getValue() < jProgressBar1.getMaximum()) {
            this.listener.nextLabel();
            if (jProgressBar1.getValue() == (jProgressBar1.getMaximum() - 1)) {
                this.jButtonOK.setText("OK & Save");
            }
        } else {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setDialogTitle("Save updated labels to...");
            if (currentFile != null) {
                fileChooser.setSelectedFile(currentFile);
            } else if (currentReferenceFile != null) {
                fileChooser.setCurrentDirectory(currentReferenceFile);
            }
            FileNameExtensionFilter filter = new FileNameExtensionFilter("text", "txt");
            fileChooser.setFileFilter(filter);
            int result = fileChooser.showOpenDialog(this);
            File selected_file;
            switch (result) {
                case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                    selected_file = fileChooser.getSelectedFile();
                    this.currentFile = fileChooser.getSelectedFile();
                    this.listener.saveFileLocation(currentFile);
                    if (selected_file != null) {
                        this.newFile = selected_file.toString();
                        if (!newFile.endsWith(".txt")) {
                            this.newFile += ".txt";
                        }
                        this.jButtonOK.setEnabled(true);
                        save2File();
                        listener.finish();
                        dispose();
                    }
                    break;
                case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                    int confirm = JOptionPane.showOptionDialog(this, "Are You Sure to Close the Labelling Assistant?", "Exit Confirmation", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, null);
                    if (confirm == 0) {
                        listener.finish();
                        dispose();
                    }
                    break;
                case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                    break;
            }

        }
    }


    private void jFormattedTextFieldLabelKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jFormattedTextFieldLabelKeyPressed
        int value = Integer.valueOf(jFormattedTextFieldLabel.getValue().toString());
        switch (evt.getKeyCode()) {
            case KeyEvent.VK_ENTER:
                if (this.jButtonOK.isEnabled()) {
                    OKPressed();
                }
                break;
            case KeyEvent.VK_UP:
                value++;
                if (value > 1) {
                    value = 1;
                    Toolkit.getDefaultToolkit().beep();
                } else if (value < 0) {
                    value = 0;
                    Toolkit.getDefaultToolkit().beep();
                }
                this.jFormattedTextFieldLabel.setValue(value);
                break;
            case KeyEvent.VK_DOWN:
                value--;
                if (value > 1) {
                    value = 1;
                    Toolkit.getDefaultToolkit().beep();
                } else if (value < 0) {
                    value = 0;
                    Toolkit.getDefaultToolkit().beep();
                }
                this.jFormattedTextFieldLabel.setValue(value);
                break;
        }
    }//GEN-LAST:event_jFormattedTextFieldLabelKeyPressed

    private void jFormattedTextFieldLabelInputMethodTextChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_jFormattedTextFieldLabelInputMethodTextChanged
    }//GEN-LAST:event_jFormattedTextFieldLabelInputMethodTextChanged

    private void jTextFieldOldFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldOldFileActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldOldFileActionPerformed

    private void jTextFieldOldFileMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextFieldOldFileMouseClicked
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Set previous labelling-session file(s)");
        fileChooser.setMultiSelectionEnabled(true);
        if (currentReferenceFile != null) {
            fileChooser.setSelectedFile(currentReferenceFile);
        } else if (currentFile != null) {
            fileChooser.setCurrentDirectory(currentFile);
        }
        FileNameExtensionFilter filter = new FileNameExtensionFilter("text", "txt");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File[] selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFiles();
                this.currentReferenceFile = fileChooser.getCurrentDirectory();
                this.listener.saveReferenceFileLocation(currentReferenceFile);
                if (selected_file != null) {
                    setReferenceFile(selected_file);
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jTextFieldOldFileMouseClicked

    private void jTextFieldPreviousLabelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldPreviousLabelActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldPreviousLabelActionPerformed

    public void setReferenceFile(File[] selected_file) {
        mismatch.clear();
        String files = "";
        this.currentReferenceFile = selected_file[0];
        listener.saveReferenceFileLocation(currentReferenceFile);
        for (int i = 0; i < selected_file.length; i++) {
            files += selected_file[i] + "; ";
            analyzeMismatch(selected_file[i]);
        }
        this.jTextFieldOldFile.setText(files);
        if (oldQLabels.size() == 0) {
            JOptionPane.showMessageDialog(this, "The reference file does not contain labels for the presented case!", "Warning", JOptionPane.NO_OPTION);
        } else if (mismatch.size() == 0) {
            JOptionPane.showMessageDialog(this, "There is no Mismatch!", "Warning", JOptionPane.NO_OPTION);
            save2File();
            this.dispose();
        }
        listener.setUnlabelledVoxels(mismatch);
        this.setLabelsSize(mismatch.size());
        if (mismatch.size() == 1) {
            this.jButtonOK.setText("OK & Save");
        }
    }

    public void analyzeMismatch(File oldFile) {
        BufferedReader reader;
        String line;
        int linesize;
        try {
            reader = new BufferedReader(new FileReader(oldFile));
            while ((line = reader.readLine()) != null) {
                String[] parts = line.split("\\t");
                linesize = parts.length;
                if (linesize > 0) {
                    if (!parts[0].startsWith("*")) {
                        String[] firstCol = parts[0].split("\\\\");
                        if (firstCol[2].matches(model.getPatientName()) && firstCol[3].matches(model.getStudyDate()) && firstCol[4].matches(model.getSeriesNumber() + "-" + model.getSeriesDescription())) {
                            int oldVal = Integer.valueOf(parts[1]);
                            double qscore = qscores.get(firstCol[5]);
                            if (oldQLabels.containsKey(firstCol[5])) {
                                oldQLabels.put(firstCol[5], oldQLabels.get(firstCol[5]) + ";" + oldVal);
                            } else {
                                oldQLabels.put(firstCol[5], String.valueOf(oldVal));
                            }
                            if (oldVal == 1 && qscore < 0.5 || oldVal == 0 && qscore >= 0.5) {
                                mismatch.add(firstCol[5]);
                            }
                        }
                    }
                }
            }
            reader.close();
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    public void save2File() {
        try {
            BufferedWriter output = new BufferedWriter(new FileWriter(newFile, true));
            BufferedReader reader;
            String line;
            int linesize;
            reader = new BufferedReader(new FileReader(this.currentReferenceFile.toString()));
            if (!newQLabels.isEmpty()) {
                output.append("*Updtated Labelling Session. Files used as reference: " + this.jTextFieldOldFile.getText());
                output.newLine();
            }
            while ((line = reader.readLine()) != null) {
                String[] parts = line.split("\\t");
                linesize = parts.length;
                if (linesize > 0) {
                    if (!parts[0].startsWith("*")) {
                        String[] firstCol = parts[0].split("\\\\");
                        if (firstCol[2].matches(model.getPatientName())
                                && firstCol[3].matches(model.getStudyDate())
                                && firstCol[4].matches(model.getSeriesNumber() + "-" + model.getSeriesDescription())) {
                            if (newQLabels.containsKey(firstCol[5])) {
                                String newline = parts[0] + "\t" + newQLabels.get(firstCol[5]) + "\t" + "UPDATED! Before was:" + "\t" + oldQLabels.get(firstCol[5]);
                                output.append(newline);
                                output.newLine();
                            } else {
                                output.append(parts[0] + "\t" + parts[1]);
                                output.newLine();
                            }
                        }
                    }
                }
            }
            output.close();
            reader.close();
        } //            CHECK FOR REPEATED ENTRIES LATER
        catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    public void setLabelsSize(int total) {
        this.jProgressBar1.setMaximum(total);
        this.jProgressBar1.setValue(0);
        this.jLabelProgress.setText(0 + "/" + total + "voxels labelled");
    }

    @Override
    public void askLabel(String coord) {
        this.setVisible(true);
        this.jTextFieldCoord.setText(coord);
        this.jTextFieldPreviousLabel.setText(this.oldQLabels.get(coord));
        this.jTextFieldQScore.setText(this.qscores.get(coord).toString());
        if (this.currentReferenceFile != null) {
            this.jButtonOK.setEnabled(true);
        }
    }
    /**
     * @param args the command line arguments
     */
//    public static void main(String args[]) {
//        /* Set the Nimbus look and feel */
//        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
//        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
//         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
//         */
//        try {
//            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
//                if ("Nimbus".equals(info.getName())) {
//                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
//                    break;
//                }
//            }
//        } catch (ClassNotFoundException ex) {
//            java.util.logging.Logger.getLogger(PopupLabelling.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (InstantiationException ex) {
//            java.util.logging.Logger.getLogger(PopupLabelling.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (IllegalAccessException ex) {
//            java.util.logging.Logger.getLogger(PopupLabelling.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
//            java.util.logging.Logger.getLogger(PopupLabelling.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        }
//        //</editor-fold>
//
//        /* Create and display the form */
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new PopupLabelling().setVisible(true);
//            }
//        });
//    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonOK;
    private javax.swing.JFormattedTextField jFormattedTextFieldLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabelProgress;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JTextField jTextFieldCoord;
    private javax.swing.JTextField jTextFieldOldFile;
    private javax.swing.JTextField jTextFieldPreviousLabel;
    private javax.swing.JTextField jTextFieldQScore;
    // End of variables declaration//GEN-END:variables

    @Override
    public void keyTyped(KeyEvent ke) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void keyPressed(KeyEvent ke) {
        if (ke.getKeyCode() == KeyEvent.VK_ENTER) {
            OKPressed();
        }
    }

    @Override
    public void keyReleased(KeyEvent ke) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void setLocationRelTo(Component comp) {
        this.setLocationRelTo(comp);
        System.out.println("");
    }
}
