/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.colormap;

import java.util.ArrayList;
import org.spectrim.model.GlobalModel;
import org.spectrim.spectra.Spectra;
import org.spectrim.view.SpectraPanel;

/**
 * 
 * This class enables the user to color map a specific feature. 
 * The features can be displayed as overlays on top of the MR-images. 
 * @author Nuno, Hans
 */
public class ColorMapUI extends javax.swing.JFrame {

    private GlobalModel model;
    private final InterfaceMainGUIColorMapUI mainGUI;

    /**
     * Creates new form ColorMapUI.
     * @param mainGUI
     * @param model
     */
    public ColorMapUI(InterfaceMainGUIColorMapUI mainGUI, GlobalModel model) {
        this.mainGUI = mainGUI;
        this.model = model;
        initComponents( );
        ArrayList<String> scales = model.getColorMap( ).getColorScalesNames( );
        for ( int i = 0; i < scales.size( ); i++ ) 
        {
            this.jComboBoxColorScale.addItem( scales.get( i ) );
        }
        this.jComboBoxFunction.addItem( "--Select Function--" );
        ArrayList<String> functions = model.getColorMap( ).getFunctionsNames( );
        for (int i = 0; i < functions.size( ); i++) 
        {
            this.jComboBoxFunction.addItem( functions.get( i ) );
        }
        this.setVisible( true );
        this.pack( );
    }
    
    public void setGlobalModel( GlobalModel model ){
        this.model = model;
        this.jComboBoxFunction.setSelectedIndex( 0 );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jComboBoxColorScale = new javax.swing.JComboBox();
        jComboBoxFunction = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jPanelRanges = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jLabelMsgSelectRange = new javax.swing.JLabel();
        jPanelRange1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jFormattedTextFieldMinR1 = new javax.swing.JFormattedTextField();
        jFormattedTextFieldMaxR1 = new javax.swing.JFormattedTextField();
        jLabelDimensionsR1 = new javax.swing.JLabel();
        jPanelRange2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jFormattedTextFieldMinR2 = new javax.swing.JFormattedTextField();
        jFormattedTextFieldMaxR2 = new javax.swing.JFormattedTextField();
        jLabelDimensionsR2 = new javax.swing.JLabel();
        jFormattedTextFieldMinScale = new javax.swing.JFormattedTextField();
        jLabel5 = new javax.swing.JLabel();
        jFormattedTextFieldMaxScale = new javax.swing.JFormattedTextField();
        jButtonGaussian = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("SpectrIm - Map Features");
        setAlwaysOnTop(true);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        jComboBoxColorScale.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxColorScaleActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 165;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jComboBoxColorScale, gridBagConstraints);

        jComboBoxFunction.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxFunctionActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 165;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jComboBoxFunction, gridBagConstraints);

        jLabel1.setText("Color Scale:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jLabel1, gridBagConstraints);

        jLabel2.setText("Function:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jLabel2, gridBagConstraints);

        jPanelRanges.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        jPanelRanges.setLayout(new java.awt.GridBagLayout());

        jButton1.setText("Select in Spectrum");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        jPanelRanges.add(jButton1, gridBagConstraints);

        jLabelMsgSelectRange.setText("Please, Select a Range:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(6, 0, 4, 0);
        jPanelRanges.add(jLabelMsgSelectRange, gridBagConstraints);

        jPanelRange1.setLayout(new java.awt.GridBagLayout());

        jLabel3.setText("Range 1:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanelRange1.add(jLabel3, gridBagConstraints);

        jFormattedTextFieldMinR1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMinR1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 86;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 2);
        jPanelRange1.add(jFormattedTextFieldMinR1, gridBagConstraints);

        jFormattedTextFieldMaxR1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMaxR1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 86;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 0);
        jPanelRange1.add(jFormattedTextFieldMaxR1, gridBagConstraints);

        jLabelDimensionsR1.setText("ppm");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 0);
        jPanelRange1.add(jLabelDimensionsR1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanelRanges.add(jPanelRange1, gridBagConstraints);

        jPanelRange2.setLayout(new java.awt.GridBagLayout());

        jLabel4.setText("Range 2:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanelRange2.add(jLabel4, gridBagConstraints);

        jFormattedTextFieldMinR2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMinR2ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 86;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 2);
        jPanelRange2.add(jFormattedTextFieldMinR2, gridBagConstraints);

        jFormattedTextFieldMaxR2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMaxR2ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 86;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 0);
        jPanelRange2.add(jFormattedTextFieldMaxR2, gridBagConstraints);

        jLabelDimensionsR2.setText("ppm");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 0);
        jPanelRange2.add(jLabelDimensionsR2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanelRanges.add(jPanelRange2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 4;
        gridBagConstraints.ipady = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jPanelRanges, gridBagConstraints);

        jFormattedTextFieldMinScale.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMinScaleActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 86;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
        getContentPane().add(jFormattedTextFieldMinScale, gridBagConstraints);

        jLabel5.setText("Scale Range:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jLabel5, gridBagConstraints);

        jFormattedTextFieldMaxScale.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldMaxScale.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMaxScaleActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 86;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
        getContentPane().add(jFormattedTextFieldMaxScale, gridBagConstraints);

        jButtonGaussian.setText("Apply Gaussian filter");
        jButtonGaussian.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonGaussianActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonGaussian, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jFormattedTextFieldMaxR1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMaxR1ActionPerformed
        rangeUpdate();
    }//GEN-LAST:event_jFormattedTextFieldMaxR1ActionPerformed

    private void jComboBoxColorScaleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxColorScaleActionPerformed
        model.getColorMap().setCurrentScale(this.jComboBoxColorScale.getSelectedIndex());
        model.updateViewImagePanels();
    }//GEN-LAST:event_jComboBoxColorScaleActionPerformed

    private void jComboBoxFunctionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxFunctionActionPerformed
        int index = this.jComboBoxFunction.getSelectedIndex();

        if (index == 0) {
            this.jPanelRanges.setEnabled(false);
            this.jPanelRanges.setVisible(false);
            this.jFormattedTextFieldMinScale.setText("");
            this.jFormattedTextFieldMinScale.setEditable(false);
            this.jFormattedTextFieldMaxScale.setText("");
            this.jFormattedTextFieldMaxScale.setEditable(false);

        } else {
            int nrRanges = model.getColorMap().getFunction(index - 1).getNrRanges();
            if (nrRanges == 0) {
                this.jPanelRanges.setEnabled(false);
                this.jPanelRanges.setVisible(false);
                model.getColorMap().createMap(index - 1);
                updateScaleRangesFromMap();
            } else {
                this.jPanelRanges.setEnabled(true);
                this.jPanelRanges.setVisible(true);
                if (model.getColorMap().getFunction(index - 1).getRangeDomain() == MapFunction.FD_RANGE) {
                    this.jLabelDimensionsR1.setText("ppm");
                    this.jLabelDimensionsR2.setText("ppm");
                    this.jFormattedTextFieldMinR1.setText("3.1");
                    this.jFormattedTextFieldMaxR1.setText("3.5");
                    this.jFormattedTextFieldMinR2.setText("2.6");
                    this.jFormattedTextFieldMaxR2.setText("3.1");
                    mainGUI.setSpectraDomain(Spectra.Domain.FD_PPM.txt);
                } else {
                    this.jLabelDimensionsR1.setText("ms");
                    this.jLabelDimensionsR2.setText("ms");
                    this.jFormattedTextFieldMinR1.setText("50");
                    this.jFormattedTextFieldMaxR1.setText("100");
                    this.jFormattedTextFieldMinR2.setText("0");
                    this.jFormattedTextFieldMaxR2.setText("50");
                    mainGUI.setSpectraDomain(Spectra.Domain.FD_PPM.txt);
                }
                if (nrRanges == 1) {
                    this.jPanelRange1.setEnabled(true);
                    this.jPanelRange1.setVisible(true);
                    this.jPanelRange2.setEnabled(false);
                    this.jPanelRange2.setVisible(false);
                    model.getColorMap().createMap(index - 1, new double[]{getMinR1(), getMaxR1()});

                } else if (nrRanges == 2) {
                    this.jPanelRange1.setEnabled(true);
                    this.jPanelRange1.setVisible(true);
                    this.jPanelRange2.setEnabled(true);
                    this.jPanelRange2.setVisible(true);
                    model.getColorMap().createMap(index - 1, new double[]{getMinR1(), getMaxR1(), getMinR2(), getMaxR2()});

                }
                updateScaleRangesFromMap();
            }
            if(model.getColorMap().getFunction(index-1).getName().matches("Quality Map")){
                model.getColorMap().setMin(0);
                model.getColorMap().setMax(1);
                this.jFormattedTextFieldMinScale.setText("0");
                this.jFormattedTextFieldMaxScale.setText("1");
            }
            updateDomainMarkers();
        }
        this.pack();
    }//GEN-LAST:event_jComboBoxFunctionActionPerformed

    private void jFormattedTextFieldMaxScaleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMaxScaleActionPerformed
        if (this.jComboBoxFunction.getSelectedIndex() != 0) {
            model.getColorMap().setMax(getMaxScale());
        }
    }//GEN-LAST:event_jFormattedTextFieldMaxScaleActionPerformed

    private void jFormattedTextFieldMinScaleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMinScaleActionPerformed
        if (this.jComboBoxFunction.getSelectedIndex() != 0) {
            model.getColorMap().setMin(getMinScale());
        }
    }//GEN-LAST:event_jFormattedTextFieldMinScaleActionPerformed

    private void jFormattedTextFieldMinR1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMinR1ActionPerformed
        rangeUpdate();
    }//GEN-LAST:event_jFormattedTextFieldMinR1ActionPerformed

    private void jFormattedTextFieldMinR2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMinR2ActionPerformed
        rangeUpdate();
    }//GEN-LAST:event_jFormattedTextFieldMinR2ActionPerformed

    private void jFormattedTextFieldMaxR2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMaxR2ActionPerformed
        rangeUpdate();
    }//GEN-LAST:event_jFormattedTextFieldMaxR2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        int index = this.jComboBoxFunction.getSelectedIndex();
        if (this.model.getColorMap().getFunction(index - 1).getNrRanges() == 1) {
            model.initiate1RangeSelection();
        } else if (this.model.getColorMap().getFunction(index - 1).getNrRanges() == 2) {
            model.initiate2RangesSelection();
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButtonGaussianActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonGaussianActionPerformed
        this.model.getColorMap().smoothColorMap();
        this.model.updateViewImagePanels();
    }//GEN-LAST:event_jButtonGaussianActionPerformed

    private float getMaxScale() {
        return Float.valueOf(this.jFormattedTextFieldMaxScale.getText().toString());
    }

    private float getMinScale() {
        return Float.valueOf(this.jFormattedTextFieldMinScale.getText().toString());
    }

    private float getMinR1() {
        return Float.valueOf(this.jFormattedTextFieldMinR1.getText().toString());
    }

    private float getMaxR1() {
        return Float.valueOf(this.jFormattedTextFieldMaxR1.getText().toString());
    }

    private float getMinR2() {
        return Float.valueOf(this.jFormattedTextFieldMinR2.getText().toString());
    }

    private float getMaxR2() {
        return Float.valueOf(this.jFormattedTextFieldMaxR2.getText().toString());
    }

    private void rangeUpdate() {
        int index = this.jComboBoxFunction.getSelectedIndex();
        if (index != 0) {
            updateDomainMarkers();
            model.getColorMap().createMap(index - 1, new double[]{getMinR1(), getMaxR1(), getMinR2(), getMaxR2()});
            updateScaleRangesFromMap();
        }
    }

    private void updateDomainMarkers() {
        model.clearDomainMarkers();
        if (model.getColorMap().getCurrentFunction().getNrRanges() > 0) {
            model.addDomainMarker(getMinR1(), SpectraPanel.COLOR1);
            model.addDomainMarker(getMaxR1(), SpectraPanel.COLOR1);
            if (model.getColorMap().getCurrentFunction().getNrRanges() == 2) {
                model.addDomainMarker(getMinR2(), SpectraPanel.COLOR2);
                model.addDomainMarker(getMaxR2(), SpectraPanel.COLOR2);
            }
        }
    }

    private void updateScaleRangesFromMap() {
        this.jFormattedTextFieldMinScale.setText(String.valueOf(model.getColorMap().getMin()));
        this.jFormattedTextFieldMaxScale.setText(String.valueOf(model.getColorMap().getMax()));
        this.jFormattedTextFieldMinScale.setEditable(true);
        this.jFormattedTextFieldMaxScale.setEditable(true);
    }

    public void setRangesText(double min1, double max1, double min2, double max2) {
        this.jFormattedTextFieldMinR1.setText(String.valueOf(min1));
        this.jFormattedTextFieldMaxR1.setText(String.valueOf(max1));
        this.jFormattedTextFieldMinR2.setText(String.valueOf(min2));
        this.jFormattedTextFieldMaxR2.setText(String.valueOf(max2));
    }

    public void setRangesText(double min1, double max1) {
        this.jFormattedTextFieldMinR1.setText(String.valueOf(min1));
        this.jFormattedTextFieldMaxR1.setText(String.valueOf(max1));
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ColorMapUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ColorMapUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ColorMapUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ColorMapUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButtonGaussian;
    private javax.swing.JComboBox jComboBoxColorScale;
    private javax.swing.JComboBox jComboBoxFunction;
    private javax.swing.JFormattedTextField jFormattedTextFieldMaxR1;
    private javax.swing.JFormattedTextField jFormattedTextFieldMaxR2;
    private javax.swing.JFormattedTextField jFormattedTextFieldMaxScale;
    private javax.swing.JFormattedTextField jFormattedTextFieldMinR1;
    private javax.swing.JFormattedTextField jFormattedTextFieldMinR2;
    private javax.swing.JFormattedTextField jFormattedTextFieldMinScale;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabelDimensionsR1;
    private javax.swing.JLabel jLabelDimensionsR2;
    private javax.swing.JLabel jLabelMsgSelectRange;
    private javax.swing.JPanel jPanelRange1;
    private javax.swing.JPanel jPanelRange2;
    private javax.swing.JPanel jPanelRanges;
    // End of variables declaration//GEN-END:variables
}
