/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.colormap;

import java.awt.Color;
import java.util.HashMap;
import org.spectrim.model.GlobalModel;

/**
 *
 * @author johan
 */
public class ImportedCSVDataColorMapOverlaySelectionFrame extends javax.swing.JFrame {

    private final String[]   m_columnTypes;
    private final String[]   m_columnNames;
    private final Object[][] m_csvData;
    private final GlobalModel m_globalModel;
    private final HashMap<String,Integer> m_numericalOverlaysMapIndices = new HashMap<>( );
    private final HashMap<String,Integer> m_discreteOverlaysMapIndices  = new HashMap<>( );         
    private final HashMap<String,Integer> m_colorOverlaysMapIndices     = new HashMap<>( );         
    /**
     * Creates new form ImportedCSVDataColorMapOverlaySelectionFrame
     * @param fileNameLoaded
     * @param csvData
     * @param columnNames
     * @param columnTypes
     * @param model
     */
    public ImportedCSVDataColorMapOverlaySelectionFrame( String fileNameLoaded, 
                                                         Object[][] csvData, 
                                                         String[] columnNames, 
                                                         String[] columnTypes,
                                                         GlobalModel model ) 
    {
        
        initComponents( );
        
        m_csvFileLoadedjLabel.setText( fileNameLoaded );
        
        m_discreteColorLabelsjComboBox.removeAllItems( );
        m_discreteLabeljComboBox.removeAllItems( );
        m_numericalOverlayTypeSelectionjComboBox.removeAllItems( );
       
        m_csvData     = csvData;
        m_columnNames = columnNames;
        m_columnTypes = columnTypes;
        m_globalModel = model;
        
        for ( int i = 1; i < m_columnTypes.length; i++ )
        {
            if ( m_columnTypes[i].compareTo( "float" ) == 0 )
            {
                m_numericalOverlayTypeSelectionjComboBox.addItem( m_columnNames[i] );
                m_numericalOverlaysMapIndices.put( m_columnNames[i], i );
            }
            
            if ( m_columnTypes[i].compareTo( "string" ) == 0 )
            {
                m_discreteLabeljComboBox.addItem( m_columnNames[i] );
                m_discreteOverlaysMapIndices.put( m_columnNames[i], i );
            }
            
            if ( m_columnTypes[i].compareTo( "color" ) == 0 )
            {
                m_discreteColorLabelsjComboBox.addItem( m_columnNames[i] );
                m_colorOverlaysMapIndices.put( m_columnNames[i], i );
            } 
        }
        
        setVisible( true );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        dataGroupSelectionButtonGroup = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        m_numericalOverlayTypeSelectionjComboBox = new javax.swing.JComboBox<>();
        m_displayNumericValuesjRadioButton = new javax.swing.JRadioButton();
        m_displayDiscreteLabelValuesjRadioButton = new javax.swing.JRadioButton();
        m_discreteLabeljComboBox = new javax.swing.JComboBox<>();
        m_displaySelectedOverlayTypejButton = new javax.swing.JButton();
        m_displayDirectColorValuesjRadioButton = new javax.swing.JRadioButton();
        m_discreteColorLabelsjComboBox = new javax.swing.JComboBox<>();
        jLabel1 = new javax.swing.JLabel();
        m_csvFileLoadedjLabel = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        m_transparencyjTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        m_quitDialogjButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Display overlay type and properties selection"));

        m_numericalOverlayTypeSelectionjComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        dataGroupSelectionButtonGroup.add(m_displayNumericValuesjRadioButton);
        m_displayNumericValuesjRadioButton.setSelected(true);
        m_displayNumericValuesjRadioButton.setText("Numeric values");

        dataGroupSelectionButtonGroup.add(m_displayDiscreteLabelValuesjRadioButton);
        m_displayDiscreteLabelValuesjRadioButton.setText("Discrete label values");

        m_discreteLabeljComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        m_displaySelectedOverlayTypejButton.setText("Display selected  overlay type");
        m_displaySelectedOverlayTypejButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_displaySelectedOverlayTypejButtonActionPerformed(evt);
            }
        });

        dataGroupSelectionButtonGroup.add(m_displayDirectColorValuesjRadioButton);
        m_displayDirectColorValuesjRadioButton.setText("Discrete color values");

        m_discreteColorLabelsjComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel1.setText("Loaded file: ");

        m_csvFileLoadedjLabel.setText("jLabel2");

        jLabel2.setText("Transparency");

        m_transparencyjTextField.setText("0.7");

        jLabel3.setText("[0,1]");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(26, 26, 26)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(m_displayDiscreteLabelValuesjRadioButton)
                        .addGap(18, 18, 18)
                        .addComponent(m_discreteLabeljComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 198, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(m_displayDirectColorValuesjRadioButton)
                        .addGap(18, 18, 18)
                        .addComponent(m_discreteColorLabelsjComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 198, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(41, 41, 41)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_transparencyjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(26, 26, 26)
                        .addComponent(jLabel3))
                    .addComponent(m_displaySelectedOverlayTypejButton)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_displayNumericValuesjRadioButton)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(8, 8, 8)
                                .addComponent(jLabel1)))
                        .addGap(44, 44, 44)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_csvFileLoadedjLabel)
                            .addComponent(m_numericalOverlayTypeSelectionjComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 198, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(260, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(m_csvFileLoadedjLabel))
                .addGap(25, 25, 25)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_numericalOverlayTypeSelectionjComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_displayNumericValuesjRadioButton))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_displayDiscreteLabelValuesjRadioButton)
                    .addComponent(m_discreteLabeljComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_displayDirectColorValuesjRadioButton)
                    .addComponent(m_discreteColorLabelsjComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(m_transparencyjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(m_displaySelectedOverlayTypejButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_quitDialogjButton.setText("Quit");
        m_quitDialogjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_quitDialogjButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(m_quitDialogjButton, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(389, 389, 389))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(23, Short.MAX_VALUE)
                .addComponent(m_quitDialogjButton)
                .addGap(21, 21, 21))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_displaySelectedOverlayTypejButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_displaySelectedOverlayTypejButtonActionPerformed
        
        if ( m_displayNumericValuesjRadioButton.isSelected( ) == true )
        {
            String selectedDataString = m_numericalOverlayTypeSelectionjComboBox.getItemAt( m_numericalOverlayTypeSelectionjComboBox.getSelectedIndex( ) );
            int selectedDataColumnNumber = m_numericalOverlaysMapIndices.get( selectedDataString );
            HashMap<String, Double> csvFileValuesHashMap = new HashMap<>( );
            for( int i = 0; i < m_csvData.length; i++ )
            {
                String dummy = (String) m_csvData[i][selectedDataColumnNumber];
                String key = "" + m_csvData[i][0];
                Double myDouble = new Double( dummy );
                csvFileValuesHashMap.put( key, myDouble );
            }
            
            m_globalModel.mapExternalCSVFileNumericalValues( csvFileValuesHashMap );
            
        }
        
        if ( m_displayDiscreteLabelValuesjRadioButton.isSelected( ) == true )
        {
            String selectedDataString = m_discreteLabeljComboBox.getItemAt( this.m_discreteLabeljComboBox.getSelectedIndex( ) );
            int selectedDataColumnNumber = m_discreteOverlaysMapIndices.get( selectedDataString );
            HashMap<String, Double> uniqueLabelsHashMap = new HashMap<>( );
            int cntr = 0;
            for( int i = 0; i < m_csvData.length; i++ )
            {
                String dummy = (String) m_csvData[i][selectedDataColumnNumber];
                if ( uniqueLabelsHashMap.get( dummy ) == null )
                {
                    uniqueLabelsHashMap.put( dummy, new Double( cntr ) );
                    cntr++;
                }
            }
             
            HashMap<String, Double> csvFileLabelAsDoubleValuesHashMap = new HashMap<>( );
            for( int i = 0; i < m_csvData.length; i++ )
            {
                String dummy = (String) m_csvData[i][selectedDataColumnNumber];
                String key = "" + m_csvData[i][0];
                
                Double myLabel = uniqueLabelsHashMap.get( dummy );
                // System.out.println( "" + myLabel );
                csvFileLabelAsDoubleValuesHashMap.put( key, myLabel );
            }
            
            m_globalModel.mapExternalCSVFileNumericalValues( csvFileLabelAsDoubleValuesHashMap );  
        }   
        
        if ( this.m_displayDirectColorValuesjRadioButton.isSelected( ) == true )
        {
            String selectedDataString = m_discreteColorLabelsjComboBox.getItemAt( m_discreteColorLabelsjComboBox.getSelectedIndex( ) );
            int selectedDataColumnNumber = m_colorOverlaysMapIndices.get( selectedDataString );
            HashMap<String, Color> csvFileColorValuesHashMap = new HashMap<>( );
            
            for( int i = 0; i < m_csvData.length; i++ )
            {
                String dummy = (String) m_csvData[i][selectedDataColumnNumber]; // is color as string
                Color  color = null;
                String key = "" + m_csvData[i][0];
                switch ( dummy.toUpperCase( ) )
                {
                    case "RED"      : color = Color.RED;        break;
                    case "BLUE"     : color = Color.BLUE;       break;
                    case "YELLOW"   : color = Color.YELLOW;     break;
                    case "MAGENTA"  : color = Color.MAGENTA;    break;
                    case "CYAN"     : color = Color.CYAN;       break;
                    case "BLACK"    : color = Color.BLACK;      break;
                    case "WHITE"    : color = Color.WHITE;      break;
                    case "GREEN"    : color = Color.GREEN;      break;
                    case "ORANGE"   : color = Color.ORANGE;     break;
                    case "PINK"     : color = Color.PINK;       break;
                    case "DARKRED"      : color = Color.RED.darker( );     break;
                    case "DARKBLUE"     : color = Color.BLUE.darker( );    break;
                    case "DARKYELLOW"   : color = Color.YELLOW.darker( );  break;
                    case "DARKMAGENTA"  : color = Color.MAGENTA.darker( ); break;
                    case "DARKCYAN"     : color = Color.CYAN.darker( );    break;
                    case "DARKGREEN"    : color = Color.GREEN.darker( );   break;
                    case "DARKORANGE"   : color = Color.ORANGE.darker( );  break;
                    case "DARKPINK"     : color = Color.PINK.darker( );    break;
                    case "BRIGHTRED"      : color = Color.RED.brighter();     break;
                    case "BRIGHTBLUE"     : color = Color.BLUE.darker( );    break;
                    case "BRIGHTYELLOW"   : color = Color.YELLOW.darker( );  break;
                    case "BRIGHTMAGENTA"  : color = Color.MAGENTA.darker( ); break;
                    case "BRIGHTCYAN"     : color = Color.CYAN.darker( );    break;
                    case "BRIGHTGREEN"    : color = Color.GREEN.darker( );   break;
                    case "BRIGHTORANGE"   : color = Color.ORANGE.darker( );  break;
                    case "BRIGHTPINK"     : color = Color.PINK.darker( );    break;
                    default: color = null; // in this case the color overlay of the voxel won't be drawn at all!
                }
                
                float transparenacy = new Float( m_transparencyjTextField.getText( ) ).floatValue();
                if ( color == null )
                {
                    csvFileColorValuesHashMap.put( key, null );
                }
                else
                {
                    csvFileColorValuesHashMap.put( key, new Color( color.getRed( )/255f, color.getGreen( )/255f, color.getBlue( )/255f, transparenacy ) );
                }
                
            } 
            
            m_globalModel.mapExternalCSVFileColorValues( csvFileColorValuesHashMap ); 
        }
    }//GEN-LAST:event_m_displaySelectedOverlayTypejButtonActionPerformed

    private void m_quitDialogjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_quitDialogjButtonActionPerformed
        dispose( );
    }//GEN-LAST:event_m_quitDialogjButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main( String args[] ) 
    {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ImportedCSVDataColorMapOverlaySelectionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ImportedCSVDataColorMapOverlaySelectionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ImportedCSVDataColorMapOverlaySelectionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ImportedCSVDataColorMapOverlaySelectionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ImportedCSVDataColorMapOverlaySelectionFrame( null, null, null, null, null ).setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup dataGroupSelectionButtonGroup;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel m_csvFileLoadedjLabel;
    private javax.swing.JComboBox<String> m_discreteColorLabelsjComboBox;
    private javax.swing.JComboBox<String> m_discreteLabeljComboBox;
    private javax.swing.JRadioButton m_displayDirectColorValuesjRadioButton;
    private javax.swing.JRadioButton m_displayDiscreteLabelValuesjRadioButton;
    private javax.swing.JRadioButton m_displayNumericValuesjRadioButton;
    private javax.swing.JButton m_displaySelectedOverlayTypejButton;
    private javax.swing.JComboBox<String> m_numericalOverlayTypeSelectionjComboBox;
    private javax.swing.JButton m_quitDialogjButton;
    private javax.swing.JTextField m_transparencyjTextField;
    // End of variables declaration//GEN-END:variables
}
