/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.colormap;

import org.spectrim.spectra.Spectra;

/**
 *
 * @author nunopbarros
 */
public abstract class MapFunction {

    private String name;
    Spectra spectra;
    //Selectable Ranges for calculation
    private int nrRanges;
    //Range in TD or FD
    private int rangeDomain;
    public final static int FD_RANGE = 0;
    public final static int TD_RANGE = 1;

    public MapFunction(String name, Spectra spectra) {
        this.name = name;
        this.spectra = spectra;
        this.nrRanges = 0;
        this.rangeDomain = 0;
    }

    /**
     *
     * @param name function name
     * @param spectra spectra object
     * @param nrRanges nr of ranges needed (0,1,2)
     * @param rangeDomain ranges in TD or FD
     */
    public MapFunction(String name, Spectra spectra, int nrRanges, int rangeDomain) {
        this.name = name;
        this.spectra = spectra;
        this.nrRanges = nrRanges;
        this.rangeDomain = rangeDomain;
    }

    public int getNrRanges() {
        return nrRanges;
    }

    public int getRangeDomain() {
        return rangeDomain;
    }

    public String getName() {
        return name;
    }

    public abstract float function(String ID, double... limits);
}
