/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.decisionforest.multithreading;

import java.util.ArrayList;
import org.spectrim.decisionforest.data.DataSet;
import org.spectrim.decisionforest.results.ResultSet;
import org.spectrim.decisionforest.structure.Tree;

/**
 *
 * @author nunopbarros
 */
public class TreeTester implements Runnable {
    
    private final Tree tree;
    private final DataSet testdata;
    private final double minreliab;

    public TreeTester(Tree tree, DataSet testdata, double minreliab) {
        this.tree = tree;
        this.testdata = testdata.clone();
        this.minreliab = minreliab;

    }

    @Override
    public void run() {
        final ArrayList<Integer> dataelem = new ArrayList<>();
        for (int i = 0; i < testdata.size(); i++) {
            dataelem.add(i);
        }
        ResultSet results = new ResultSet();
        tree.root.setDataSet(testdata);
        tree.root.setDataElems((ArrayList<Integer>) dataelem.clone(),false);
        if (tree.root.getLevel() <= tree.maxdepth) {
            tree.root.test(results, minreliab);
//            tree.root.clearDataElems();
            if (tree.root.hasChildren()) {
                for (int i = 0; i < tree.root.getNrChildren(); i++) {
                    tree.test(tree.root.getChild(i), results, minreliab);
                }
            }
        }
//        tree.removeData();
        tree.reportResults(results);
    }
    
}
