/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.decisionforest.multithreading;

import java.util.ArrayList;
import org.spectrim.decisionforest.data.DataSet;
import org.spectrim.decisionforest.results.ResultSet;
import org.spectrim.decisionforest.structure.Tree;

/**
 *
 * @author nunopbarros
 */
public class TreeTrainer implements Runnable {

    private final DataSet traindata;
    private final int nriter;
    private final int nrsamples;
    private final int baggingsize;
    private final ArrayList<ResultSet> resultsOOB;
    private final Tree tree;
    private final int weaklearner;
    private final boolean optimizeWeights;

    public TreeTrainer(Tree tree, DataSet traindata, int nriter, int nrsamples, int baggingsize, ArrayList<ResultSet> resultsOOB, int weaklearner, boolean optimizeWeights) {
        this.tree = tree;
        this.traindata = traindata.clone();
        this.nriter = nriter;
        this.nrsamples = nrsamples;
        this.baggingsize = baggingsize;
        this.resultsOOB = resultsOOB;
        this.weaklearner = weaklearner;
        this.optimizeWeights = optimizeWeights;
    }

    @Override
    public void run() {
//        Bootstrapping
        ArrayList<Integer> dataelem = traindata.bootstrap(baggingsize);
        tree.root.setDataSet(traindata);
        tree.root.setDataElems((ArrayList<Integer>) dataelem.clone(),true);
        tree.trainTree(nriter, nrsamples,weaklearner,optimizeWeights);
        
        
//        if (tree.root.getLevel() <= tree.maxdepth) {
//            tree.root.setDataSet(traindata);
//            tree.root.train(nriter, nrsamples, tree.minsize);
//            tree.root.clearDataElems();
////            if (tree.root.hasChildren()) {
////                for (int i = 0; i < tree.root.getNrChildren(); i++) {
////                    if (tree.root.getChild(i).hasDataElems()) {
////                        tree.train(tree.root.getChild(i), traindata, nriter, nrsamples);
////                    }
////                }
////            }
//        }
        tree.removeData();
//        tree.test(traindata.getOutOfBagElems(), traindata, resultsOOB.get(0), 0);
//        for (int n = 1; n <= traindata.nrvar; n++) {
//            DataSet dataaux = traindata.clone();
//            dataaux.permutateVariable(n-1);
//            tree.test(traindata.getOutOfBagElems(), dataaux, resultsOOB.get(n), 0);
//        }
        tree.informTrainedTree();
    }
}
