/*
 * File: $Id: PolygonEventCaster.java,v 1.1.1.1 2006/04/19 09:38:47 hans Exp $
 * History
 * Date: 31.01.2003  Authors: Martin Buerki / Hans Slotboom  
 *
 * Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

package org.spectrim.imagegraphicobjects;

import java.util.Vector;



public class PolygonEventCaster implements PolygonListener 
{

    protected Vector<PolygonListener> m_listener = new Vector<PolygonListener>( );

    public void add( PolygonListener l )
    {
        if ( !m_listener.contains( l ) )
        { 
            m_listener.addElement( l ); 
        }
    }

    public void remove( PolygonListener l ) 
    {
        m_listener.removeElement( l );
    }

    public void polygonChanged( PolygonEvent e ) 
    {
        for ( int i = 0; i < m_listener.size( ); i++ )
        {
            m_listener.elementAt( i ).polygonChanged( e );
        }
    }

    public void polygonSelect( PolygonEvent e ) 
    {
        for ( int i = 0; i < m_listener.size(); i++ )
        {
            m_listener.elementAt( i ).polygonSelect( e );
        }
    }

    public void polygonDrag( PolygonEvent e ) 
    {
        for ( int i = 0; i < m_listener.size( ); i++ )
        {
            m_listener.elementAt( i ).polygonDrag( e );
        }
    }

    public void polygonRemoved( PolygonEvent e ) 
    {
        for ( int i = 0; i < m_listener.size( ); i++ )
        {
            m_listener.elementAt( i ).polygonRemoved( e );
        }
    }
}
