/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.spectrim.imageprocessing;

import org.spectrim.imagegraphicobjects.RegioPolygon;
import java.util.ArrayList;
import java.util.LinkedList;
import javax.swing.JFrame;

/**
 *
 * This class removes pixels within a region polygon from selected image
 * segments.
 *
 * @author slotboom
 */
public class ImageOverlayPixelRemover
{

    /**
     * Constructs an object of ImageOverlayPixelRemover.
     * @param parent
     * @param imageSegmentsOverlayList
     * @param selectedPolygon
     * @param selectedTissueTypes
     * @param currentImageNumber
     * @param imageWidth
     * @param imageHeight
     * @param numberOfImages
     */
    public ImageOverlayPixelRemover( JFrame parent, 
                                     ArrayList< LinkedList<boolean[][]> > imageSegmentsOverlayList,
                                     RegioPolygon selectedPolygon, 
                                     int[] selectedTissueTypes,
                                     int currentImageNumber,
                                     int imageWidth, int imageHeight, 
                                     int numberOfImages )
    {

        for ( int tissueTypeNumber = 0;  tissueTypeNumber < selectedTissueTypes.length ; tissueTypeNumber++ )
        {
            // set counter to zero for each image segment type..
            boolean[][] currentBooleanOverlay = imageSegmentsOverlayList.get( currentImageNumber ).get( selectedTissueTypes[tissueTypeNumber] );

            for ( int j = 0; j < imageHeight; j++ )
            {
                for ( int k = 0; k < imageWidth; k++ )
                {
                    if ( selectedPolygon.contains( k, j ) == true )
                    {
                        currentBooleanOverlay[k][j] = false;
                    }
                }
            }

        }
    }
}
