/*
 * File: $Id: ImageParametersWithinARegioPolygon.java,v 1.1.1.1 2008/10/10 09:38:47 hans Exp $
 * History
 * Date: 10.10.2008 Hans Slotboom  Changes:
 *
 * Copyright (C) 2008 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

package org.spectrim.imageprocessing;

/**
 *
 * @author  hans
 */
public class ImageParametersWithinARegioPolygon 
{
    
    /** 
     * Creates a new instance of ImageParametersWithinARegioPolygon 
     */
    public ImageParametersWithinARegioPolygon( ) 
    {
        
    }
    
    /**
     * Sets the name of the ROI to which this belongs
     */
    public void setROIName( String name )
    {
        m_nameOfROI = name;
    }

    /**
     * Returss the name of the ROI to which this belongs
     */
    public String getROIName( )
    {
        return m_nameOfROI;
    }

    /**
     * Sets the  number of pixels within ROI 
     */
    public void setNumberOfPixels( int number )
    {
        m_numberOfPixelsWithinROI = number;
    }

    /**
     * Returns the  number of pixels within ROI
     */
    public int getNumberOfPixels( )
    {
        return m_numberOfPixelsWithinROI;
    }

    /**
     * Sets the volume of the ROI 
     */
    public void setROIVolume( float volume )
    {
        m_ROIVolume = volume;
    }

    /**
     * Returns the volume of the ROI
     */
    public float getROIVolume( )
    {
        return m_ROIVolume;
    }    
    
    /**
     * Sets the mean pixel value of the ROI 
     */
    public void setMeanPixelValue( float mean )
    {
        m_meanOfPixelValues = mean;
    }

    /**
     * Sets the mean pixel value of the ROI 
     */
    public void setMeanRawPixelValue( float mean_raw )
    {
        m_meanRawOfPixelValues = mean_raw;
    }
    
    
    /**
     * Returns the mean pixel value of the ROI 
     */
    public float getMeanPixelValue( )
    {
        return m_meanOfPixelValues;
    }    
    
    /**
     * Returns the mean raw (non scaled pixels) pixel value of the ROI 
     */
    public float getMeanRawPixelValue( )
    {
        return m_meanRawOfPixelValues;
    }   
    
    
    /**
     * Sets the standard deviation pixel value of the ROI 
     */
    public void setStandardDeviationOfPixelValues( float stdev )
    {
        m_standardDeviationOfPixelValues = stdev;
    }

    /**
     * Sets the standard deviation pixel value of the ROI 
     */
    public void setStandardDeviationRawOfPixelValues( float stdev_raw )
    {
        m_standardDeviationRawOfPixelValues = stdev_raw;
    }   
    
    /**
     * Returns the standard deviation pixel value of the ROI 
     */
    public float getStandardDeviationOfPixelValues( )
    {
        return m_standardDeviationOfPixelValues;
    }    
    
    /**
     * Returns the standard deviation pixel value of the ROI 
     */
    public float getStandardDeviationRawOfPixelValues( )
    {
        return m_standardDeviationRawOfPixelValues;
    }
    
    /**
     * Equals ( pixelMax - pixelMin ) / 2
     * @return
     */
    public float getCenterPixelRawRangeValueOfRegion( )
    {
        return m_pixelRawRangeCenterValue;
    }
     
    /**
     *  Equals ( pixelMax - pixelMin )
     * @return
     */
    public float getMinimumMaximumRawRangeOfRegion( )
    {
         return m_pixelMinimumMaximumRawRangeOfRegion;
    }
    
    /**
     * Equals ( pixelMax - pixelMin ) / 2
     * @return
     */
    public void setCenterPixelRawRangeValueOfRegion( float centerValue )
    {
        m_pixelRawRangeCenterValue = centerValue;
    }
     
    /**
     *  Equals ( pixelMax - pixelMin )
     * @return
     */
    public void setMinimumMaximumRawRangeOfRegion( float minimumMaximumValue )
    {
         m_pixelMinimumMaximumRawRangeOfRegion = minimumMaximumValue;
    }
    
    
    // Attributes
    private String m_nameOfROI;
    private int m_numberOfPixelsWithinROI;
    private float m_ROIVolume;
    
    private float m_meanOfPixelValues;
    private float m_meanRawOfPixelValues;
    
    private float m_standardDeviationOfPixelValues;
    private float m_standardDeviationRawOfPixelValues;
    
    private float m_pixelRawRangeCenterValue;
    private float m_pixelMinimumMaximumRawRangeOfRegion;
}
