/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.imageprocessing;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Vector;
import javax.swing.AbstractListModel;
import javax.swing.DefaultListModel;
import javax.swing.ListModel;
import org.spectrim.main.MetaboliteFeatures;
import org.spectrim.model.GlobalModel;
import org.spectrim.tdfdfit.TDFDFitResultsStore;

/**
 *
 * @author johan
 */
public class QMRSIOutlierRemovalControlFrame extends javax.swing.JFrame {

    /**
     * Creates new form QMRSIOutlierRemovalControl
     * @param model
     */
    public QMRSIOutlierRemovalControlFrame( GlobalModel model,
                                            int selectedMetabNumber,
                                            int selectedFeature ) 
    {
        initComponents( );
        // For the time being it only works with TDFDFit data 
        TDFDFitResultsStore store = model.getTDFDFitStore( );
        String[] metabNames = store.getMetabolitesNames( );
        DefaultListModel<String> listmodel = (DefaultListModel<String>) m_metaboliteSelectionList.getModel( );
        
        for ( int i = 0; i < metabNames.length; i++ )
        {
            listmodel.add( i, metabNames[i] );
        }
        setVisible( true );
        m_model = model;
        m_metaboliteSelectionList.setSelectedIndex(selectedMetabNumber);
        
        switch ( selectedFeature )
        {
            case MetaboliteFeatures.AREA:       this.m_peakAreaCheckBox.setSelected( true );
                                                this.m_OffsetCheckBox.setSelected( false );
                                                this.m_phaseCheckBox.setSelected( false );
                                                this.m_LorentzianWidthCheckBox.setSelected( false );
                                                this.m_gaussianCheckBox.setSelected( false );
                                                break;
                     
            case MetaboliteFeatures.FRQSHIFT:   this.m_peakAreaCheckBox.setSelected( false );
                                                this.m_OffsetCheckBox.setSelected( true );
                                                this.m_phaseCheckBox.setSelected( false );
                                                this.m_LorentzianWidthCheckBox.setSelected( false );
                                                this.m_gaussianCheckBox.setSelected( false );
                                                break;
                     
            case MetaboliteFeatures.DAMPING:    this.m_peakAreaCheckBox.setSelected( false );
                                                this.m_OffsetCheckBox.setSelected( false );
                                                this.m_phaseCheckBox.setSelected( false );
                                                this.m_LorentzianWidthCheckBox.setSelected( true );
                                                this.m_gaussianCheckBox.setSelected( false );
                                                break;
                     
            case MetaboliteFeatures.PHASE:      this.m_peakAreaCheckBox.setSelected( false );
                                                this.m_OffsetCheckBox.setSelected( false );
                                                this.m_phaseCheckBox.setSelected( true );
                                                this.m_LorentzianWidthCheckBox.setSelected( false );
                                                this.m_gaussianCheckBox.setSelected( false );
                                                break;
                     
            case MetaboliteFeatures.GDAMPING:   this.m_peakAreaCheckBox.setSelected( false );
                                                this.m_OffsetCheckBox.setSelected( false );
                                                this.m_phaseCheckBox.setSelected( false );
                                                this.m_LorentzianWidthCheckBox.setSelected( false );
                                                this.m_gaussianCheckBox.setSelected( true );
                                                break;
            default: break;
        }
        pack( );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jRadioButton1 = new javax.swing.JRadioButton();
        jPanel5 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        m_metaboliteSelectionList = new javax.swing.JList<>();
        jPanel4 = new javax.swing.JPanel();
        m_peakAreaCheckBox = new javax.swing.JCheckBox();
        m_OffsetCheckBox = new javax.swing.JCheckBox();
        m_LorentzianWidthCheckBox = new javax.swing.JCheckBox();
        m_phaseCheckBox = new javax.swing.JCheckBox();
        m_gaussianCheckBox = new javax.swing.JCheckBox();
        jPanel6 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        m_minimumInterQuartileMultiplicationFactorTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        m_maximumInterQuartileMultiplicationFactorTextField = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        m_cancelButton = new javax.swing.JButton();
        m_applyAndQuitButton = new javax.swing.JButton();
        m_undoOutlierFilterButton = new javax.swing.JButton();
        m_previewButton = new javax.swing.JButton();

        jRadioButton1.setText("jRadioButton1");

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Set parameter type(s) on which outlier filtering should be performed");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Select metabolite"));

        m_metaboliteSelectionList.setModel(new DefaultListModel<String>());
        jScrollPane1.setViewportView(m_metaboliteSelectionList);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Parameter group"));

        m_peakAreaCheckBox.setSelected(true);
        m_peakAreaCheckBox.setText(" Peak area");

        m_OffsetCheckBox.setText("Offset");

        m_LorentzianWidthCheckBox.setText("Lorentzian damping");

        m_phaseCheckBox.setText("Phase");

        m_gaussianCheckBox.setText("Gaussian width");

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_peakAreaCheckBox)
                .addGap(45, 45, 45)
                .addComponent(m_OffsetCheckBox)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 50, Short.MAX_VALUE)
                .addComponent(m_LorentzianWidthCheckBox)
                .addGap(55, 55, 55)
                .addComponent(m_phaseCheckBox)
                .addGap(52, 52, 52)
                .addComponent(m_gaussianCheckBox)
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_peakAreaCheckBox)
                    .addComponent(m_OffsetCheckBox)
                    .addComponent(m_LorentzianWidthCheckBox)
                    .addComponent(m_phaseCheckBox)
                    .addComponent(m_gaussianCheckBox))
                .addGap(20, 20, 20))
        );

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("Percentile boundaries"));

        jLabel1.setText("Minimum inter quartile range factor");

        m_minimumInterQuartileMultiplicationFactorTextField.setText("-1.5");

        jLabel2.setText("Maximum inter quartile range factor");

        m_maximumInterQuartileMultiplicationFactorTextField.setText("1.5");
        m_maximumInterQuartileMultiplicationFactorTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_maximumInterQuartileMultiplicationFactorTextFieldActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(m_minimumInterQuartileMultiplicationFactorTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel2)
                .addGap(18, 18, 18)
                .addComponent(m_maximumInterQuartileMultiplicationFactorTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGap(39, 39, 39)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(m_minimumInterQuartileMultiplicationFactorTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(m_maximumInterQuartileMultiplicationFactorTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(52, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        m_cancelButton.setText("Cancel");

        m_applyAndQuitButton.setText("Apply");

        m_undoOutlierFilterButton.setText("Undo");
        m_undoOutlierFilterButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_undoOutlierFilterButtonActionPerformed(evt);
            }
        });

        m_previewButton.setText("Preview");
        m_previewButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_previewButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_cancelButton)
                .addGap(118, 118, 118)
                .addComponent(m_undoOutlierFilterButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(m_previewButton)
                .addGap(125, 125, 125)
                .addComponent(m_applyAndQuitButton)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(38, 38, 38)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_cancelButton)
                    .addComponent(m_applyAndQuitButton)
                    .addComponent(m_undoOutlierFilterButton)
                    .addComponent(m_previewButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, Short.MAX_VALUE)
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_previewButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_previewButtonActionPerformed
        notifyActionListeners( this, PREVIEW_OUTLIER_FILTERING_ID, PREVIEW_OUTLIER_FILTERING_CMD );
    }//GEN-LAST:event_m_previewButtonActionPerformed

    private void m_maximumInterQuartileMultiplicationFactorTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_maximumInterQuartileMultiplicationFactorTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_maximumInterQuartileMultiplicationFactorTextFieldActionPerformed

    private void m_undoOutlierFilterButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_undoOutlierFilterButtonActionPerformed
        notifyActionListeners( this, UNDO_OUTLIER_FILTERING_ID, UNDO_OUTLIER_FILTERING_CMD );
    }//GEN-LAST:event_m_undoOutlierFilterButtonActionPerformed

    
    /**
     * Adds an ActionListener to the list of listeners.
     * @param listener
    */
    public void addActionListener( ActionListener listener )
    {
        m_actionListeners.add( listener );
    }
    
    /**
     * Notifies actionEvent to all registered listeners.
     */
    private void notifyActionListeners( Object obj, int eventType, String actionCommand ) 
    {
        Iterator it = m_actionListeners.iterator( );
        while ( it.hasNext( ) ) 
        {
            ( (ActionListener) it.next( ) ).actionPerformed( new ActionEvent( obj, eventType, actionCommand ) );
        }
    }
    
    public float getMinimumInterQuartileFactor( )
    {
        return new Float( m_minimumInterQuartileMultiplicationFactorTextField.getText( ) );
    }

    public float getMaximumInterQuartileFactor( )
    {
        return new Float( m_maximumInterQuartileMultiplicationFactorTextField.getText( ) );
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) 
    {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(QMRSIOutlierRemovalControlFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(QMRSIOutlierRemovalControlFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(QMRSIOutlierRemovalControlFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(QMRSIOutlierRemovalControlFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() 
        {
            @Override
            public void run( ) 
            {
                new QMRSIOutlierRemovalControlFrame( null, 0, 0 ).setVisible(true);
            }
        });
    }

    public int getSelectedMetaboliteNumber( ) 
    {
        return m_metaboliteSelectionList.getSelectedIndex( );
    }

    public int getSelectedFeatureNumber( ) 
    {
        
        int featureNummer = MetaboliteFeatures.AREA;        

       return featureNummer;
    }
    
    
    
    // Attributes
    private GlobalModel m_model;
    private Vector<ActionListener> m_actionListeners = new Vector<>( );
    
    public final static int CANCEL_OUTLIER_FILTERING_ID   = 0;
    public final static int APPLY_OUTLIER_FILTERING_ID    = 1;
    public final static int PREVIEW_OUTLIER_FILTERING_ID  = 2;
    public final static int UNDO_OUTLIER_FILTERING_ID     = 3;
    
    public final static String CANCEL_OUTLIER_FILTERING_CMD   = "Cancel outlier filtering.";
    public final static String APPLY_OUTLIER_FILTERING_CMD    = "Apply outlier filtering.";
    public final static String PREVIEW_OUTLIER_FILTERING_CMD  = "Preview outlier filtering.";
    public final static String UNDO_OUTLIER_FILTERING_CMD     = "Preview outlier filtering.";
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JCheckBox m_LorentzianWidthCheckBox;
    private javax.swing.JCheckBox m_OffsetCheckBox;
    private javax.swing.JButton m_applyAndQuitButton;
    private javax.swing.JButton m_cancelButton;
    private javax.swing.JCheckBox m_gaussianCheckBox;
    private javax.swing.JTextField m_maximumInterQuartileMultiplicationFactorTextField;
    private javax.swing.JList<String> m_metaboliteSelectionList;
    private javax.swing.JTextField m_minimumInterQuartileMultiplicationFactorTextField;
    private javax.swing.JCheckBox m_peakAreaCheckBox;
    private javax.swing.JCheckBox m_phaseCheckBox;
    private javax.swing.JButton m_previewButton;
    private javax.swing.JButton m_undoOutlierFilterButton;
    // End of variables declaration//GEN-END:variables


}
