/*
 * File: $Id: MemTools.java,v 1.1.1.1 2006/04/19 09:38:48 hans Exp $
 * History
 * Date: 30. November 2002, 16:32  Authors: Martin Buerki
 *
 * Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

package org.spectrim.lib;


public final class MemTools 
{

    public static byte[] mallocByte( int size )
    {
	if (size < 0) return null;
	else if ( 1*size >= Runtime.getRuntime( ).freeMemory( ) ) return null;
	else return new byte[size];
    }

    public static short[] mallocShort( int size ) 
    {
	if (size < 0) return null;
	else if ( 2 * size >= Runtime.getRuntime( ).freeMemory( ) ) return null;
	else return new short[size];
    }

    public static int[] mallocInt( int size ) 
    {
	if (size < 0) return null;
	else if ( 4 * size >= Runtime.getRuntime( ).freeMemory( ) ) return null;
	else return new int[size];
    }

    public static int[][] mallocInt2( int nRows, int nCols ) 
    {
	if (nRows<0 || nCols<0) return null;
	else if (4*nRows*nCols >= Runtime.getRuntime().freeMemory()) return null;
	else return new int[nRows][nCols];
    }

    public static long[] mallocLong( int size ) 
    {
	if ( size < 0 ) return null;
	else if ( 8*size >= Runtime.getRuntime( ).freeMemory( ) ) return null;
	else return new long[size];
    }

    public static float[] mallocFloat( int size ) 
    {
	if ( size < 0 ) return null;
	else if ( 4*size >= Runtime.getRuntime( ).freeMemory( ) ) return null;
	else return new float[size];
    }

    public static double[] mallocDouble( int size ) 
    {
	if (size < 0) return null;
	else if ( 8 * size >= Runtime.getRuntime( ).freeMemory( ) ) return null;
	else return new double[size];
    }
}
