/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.patientbrowser;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.TreeMap;

/**
 *
 * @author user
 */
public class Study {
    private String description;
    private String date;
    private String UID;
    private TreeMap<String,Series> series = new TreeMap<>();
    private HashMap<Integer,String> hashcode2UID = new HashMap<>();
    
    public Study(String description, String UID, String date){
        this.description = description;
        this.UID = UID;
        this.date = date;
    }
    
    public Collection<Series> getSeries(){
        return series.values();
    }
    
    /**
     * Attempt to sort the series by series number.
     * @return 
     */
    public Collection<Series> getSortedBySeriesNumberSeries(){
        return sortBySeriesNumberComparator( series, true ).values();
    }
    
    private static Map<String, Series> sortBySeriesNumberComparator(Map<String, Series> unsortMap, final boolean order)
    {

        List<Entry<String, Series>> list = new LinkedList<Entry<String, Series>>(unsortMap.entrySet());

        // Sorting the list based on values
        Collections.sort(list, new Comparator<Entry<String, Series>>()
        {
            @Override
            public int compare( Entry<String, Series> o1,
                                Entry<String, Series> o2)
            {
                if (order)
                {
                    return o1.getValue().getSeriesNr().compareTo(o2.getValue().getSeriesNr());
                }
                else
                {
                    return o2.getValue().getSeriesNr().compareTo(o1.getValue().getSeriesNr());
                }
            }
        });

        // Maintaining insertion order with the help of LinkedList
        Map<String, Series> sortedMap = new LinkedHashMap<String, Series>();
        for (Entry<String, Series> entry : list)
        {
            sortedMap.put(entry.getKey(), entry.getValue());
        }

        return sortedMap;
    }

    public static void printMap(Map<String, Series> map)
    {
        for (Entry<String, Series> entry : map.entrySet())
        {
            System.out.println("Key : " + entry.getKey() + " Value : "+ entry.getValue());
        }
    }
    
    public void addSeries(Series series){
        this.series.put(series.getUID(),series);
    }
    
    public void setSeriesHashcode(int code, Series series){
        this.hashcode2UID.put(code, series.getUID());
    }
    
    public Series getSeries(String seriesUID){
        return this.series.get(seriesUID);
    }
    
    public Series getSeries(int hashcode){
        return this.series.get(hashcode2UID.get(hashcode));
    }
    
    public boolean hasSeries(String seriesUID){
        return this.series.containsKey(seriesUID);
    }
    
    public boolean hasSeries(int hashcode){
        return this.series.containsKey(hashcode2UID.get(hashcode));
    }
    
    public String getDescription(){
        return description;
    }
    
    public String getUID(){
        return UID;
    }
    
    public String getDate(){
        return date;
    }
}
