/*
 * File: $Id: MRPatientSpectrumDatabaseGUIControl.java,v 1.1.1.1 2006/04/19 09:38:48 hans Exp $
 * History
 * Date: 02.02.2004, 21:13  Authors: Hans Slotboom
 *
 * Changes:
 *
 * Copyright (C) 2003 - 2004 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

/*
 * MRPatientSpectrumDatabaseGUIControl.java
 *
 * Created on February 2, 2004, 9:04 PM
 */

package org.spectrim.patientdatabase;

import java.awt.Dimension;
import java.awt.BorderLayout;


import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.BoxLayout;
import javax.swing.BorderFactory;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import javax.swing.Box;
import javax.swing.JButton;

import javax.swing.table.DefaultTableModel;

/**
 *
 * Control that offers a browser view on the database
 *
 * @author  hans
 */

public class DatabaseMiningGUIControl  extends JPanel implements ActionListener
{
    
    /** 
     * Creates a new instance of MRPatientSpectrumDatabaseGUIControl 
     */
    public DatabaseMiningGUIControl( ) 
    {
        m_containerPanel = new JPanel( );
        m_containerPanel.setLayout( new BorderLayout( ) );
        
        m_dataBaseItemListPanel = new JPanel( );
        
        m_dataBaseItemListPanel.setLayout( new BorderLayout( ) );
        
        Object[][] cellData = { { "", "", "", "" } };
        String[] columnNames = { "<HTML><B>ID</B></HTML>",
                                 "<HTML><B>Name</B></HTML>",
                                 "<HTML><B>DOB</B></HTML>",
                                 "<HTML><B>Date</B><HTML>"
                               };
        
        m_dataBaseItemTable = new JTable( );
        
        m_dataBaseTableModel = new DefaultTableModel( cellData, columnNames );
        
        m_dataBaseItemTable.setModel( m_dataBaseTableModel );
        m_dataBaseItemTable.updateUI( );
        
        // JTable does not provide a scroll list automatically so we have to 
        // add it ourselves.
        m_tableScrollPane = new JScrollPane( );
        m_tableScrollPane.setHorizontalScrollBarPolicy( JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS );
        m_tableScrollPane.setVerticalScrollBarPolicy( JScrollPane.VERTICAL_SCROLLBAR_ALWAYS );
        m_tableScrollPane.getViewport( ).setView( m_dataBaseItemTable );        
        m_tableScrollPane.setPreferredSize( new Dimension( 500, 300 ) );
        
        m_dataBaseItemListPanel.add( m_tableScrollPane, BorderLayout.CENTER );
        m_containerPanel.add( m_dataBaseItemListPanel, BorderLayout.NORTH );
        
        // Query panel that allows the user to query the local database
        m_queryDatabasePanel = new JPanel( );
        m_queryDatabasePanel.setLayout( new BoxLayout( m_queryDatabasePanel, BoxLayout.Y_AXIS ) );
        
        m_queryDatabasePanel.setBorder( BorderFactory.createTitledBorder( "Select all from database" ) );
        
        createFirstConditionPanel( );

        m_queryDatabasePanel.add( m_firstConnectPanel );
        
        createSecondConditionPanel( );
        
        m_queryDatabasePanel.add( m_secondConnectPanel );
        
        createThirdConditionPanel( );
        
        m_queryDatabasePanel.add( m_thirdConnectPanel );
        
        createFourthConditionPanel( );
        
        m_queryButtonPanel = new JPanel( );
        
        m_queryButtonPanel.setLayout( new BoxLayout( m_queryButtonPanel, BoxLayout.X_AXIS ) );
        m_queryButtonPanel.setBorder( BorderFactory.createEmptyBorder( 15, 5, 15, 5 ) );
        m_startQuery = new JButton( "Query!" );
        m_startQuery.addActionListener( this );
        m_resetQuery = new JButton( "Reset" );
        m_resetQuery.addActionListener( this );
        
        m_queryButtonPanel.add( Box.createHorizontalGlue( ) );
        m_queryButtonPanel.add( m_startQuery );
        
        m_queryButtonPanel.add( Box.createHorizontalGlue( ) );
        m_queryButtonPanel.add( m_resetQuery );
        
        m_queryButtonPanel.add( Box.createHorizontalGlue( ) );
        
        m_queryDatabasePanel.add( m_queryButtonPanel );
        
        m_containerPanel.add( m_queryDatabasePanel );
        add( m_containerPanel );
        
        
        setVisible( true );
    }
    
    /*
     * Creates the first condition Panel
     */
    private void createFirstConditionPanel( )
    {
        m_firstConditionPanel = new JPanel( );
        m_firstConditionPanel.setLayout( new BoxLayout( m_firstConditionPanel, BoxLayout.X_AXIS ) );
        m_firstConditionPanel.setBorder( BorderFactory.createEmptyBorder( 4, 4, 4, 4 ) );
        m_firstLabel = new JLabel( " WHERE " );
        
        m_firstTypeSelectionCombo = new JComboBox( );
        
        m_firstTypeSelectionCombo.setEditable( false );
        m_firstTypeSelectionCombo.setPreferredSize( new Dimension( 195, 20 ) );
        m_firstTypeSelectionCombo.setMinimumSize( new Dimension( 195, 20 ) );
        m_firstTypeSelectionCombo.setMaximumSize( new Dimension( 195, 20 ) );
        
        m_firstTypeSelectionCombo.setToolTipText( "Select first parameter to query for" );
       
        
        m_firstOperatorCombo = new JComboBox( );
        m_firstOperatorCombo.setEditable( false );
        m_firstOperatorCombo.setMinimumSize( new Dimension( 30, 20 ) );
        m_firstOperatorCombo.setMaximumSize( new Dimension( 30, 20 ) );
        
        m_firstOperatorCombo.addItem( " = " );
        m_firstOperatorCombo.addItem( " != " );
        m_firstOperatorCombo.addItem( " < " );
        m_firstOperatorCombo.addItem( " > " );
       
        m_firstValueCombo = new JComboBox( );
        m_firstValueCombo.setPreferredSize( new Dimension( 195, 20 ) );
        m_firstValueCombo.setMinimumSize( new Dimension( 195, 20 ) );
        m_firstValueCombo.setMaximumSize( new Dimension( 195, 20 ) );
        
        m_firstValueCombo.setToolTipText( "Enter value" );
        m_firstValueCombo.setEditable( true );
       
        m_firstConditionPanel.add( m_firstLabel );
        m_firstConditionPanel.add( Box.createHorizontalGlue( ) );
        m_firstConditionPanel.add( m_firstTypeSelectionCombo );
        m_firstConditionPanel.add( Box.createHorizontalGlue( ) );
        m_firstConditionPanel.add( m_firstOperatorCombo );
        m_firstConditionPanel.add( Box.createHorizontalGlue( ) );
        m_firstConditionPanel.add( m_firstValueCombo );
        
        m_queryDatabasePanel.add( m_firstConditionPanel );
        
        m_firstConnectPanel = new JPanel( );
        
        m_firstConnectPanel.setLayout( new BoxLayout(m_firstConnectPanel, BoxLayout.X_AXIS ) );
        m_firstConnectPanel.setBorder( BorderFactory.createEmptyBorder( 4, 4, 4, 4 ) );
        
        m_firstConnectExpressionsCombo = new JComboBox( );
        m_firstConnectExpressionsCombo.setMinimumSize( new Dimension( 30, 20 ) );
        m_firstConnectExpressionsCombo.setMaximumSize( new Dimension( 30, 20 ) );
        
        m_firstConnectExpressionsCombo.addItem( "AND" );
        m_firstConnectExpressionsCombo.addItem( "OR" );
        m_firstConnectExpressionsCombo.addItem( "NOR" );
        m_firstConnectExpressionsCombo.addItem( "XOR" );
        
        m_firstConnectPanel.add( Box.createHorizontalGlue( ) );
        m_firstConnectPanel.add( m_firstConnectExpressionsCombo );
        m_firstConnectPanel.add( Box.createHorizontalGlue( ) );     
    }
    
    /**
     * Creates the second condition Panel
     */
    private void createSecondConditionPanel( )
    {
        
        m_secondConditionPanel = new JPanel( );
        m_secondConditionPanel.setLayout( new BoxLayout( m_secondConditionPanel, BoxLayout.X_AXIS ) );
        m_secondConditionPanel.setBorder( BorderFactory.createEmptyBorder( 4, 4, 4, 4 ) );
        m_secondLabel = new JLabel( " WHERE " );
        
        m_secondTypeSelectionCombo = new JComboBox( );
        
        m_secondTypeSelectionCombo.setEditable( false );
        m_secondTypeSelectionCombo.setPreferredSize( new Dimension( 195, 20 ) );
        m_secondTypeSelectionCombo.setMinimumSize( new Dimension( 195, 20 ) );
        m_secondTypeSelectionCombo.setMaximumSize( new Dimension( 195, 20 ) );
        
        m_secondTypeSelectionCombo.setToolTipText( "Select first parameter to query for" );
       
        
        m_secondOperatorCombo = new JComboBox( );
        m_secondOperatorCombo.setEditable( false );
        m_secondOperatorCombo.setMinimumSize( new Dimension( 30, 20 ) );
        m_secondOperatorCombo.setMaximumSize( new Dimension( 30, 20 ) );
        
        m_secondOperatorCombo.addItem( " = " );
        m_secondOperatorCombo.addItem( " != " );
        m_secondOperatorCombo.addItem( " < " );
        m_secondOperatorCombo.addItem( " > " );
       
        m_secondValueCombo = new JComboBox( );
        m_secondValueCombo.setPreferredSize( new Dimension( 195, 20 ) );
        m_secondValueCombo.setMinimumSize( new Dimension( 195, 20 ) );
        m_secondValueCombo.setMaximumSize( new Dimension( 195, 20 ) );
        
        m_secondValueCombo.setToolTipText( "Enter value" );
        m_secondValueCombo.setEditable( true );
       
        m_secondConditionPanel.add( m_secondLabel );
        m_secondConditionPanel.add( Box.createHorizontalGlue( ) );
        m_secondConditionPanel.add( m_secondTypeSelectionCombo );
        m_secondConditionPanel.add( Box.createHorizontalGlue( ) );
        m_secondConditionPanel.add( m_secondOperatorCombo );
        m_secondConditionPanel.add( Box.createHorizontalGlue( ) );
        m_secondConditionPanel.add( m_secondValueCombo );
        
        m_queryDatabasePanel.add( m_secondConditionPanel );
        
        m_secondConnectPanel = new JPanel( );
        
        m_secondConnectPanel.setLayout( new BoxLayout( m_secondConnectPanel, BoxLayout.X_AXIS ) );
        m_secondConnectPanel.setBorder( BorderFactory.createEmptyBorder( 4, 4, 4, 4 ) );
        
        m_secondConnectExpressionsCombo = new JComboBox( );
        m_secondConnectExpressionsCombo.setMinimumSize( new Dimension( 30, 20 ) );
        m_secondConnectExpressionsCombo.setMaximumSize( new Dimension( 30, 20 ) );
        
        m_secondConnectExpressionsCombo.addItem( "AND" );
        m_secondConnectExpressionsCombo.addItem( "OR" );
        m_secondConnectExpressionsCombo.addItem( "NOR" );
        m_secondConnectExpressionsCombo.addItem( "XOR" );
        
        m_secondConnectPanel.add( Box.createHorizontalGlue( ) );
        m_secondConnectPanel.add( m_secondConnectExpressionsCombo );
        m_secondConnectPanel.add( Box.createHorizontalGlue( ) );     
    }
    
    /**
     * Creates the third condition Panel
     */
    private void createThirdConditionPanel( )
    {
        
        m_thirdConditionPanel = new JPanel( );
        m_thirdConditionPanel.setLayout( new BoxLayout( m_thirdConditionPanel, BoxLayout.X_AXIS ) );
        m_thirdConditionPanel.setBorder( BorderFactory.createEmptyBorder( 4, 4, 4, 4 ) );
        m_thirdLabel = new JLabel( " WHERE " );
        
        m_thirdTypeSelectionCombo = new JComboBox( );
        
        m_thirdTypeSelectionCombo.setEditable( false );
        m_thirdTypeSelectionCombo.setPreferredSize( new Dimension( 195, 20 ) );
        m_thirdTypeSelectionCombo.setMinimumSize( new Dimension( 195, 20 ) );
        m_thirdTypeSelectionCombo.setMaximumSize( new Dimension( 195, 20 ) );
        
        m_thirdTypeSelectionCombo.setToolTipText( "Select first parameter to query for" );
       
        
        m_thirdOperatorCombo = new JComboBox( );
        m_thirdOperatorCombo.setEditable( false );
        m_thirdOperatorCombo.setMinimumSize( new Dimension( 30, 20 ) );
        m_thirdOperatorCombo.setMaximumSize( new Dimension( 30, 20 ) );
        
        m_thirdOperatorCombo.addItem( " = " );
        m_thirdOperatorCombo.addItem( " != " );
        m_thirdOperatorCombo.addItem( " < " );
        m_thirdOperatorCombo.addItem( " > " );
       
        m_thirdValueCombo = new JComboBox( );
        m_thirdValueCombo.setPreferredSize( new Dimension( 195, 20 ) );
        m_thirdValueCombo.setMinimumSize( new Dimension( 195, 20 ) );
        m_thirdValueCombo.setMaximumSize( new Dimension( 195, 20 ) );
        
        m_thirdValueCombo.setToolTipText( "Enter value" );
        m_thirdValueCombo.setEditable( true );
       
        m_thirdConditionPanel.add( m_thirdLabel );
        m_thirdConditionPanel.add( Box.createHorizontalGlue( ) );
        m_thirdConditionPanel.add( m_thirdTypeSelectionCombo );
        m_thirdConditionPanel.add( Box.createHorizontalGlue( ) );
        m_thirdConditionPanel.add( m_thirdOperatorCombo );
        m_thirdConditionPanel.add( Box.createHorizontalGlue( ) );
        m_thirdConditionPanel.add( m_thirdValueCombo );
        
        m_queryDatabasePanel.add( m_thirdConditionPanel );
        
        m_thirdConnectPanel = new JPanel( );
        
        m_thirdConnectPanel.setLayout( new BoxLayout( m_thirdConnectPanel, BoxLayout.X_AXIS ) );
        m_thirdConnectPanel.setBorder( BorderFactory.createEmptyBorder( 4, 4, 4, 4 ) );
        
        m_thirdConnectExpressionsCombo = new JComboBox( );
        m_thirdConnectExpressionsCombo.setMinimumSize( new Dimension( 30, 20 ) );
        m_thirdConnectExpressionsCombo.setMaximumSize( new Dimension( 30, 20 ) );
        
        m_thirdConnectExpressionsCombo.addItem( "AND" );
        m_thirdConnectExpressionsCombo.addItem( "OR" );
        m_thirdConnectExpressionsCombo.addItem( "NOR" );
        m_thirdConnectExpressionsCombo.addItem( "XOR" );
        
        m_thirdConnectPanel.add( Box.createHorizontalGlue( ) );
        m_thirdConnectPanel.add( m_thirdConnectExpressionsCombo );
        m_thirdConnectPanel.add( Box.createHorizontalGlue( ) );     
    }
    
        /**
     * Creates the third condition Panel
     */
    private void createFourthConditionPanel( )
    {
        
        m_fourthConditionPanel = new JPanel( );
        m_fourthConditionPanel.setLayout( new BoxLayout( m_fourthConditionPanel, BoxLayout.X_AXIS ) );
        m_fourthConditionPanel.setBorder( BorderFactory.createEmptyBorder( 4, 4, 4, 4 ) );
        m_fourthLabel = new JLabel( " WHERE " );
        
        m_fourthTypeSelectionCombo = new JComboBox( );
        
        m_fourthTypeSelectionCombo.setEditable( false );
        m_fourthTypeSelectionCombo.setPreferredSize( new Dimension( 195, 20 ) );
        m_fourthTypeSelectionCombo.setMinimumSize( new Dimension( 195, 20 ) );
        m_fourthTypeSelectionCombo.setMaximumSize( new Dimension( 195, 20 ) );
        
        m_fourthTypeSelectionCombo.setToolTipText( "Select first parameter to query for" );
       
        
        m_fourthOperatorCombo = new JComboBox( );
        m_fourthOperatorCombo.setEditable( false );
        m_fourthOperatorCombo.setMinimumSize( new Dimension( 30, 20 ) );
        m_fourthOperatorCombo.setMaximumSize( new Dimension( 30, 20 ) );
        
        m_fourthOperatorCombo.addItem( " = " );
        m_fourthOperatorCombo.addItem( " != " );
        m_fourthOperatorCombo.addItem( " < " );
        m_fourthOperatorCombo.addItem( " > " );
       
        m_fourthValueCombo = new JComboBox( );
        m_fourthValueCombo.setPreferredSize( new Dimension( 195, 20 ) );
        m_fourthValueCombo.setMinimumSize( new Dimension( 195, 20 ) );
        m_fourthValueCombo.setMaximumSize( new Dimension( 195, 20 ) );
        
        m_fourthValueCombo.setToolTipText( "Enter value" );
        m_fourthValueCombo.setEditable( true );
       
        m_fourthConditionPanel.add( m_fourthLabel );
        m_fourthConditionPanel.add( Box.createHorizontalGlue( ) );
        m_fourthConditionPanel.add( m_fourthTypeSelectionCombo );
        m_fourthConditionPanel.add( Box.createHorizontalGlue( ) );
        m_fourthConditionPanel.add( m_fourthOperatorCombo );
        m_fourthConditionPanel.add( Box.createHorizontalGlue( ) );
        m_fourthConditionPanel.add( m_fourthValueCombo );
        
        m_queryDatabasePanel.add( m_fourthConditionPanel );
        
    }
    
    /**
     * Is called whenever a registered component raises an ActionEvent
     */ 
    public void actionPerformed( ActionEvent actionEvent ) 
    {
        
    }
    
    private JPanel m_containerPanel;
    
    // Members to handle the the JTable that contains the list of database entries 
    private JPanel m_dataBaseItemListPanel;
    private JTable m_dataBaseItemTable;
    private DefaultTableModel m_dataBaseTableModel;
    private JScrollPane m_tableScrollPane;
    
    // Members to enable the user to query the database
    private JPanel m_queryDatabasePanel;
    
    private JPanel m_firstConditionPanel;
    private JLabel m_firstLabel;
    private JComboBox m_firstTypeSelectionCombo;
    private JComboBox m_firstOperatorCombo;
    private JComboBox m_firstValueCombo;
    private JComboBox m_firstConnectExpressionsCombo;
    
    private  JPanel m_firstConnectPanel;
    
    private JPanel m_secondConditionPanel;
    private JLabel m_secondLabel;
    private JComboBox m_secondTypeSelectionCombo;
    private JComboBox m_secondOperatorCombo;
    private JComboBox m_secondValueCombo;
    private JComboBox m_secondConnectExpressionsCombo;
    
    private  JPanel m_secondConnectPanel;

    private JPanel m_thirdConditionPanel;
    private JLabel m_thirdLabel;
    private JComboBox m_thirdTypeSelectionCombo;
    private JComboBox m_thirdOperatorCombo;
    private JComboBox m_thirdValueCombo;
    private JComboBox m_thirdConnectExpressionsCombo;
    
    private  JPanel m_thirdConnectPanel;

    private JPanel m_fourthConditionPanel;
    private JLabel m_fourthLabel;
    private JComboBox m_fourthTypeSelectionCombo;
    private JComboBox m_fourthOperatorCombo;
    private JComboBox m_fourthValueCombo;

    private JPanel m_queryButtonPanel;
    
    private JButton m_startQuery;
    private JButton m_resetQuery;
    
    // For proper serialization
    private static final long serialVersionUID = 1482255591281213L;
    
}
