/*
 * MRSpectroscopyDatabaseQueryPanel.java
 *
 * Created on November 30, 2006, 10:06 PM
 */

package org.spectrim.patientdatabase;

import org.spectrim.dicom.DicomImageData;
import org.spectrim.dicom.DicomImageSeriesData;
// import SCANalyze.MRSpectroscopyDatabaseConnection.DataBaseConnectionDefinerFrame;
//import SCANalyze.MRSpectroscopyDatabaseConnection.DatabaseConnectionSettings;
//import SCANalyze.MRSpectroscopyDatabaseConnection.InstancesTableModel;
//import SCANalyze.MRSpectroscopyDatabaseConnection.MRSpectroscopyDatabaseConnection;
//import SCANalyze.MRSpectroscopyDatabaseConnection.SeriesTableModel;
//import SCANalyze.MRSpectroscopyDatabaseConnection.StudyTableModel;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Blob;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author  hans
 */
public class MRSpectroscopyDatabaseQueryPanel extends javax.swing.JPanel implements ActionListener, ListSelectionListener
{
    
    /** 
     * Creates new form MRSpectroscopyDatabaseQueryPanel 
     */
    public MRSpectroscopyDatabaseQueryPanel( JFrame parent ) 
    {
        m_parent = parent;
        initComponents( );
        
        m_examinationsQueryTable.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
        
        m_examinationsQueryTableListSelectionModel = m_examinationsQueryTable.getSelectionModel( );
        m_examinationsQueryTableListSelectionModel.addListSelectionListener( this );
        
        m_seriesQueryTable.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
        m_seriesQueryTableListSelectionModel = m_seriesQueryTable.getSelectionModel( );
        m_seriesQueryTableListSelectionModel.addListSelectionListener( this );
        
        m_seriesQueryTable.addMouseListener( new MouseAdapter( ) 
        {
            public void mousePressed(MouseEvent me) 
            {                
                showPopup(me);            
            }            
            public void mouseReleased(MouseEvent me) 
            {                
                showPopup(me);            
            }        
        });
        
        m_examinationsQueryTable.getColumnModel( ).getColumn( 0 ).setPreferredWidth( 140 );
        m_examinationsQueryTable.getColumnModel( ).getColumn( 1 ).setPreferredWidth( 30 );
        m_examinationsQueryTable.getColumnModel( ).getColumn( 2 ).setPreferredWidth( 30 );
        m_examinationsQueryTable.getColumnModel( ).getColumn( 3 ).setPreferredWidth( 60 );
        m_examinationsQueryTable.getColumnModel( ).getColumn( 4 ).setPreferredWidth( 20 );
        
        m_seriesQueryTable.getColumnModel( ).getColumn( 0 ).setPreferredWidth( 30 );
        m_seriesQueryTable.getColumnModel( ).getColumn( 1 ).setPreferredWidth( 150 );
        m_seriesQueryTable.getColumnModel( ).getColumn( 2 ).setPreferredWidth( 30 );
        m_seriesQueryTable.getColumnModel( ).getColumn( 3 ).setPreferredWidth( 50 );
        
        m_seriesQueryTablePopupMenu.add( m_loadModelSpectrumMenuItem );
        m_seriesQueryTablePopupMenu.add( m_loadModelSpectrumRefSignalMenuItem );
       
        m_seriesQueryTablePopupMenu.add( m_loadPatientSpectrumMenuItem );
        m_seriesQueryTablePopupMenu.add( m_loadPatientSpectrumRefSignalMenuItem );
    }
 
    
    
    private void showPopup( MouseEvent me ) 
    {        
        if ( me.getSource( ) == m_seriesQueryTable )
        {
            // is this event a popup trigger?        
            if ( m_seriesQueryTablePopupMenu.isPopupTrigger( me ) ) 
            {            
                Point p = me.getPoint( );     
                int row = m_seriesQueryTable.rowAtPoint( p );            
                int col = m_seriesQueryTable.columnAtPoint( p );            
                // if we've clicked on a row in the second col            
                if ( row != -1 && col == 1 )
                {
                    m_seriesQueryTablePopupMenu.show( m_seriesQueryTable, p.x, p.y);
                }
            }
        }
    }
    
    /** 
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_dataBaseInformationPanel = new javax.swing.JPanel();
        m_hostIPLabel = new javax.swing.JLabel();
        m_redefneDatabaseConnectionButton = new javax.swing.JButton();
        m_currentHostIPLabel = new javax.swing.JLabel();
        m_portNumberLabel = new javax.swing.JLabel();
        m_currentPortNumberLabel = new javax.swing.JLabel();
        m_databaseLabel = new javax.swing.JLabel();
        m_currentDatabaseLabel = new javax.swing.JLabel();
        m_queryPanel = new javax.swing.JPanel();
        m_studyIDTextField = new javax.swing.JTextField();
        m_studyIDLabel = new javax.swing.JLabel();
        m_databaseName = new javax.swing.JLabel();
        m_patientNameTextField = new javax.swing.JTextField();
        m_dateOfBirthlabel = new javax.swing.JLabel();
        m_dataOfBirthTextField = new javax.swing.JTextField();
        m_studyDateLabel = new javax.swing.JLabel();
        m_studyDateTextField = new javax.swing.JTextField();
        m_performQueryButton = new javax.swing.JButton();
        m_examinationPanel = new javax.swing.JPanel();
        m_examinationScrollPane = new javax.swing.JScrollPane();
        m_examinationsQueryTable = new javax.swing.JTable();
        m_seriesPanel = new javax.swing.JPanel();
        m_seriesScrollPane = new javax.swing.JScrollPane();
        m_seriesQueryTable = new javax.swing.JTable();
        m_instancesPanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        m_instancesTable = new javax.swing.JTable();

        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentHidden(java.awt.event.ComponentEvent evt) {
                formComponentHidden(evt);
            }
        });

        m_dataBaseInformationPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Database Information"));

        m_hostIPLabel.setText("Host IP address :");

        m_redefneDatabaseConnectionButton.setText("Set databaseconnection..");
        m_redefneDatabaseConnectionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_redefneDatabaseConnectionButtonActionPerformed(evt);
            }
        });

        m_currentHostIPLabel.setText("127.0.0.1");

        m_portNumberLabel.setText("Port :");

        m_currentPortNumberLabel.setText("3306");

        m_databaseLabel.setText("Database name :");

        m_currentDatabaseLabel.setText("din_spectro_db");

        org.jdesktop.layout.GroupLayout m_dataBaseInformationPanelLayout = new org.jdesktop.layout.GroupLayout(m_dataBaseInformationPanel);
        m_dataBaseInformationPanel.setLayout(m_dataBaseInformationPanelLayout);
        m_dataBaseInformationPanelLayout.setHorizontalGroup(
            m_dataBaseInformationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_dataBaseInformationPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_dataBaseInformationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_dataBaseInformationPanelLayout.createSequentialGroup()
                        .add(m_hostIPLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_currentHostIPLabel)
                        .add(50, 50, 50)
                        .add(m_portNumberLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_currentPortNumberLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(m_databaseLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_currentDatabaseLabel)
                        .add(22, 22, 22))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, m_dataBaseInformationPanelLayout.createSequentialGroup()
                        .add(m_redefneDatabaseConnectionButton)
                        .addContainerGap())))
        );
        m_dataBaseInformationPanelLayout.setVerticalGroup(
            m_dataBaseInformationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_dataBaseInformationPanelLayout.createSequentialGroup()
                .add(m_dataBaseInformationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_hostIPLabel)
                    .add(m_portNumberLabel)
                    .add(m_databaseLabel)
                    .add(m_currentHostIPLabel)
                    .add(m_currentPortNumberLabel)
                    .add(m_currentDatabaseLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_redefneDatabaseConnectionButton))
        );

        m_queryPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Database Query"));

        m_studyIDLabel.setText("Study ID");

        m_databaseName.setText("Patient Name");

        m_dateOfBirthlabel.setText("Date of birth");

        m_studyDateLabel.setText("Study date");

        m_performQueryButton.setText("Query!");
        m_performQueryButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_performQueryButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_queryPanelLayout = new org.jdesktop.layout.GroupLayout(m_queryPanel);
        m_queryPanel.setLayout(m_queryPanelLayout);
        m_queryPanelLayout.setHorizontalGroup(
            m_queryPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_queryPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_queryPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_queryPanelLayout.createSequentialGroup()
                        .add(m_queryPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(m_dateOfBirthlabel)
                            .add(m_studyIDLabel)
                            .add(m_studyDateLabel)
                            .add(m_databaseName))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_queryPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(m_patientNameTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 356, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_dataOfBirthTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 356, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_studyIDTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 356, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_studyDateTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 356, Short.MAX_VALUE)))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, m_performQueryButton))
                .addContainerGap())
        );
        m_queryPanelLayout.setVerticalGroup(
            m_queryPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_queryPanelLayout.createSequentialGroup()
                .add(m_queryPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_databaseName)
                    .add(m_patientNameTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_queryPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_dateOfBirthlabel)
                    .add(m_dataOfBirthTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_queryPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_studyIDLabel)
                    .add(m_studyIDTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_queryPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_studyDateLabel)
                    .add(m_studyDateTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_performQueryButton)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_examinationPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Studies"));

        m_examinationsQueryTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Patient name", "Date of birth", "Study date", "Study ID", "Modality"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        m_examinationScrollPane.setViewportView(m_examinationsQueryTable);

        org.jdesktop.layout.GroupLayout m_examinationPanelLayout = new org.jdesktop.layout.GroupLayout(m_examinationPanel);
        m_examinationPanel.setLayout(m_examinationPanelLayout);
        m_examinationPanelLayout.setHorizontalGroup(
            m_examinationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_examinationScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 444, Short.MAX_VALUE)
        );
        m_examinationPanelLayout.setVerticalGroup(
            m_examinationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_examinationPanelLayout.createSequentialGroup()
                .add(m_examinationScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 88, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(21, Short.MAX_VALUE))
        );

        m_seriesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Series"));

        m_seriesQueryTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Number", "Description", "Instances", "Type"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        m_seriesScrollPane.setViewportView(m_seriesQueryTable);

        org.jdesktop.layout.GroupLayout m_seriesPanelLayout = new org.jdesktop.layout.GroupLayout(m_seriesPanel);
        m_seriesPanel.setLayout(m_seriesPanelLayout);
        m_seriesPanelLayout.setHorizontalGroup(
            m_seriesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_seriesScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 444, Short.MAX_VALUE)
        );
        m_seriesPanelLayout.setVerticalGroup(
            m_seriesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_seriesPanelLayout.createSequentialGroup()
                .add(m_seriesScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 87, Short.MAX_VALUE)
                .addContainerGap())
        );

        m_instancesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Instances"));

        m_instancesTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Number", "Dimension", "Position", "TE", "TR"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(m_instancesTable);

        org.jdesktop.layout.GroupLayout m_instancesPanelLayout = new org.jdesktop.layout.GroupLayout(m_instancesPanel);
        m_instancesPanel.setLayout(m_instancesPanelLayout);
        m_instancesPanelLayout.setHorizontalGroup(
            m_instancesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 444, Short.MAX_VALUE)
        );
        m_instancesPanelLayout.setVerticalGroup(
            m_instancesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_instancesPanelLayout.createSequentialGroup()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 95, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(31, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, m_queryPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, m_dataBaseInformationPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, m_examinationPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, m_seriesPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, m_instancesPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(m_dataBaseInformationPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_queryPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_examinationPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_seriesPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_instancesPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(45, 45, 45))
        );
    }// </editor-fold>//GEN-END:initComponents

    
/**
 * Is called whenever the m_performQueryButtonActionPerformed button is pressed
 */ 
    private void m_performQueryButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_performQueryButtonActionPerformed

        while ( m_examinationsQueryTable.getModel( ).getRowCount( ) > 0 )
        {
            //clears the table!
            ((DefaultTableModel)m_examinationsQueryTable.getModel( ) ).setRowCount( 0 );
        }
        
        while ( m_seriesQueryTable.getModel( ).getRowCount( ) > 0 )
        {
            //clears the table!
            ((DefaultTableModel)m_seriesQueryTable.getModel( ) ).setRowCount( 0 );
        }
        
        while ( m_instancesTable.getModel( ).getRowCount( ) > 0 )
        {
            //clears the table!
            ((DefaultTableModel)m_instancesTable.getModel( ) ).setRowCount( 0 );
        }
        
        MRSpectroscopyDatabaseConnection dbCon = new MRSpectroscopyDatabaseConnection( );
        
        String sql = "SELECT * FROM patient WHERE patient_name LIKE '" + m_patientNameTextField.getText( ).replace( '*', '%' ) + "'";
        System.out.println( "sql : " + sql );
        
        Statement stmt = dbCon.createStatement( );
        ResultSet resultSet = null;
        int numberOfHits = 0;
        try
        {
            // Execute the query
            resultSet = stmt.executeQuery( sql );
            int i = 0;
            
            resultSet.last( );                  // Jump to last row
            numberOfHits = resultSet.getRow( ); // get the row count
            resultSet.beforeFirst( );           // reset to allow forward cursor processing
            
            System.out.println( "number of patients : " + numberOfHits );
            
            m_examinationResults.clear( );
            
            while( resultSet.next( ) )
            { 
                m_examinationResults.put( i++, resultSet.getString( "dicom_study_uid" ) );
            }
            resultSet.beforeFirst( );
        }
        catch ( SQLException e ) 
        {
            System.out.println( "SQLException while trying to select a patient from database !!!" );
            System.out.println( e.getMessage( ) );
        }
        
        StudyTableModel patMod = new StudyTableModel( resultSet );
        
        m_examinationsQueryTable.setModel( new DefaultTableModel( patMod.getTableData( ), patMod.getColumnNames( ) ) );
        
        m_examinationsQueryTable.getColumnModel( ).getColumn( 0 ).setPreferredWidth( 140 );
        m_examinationsQueryTable.getColumnModel( ).getColumn( 1 ).setPreferredWidth( 30 );
        m_examinationsQueryTable.getColumnModel( ).getColumn( 2 ).setPreferredWidth( 30 );
        m_examinationsQueryTable.getColumnModel( ).getColumn( 3 ).setPreferredWidth( 60 );
        m_examinationsQueryTable.getColumnModel( ).getColumn( 4 ).setPreferredWidth( 20 );
        
        dbCon.close( resultSet );

    }//GEN-LAST:event_m_performQueryButtonActionPerformed

    /**
     * Is called whenever the m_redefneDatabaseConnectionButton is pressed and
     * allows the redefinition of the database connection settings
     */
    private void m_redefneDatabaseConnectionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_redefneDatabaseConnectionButtonActionPerformed
            m_dataBaseConnectionDefinerFrame = new DataBaseConnectionDefinerFrame( m_parent );
            m_dataBaseConnectionDefinerFrame.setVisible( true );
            m_dataBaseConnectionDefinerFrame.addActionListener( this );
    }//GEN-LAST:event_m_redefneDatabaseConnectionButtonActionPerformed

    private void formComponentHidden(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentHidden
// TODO add your handling code here:
    }//GEN-LAST:event_formComponentHidden

    /**
     * Is called whenever a registered component raises an actionEvent
     */
    public void actionPerformed( ActionEvent e )
    {
        if ( e.getSource( ) == m_dataBaseConnectionDefinerFrame )
        {
            DatabaseConnectionSettings dcs = DatabaseConnectionSettings.getInstance( );
            
            m_currentDatabaseLabel.setText( dcs.getDatabaseName( ) );
            m_currentHostIPLabel.setText( dcs.getDatabaseIP( ) );
            m_currentPortNumberLabel.setText( dcs.getDatabasePort( ) );
        }
    }

    /**
     * Implementation of the listselectionlistener interface
     */
    public void valueChanged( ListSelectionEvent e ) 
    {
        
        if ( e.getSource( ) == m_examinationsQueryTableListSelectionModel )
        {
            // Ignore extra messages.
            if ( e.getValueIsAdjusting( ) ) return;

            ListSelectionModel lsm = (ListSelectionModel)e.getSource( );
            if ( lsm.isSelectionEmpty( ) ) 
            {
                 System.out.println( "No rows are selected." );
            } 
            else 
            {
                int selectedRow = lsm.getMinSelectionIndex( );
                System.out.println( "Row " + selectedRow
                                    + " is now selected." );
                upDateSeriesTable( selectedRow );
            }
        }
        
        if ( e.getSource( ) == m_seriesQueryTableListSelectionModel )
        {
            // Ignore extra messages.
            if ( e.getValueIsAdjusting( ) ) return;

            ListSelectionModel lsm = (ListSelectionModel)e.getSource( );
            if ( lsm.isSelectionEmpty( ) ) 
            {
                 System.out.println( "No rows are selected." );
            } 
            else 
            {
                int selectedRow = lsm.getMinSelectionIndex( );
                System.out.println( "Row " + selectedRow
                                    + " is now selected." );
                upDateInstancesTable( selectedRow );
            }
        }
        
    }
    
    /**
     * Updates the m_seriesQueryTable with values from the database
     */
    private void upDateSeriesTable( int selectedRow )
    {
        
        String currentlySelectedExam = (String)m_examinationResults.get( selectedRow );
        
        System.out.println( "Currently selected dicom_study_uid : " + currentlySelectedExam );
        
        // Select the series belonging to this examination
        MRSpectroscopyDatabaseConnection dbCon = new MRSpectroscopyDatabaseConnection( );
        
        String sql = "SELECT * FROM series WHERE dicom_study_uid = '" + currentlySelectedExam + "'" +
                     "ORDER BY pacs_series_number ASC";
        System.out.println( "sql : " + sql );
        
        Statement stmt = dbCon.createStatement( );
        ResultSet resultSet = null;
        int numberOfHits = 0;
        
        try
        {
            // Execute the query
            resultSet = stmt.executeQuery( sql );
            int i = 0;
            
            resultSet.last( );                  // Jump to last row
            numberOfHits = resultSet.getRow( ); // get the row count
            resultSet.beforeFirst( );           // reset to allow forward cursor processing
            
            System.out.println( "number of studies : " + numberOfHits );
            
            m_seriesResults.clear( );
            
            while( resultSet.next( ) )
            { 
                m_seriesResults.put( i++, resultSet.getString( "series_instance_uid" ) );
            }
            
            resultSet.beforeFirst( );
        }
        catch ( SQLException e ) 
        {
            System.out.println( "SQLException while trying to select a specific study from database !!!" );
            System.out.println( e.getMessage( ) );
        }
        
        SeriesTableModel stdm = new SeriesTableModel( resultSet );
        
        m_seriesQueryTable.setModel( new DefaultTableModel( stdm.getTableData( ), stdm.getColumnNames( ) ) );
        
        m_seriesQueryTable.getColumnModel( ).getColumn( 0 ).setPreferredWidth( 30 );
        m_seriesQueryTable.getColumnModel( ).getColumn( 1 ).setPreferredWidth( 150 );
        m_seriesQueryTable.getColumnModel( ).getColumn( 2 ).setPreferredWidth( 30 );
        m_seriesQueryTable.getColumnModel( ).getColumn( 3 ).setPreferredWidth( 50 );
        
        dbCon.close( resultSet );
    }
    
    
     
    /**
     * Updates the m_instancesTable with values from the database
     */
    private void upDateInstancesTable( int selectedRow )
    {
        String currentlySelectedSeriesUID = (String)m_seriesResults.get( selectedRow );
        
        System.out.println( "Currently selected sop_instance_uid : " + currentlySelectedSeriesUID );
        
        // Select the series belonging to this examination
        MRSpectroscopyDatabaseConnection dbCon = new MRSpectroscopyDatabaseConnection( );
        
        String sql = "SELECT * FROM images WHERE series_instance_uid = '" + currentlySelectedSeriesUID + "'" +
                     "ORDER BY instance_number ASC";
        
        System.out.println( "sql : " + sql );
        
        Statement stmt = dbCon.createStatement( );
        ResultSet resultSet = null;
        int numberOfHits = 0;
        
        m_dicomImageSeriesData = new DicomImageSeriesData( );
        
        try
        {
            // Execute the query
            resultSet = stmt.executeQuery( sql );
            int i = 0;
            
            resultSet.last( );                  // Jump to last row
            numberOfHits = resultSet.getRow( ); // get the row count
            resultSet.beforeFirst( );           // reset to allow forward cursor processing
            
            System.out.println( "number of instances : " + numberOfHits );
            m_isImage = true;
            m_instancesResults.clear( );
            
            while( resultSet.next( ) )
            { 
                m_instancesResults.put( i++, resultSet.getString( "sop_instance_uid" ) );
                
                Blob blob = resultSet.getBlob( "dicom_file_blob" );
                InputStream in = blob.getBinaryStream( );
                
                DicomImageData ima = new DicomImageData( in );
                
                try
                {
                    in.reset( );    
                }
                catch( IOException ioe )
                {
                    System.out.println( "IOException in InputStream reset() - call" );
                }
                
                if ( ( ima.getHeader( ).getManufacturer( ).compareTo( "SIEMENS" ) == 0 ) && ( ima.getHeader( ).getImageModality( ).compareTo( "MR" ) == 0 ) )
                {
                    ima.getSiemensSpecificDataFromInputStream( ima.getHeader( ).getSOPInstanceUID( ), in );
                }
                if ( ima.getHeader( ).isImageData( ) == false )
                {
                    m_isImage = false;
                }
                
                m_dicomImageSeriesData.addDicomImageData( ima );
            }
            
            resultSet.beforeFirst( );
        }
        catch ( SQLException e ) 
        {
            System.out.println( "SQLException while trying to select instances from database !!!" );
            System.out.println( e.getMessage( ) );
        }
        
        InstancesTableModel stdm = new InstancesTableModel( resultSet );
        
        m_instancesTable.setModel( new DefaultTableModel( stdm.getTableData( ), stdm.getColumnNames( ) ) );
       
        notifyActionListeners( DICOM_SERIES_SELECTED, DICOM_SERIES_SELECTED_CMD );
        
        dbCon.close( resultSet );
    }
    
    /**
     * Adds an actionlistener to the list of listeners to this object
     */
    public void addActionListener( ActionListener listener )
    {
        m_actionListeners.add( listener );
    }
    
    /**
     * Notifies registered ActionListeners
     */
    private void notifyActionListeners( int eventType, String actionCommand )
    {
        Iterator it = m_actionListeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, eventType, actionCommand ) );
        }
    }
    
    /**
     * Returns the DicomImageSeriesData object
     */
    public DicomImageSeriesData getDicomImageSeriesData( )
    {
        return m_dicomImageSeriesData;
    }
    
    /**
     * Returns whether the current series is a spectrum or an image (series)
     */
    public boolean isImageSeries( )
    {
        return m_isImage;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel m_currentDatabaseLabel;
    private javax.swing.JLabel m_currentHostIPLabel;
    private javax.swing.JLabel m_currentPortNumberLabel;
    private javax.swing.JPanel m_dataBaseInformationPanel;
    private javax.swing.JTextField m_dataOfBirthTextField;
    private javax.swing.JLabel m_databaseLabel;
    private javax.swing.JLabel m_databaseName;
    private javax.swing.JLabel m_dateOfBirthlabel;
    private javax.swing.JPanel m_examinationPanel;
    private javax.swing.JScrollPane m_examinationScrollPane;
    private javax.swing.JTable m_examinationsQueryTable;
    private javax.swing.JLabel m_hostIPLabel;
    private javax.swing.JPanel m_instancesPanel;
    private javax.swing.JTable m_instancesTable;
    private javax.swing.JTextField m_patientNameTextField;
    private javax.swing.JButton m_performQueryButton;
    private javax.swing.JLabel m_portNumberLabel;
    private javax.swing.JPanel m_queryPanel;
    private javax.swing.JButton m_redefneDatabaseConnectionButton;
    private javax.swing.JPanel m_seriesPanel;
    private javax.swing.JTable m_seriesQueryTable;
    private javax.swing.JScrollPane m_seriesScrollPane;
    private javax.swing.JLabel m_studyDateLabel;
    private javax.swing.JTextField m_studyDateTextField;
    private javax.swing.JLabel m_studyIDLabel;
    private javax.swing.JTextField m_studyIDTextField;
    // End of variables declaration//GEN-END:variables
    
    // Manually added member variables
    private JFrame m_parent;
    private DataBaseConnectionDefinerFrame m_dataBaseConnectionDefinerFrame;
    private ListSelectionModel m_examinationsQueryTableListSelectionModel;
    private ListSelectionModel m_seriesQueryTableListSelectionModel;
    
    private JPopupMenu m_seriesQueryTablePopupMenu = new JPopupMenu( );
    
    private JMenuItem m_loadModelSpectrumMenuItem = new JMenuItem( "Import model spectrum to project" );
    private JMenuItem m_loadModelSpectrumRefSignalMenuItem = new JMenuItem( "Import model spectrum reference signal" );
    private JMenuItem m_loadPatientSpectrumMenuItem = new JMenuItem( "Load  patient spectrum" );
    private JMenuItem m_loadPatientSpectrumRefSignalMenuItem = new JMenuItem( "Load  patient spectrum reference signal" );
   
    private Hashtable m_examinationResults = new Hashtable( );
    private Hashtable m_seriesResults = new Hashtable( );
    private Hashtable m_instancesResults = new Hashtable( );
    
    private LinkedList<ActionListener> m_actionListeners = new LinkedList<ActionListener>( );
    
    public final static int DICOM_SERIES_SELECTED = 0; 
    public final static String DICOM_SERIES_SELECTED_CMD = "SERIES_SELECTED";
    private DicomImageSeriesData m_dicomImageSeriesData;
    private boolean m_isImage = true;
    
    // For proper serialization
    private static final long serialVersionUID = 6482325933121223L;
}
