/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.popups;

import com.jmatio.types.MLArray;
import com.jmatio.types.MLNumericArray;
import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import org.dcm4che2.data.DicomObject;
import org.spectrim.utilities.MatlabIO;

/**
 *
 * @author nuno
 */
public class PopupMatlabReader extends javax.swing.JFrame {

    private DefaultTableModel tablemodel;
    private File currentFile;
    private TableCellMATLABMapReaderEditor cellTypeEditor;
    private ModelProviderInterface modelProvider;

    /**
     * Creates new form PopupMatlabReader
     */
    public PopupMatlabReader(ModelProviderInterface modelProvider) {
        initComponents();
        tablemodel = (DefaultTableModel) jTable1.getModel();
        cellTypeEditor = new TableCellMATLABMapReaderEditor(jTable1);
        TableColumn column = jTable1.getColumnModel().getColumn(2);
        column.setCellEditor(cellTypeEditor);
        this.modelProvider = modelProvider;
        this.setVisible(true);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jRadioButtonNormal = new javax.swing.JRadioButton();
        jRadioButtonTriColor = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldFile = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jButtonUpdateMap = new javax.swing.JButton();
        jCheckBoxJustSelected = new javax.swing.JCheckBox();
        jButtonResetFunctions = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("SpectrIm - Map from .MAT");
        setAlwaysOnTop(true);

        buttonGroup1.add(jRadioButtonNormal);
        jRadioButtonNormal.setSelected(true);
        jRadioButtonNormal.setText("Normal");
        jRadioButtonNormal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonNormalActionPerformed(evt);
            }
        });

        buttonGroup1.add(jRadioButtonTriColor);
        jRadioButtonTriColor.setText("Tri-Color");
        jRadioButtonTriColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonTriColorActionPerformed(evt);
            }
        });

        jLabel1.setText("File:");

        jTextFieldFile.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTextFieldFileMouseClicked(evt);
            }
        });
        jTextFieldFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldFileActionPerformed(evt);
            }
        });

        jLabel2.setText("Type:");

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Name", "Dimensions", "Map Function"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTable1);

        jButtonUpdateMap.setText("Update Map");
        jButtonUpdateMap.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonUpdateMapActionPerformed(evt);
            }
        });

        jCheckBoxJustSelected.setText("map just in selected voxels");
        jCheckBoxJustSelected.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxJustSelectedActionPerformed(evt);
            }
        });

        jButtonResetFunctions.setText("Reset Functions");
        jButtonResetFunctions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResetFunctionsActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 528, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addGap(4, 4, 4)
                        .addComponent(jRadioButtonNormal)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jRadioButtonTriColor)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jTextFieldFile))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jButtonResetFunctions)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jCheckBoxJustSelected)
                        .addGap(18, 18, 18)
                        .addComponent(jButtonUpdateMap)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextFieldFile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButtonTriColor)
                    .addComponent(jRadioButtonNormal)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 222, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonUpdateMap)
                    .addComponent(jCheckBoxJustSelected)
                    .addComponent(jButtonResetFunctions))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jRadioButtonNormalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonNormalActionPerformed
        this.cellTypeEditor.setMode(TableCellMATLABMapReaderEditor.MONOCHANNEL);
    }//GEN-LAST:event_jRadioButtonNormalActionPerformed

    private void jRadioButtonTriColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonTriColorActionPerformed
        this.cellTypeEditor.setMode(TableCellMATLABMapReaderEditor.TRICHANNEL);
    }//GEN-LAST:event_jRadioButtonTriColorActionPerformed

    private void jButtonUpdateMapActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonUpdateMapActionPerformed
        String Coordsmat = "";
        String RGBmat = "";
        String Rmat = "";
        String Gmat = "";
        String Bmat = "";
        int rows = tablemodel.getRowCount();
        if (rows > 0) {
            for (int i = 0; i < rows; i++) {
                String func = (String) tablemodel.getValueAt(i, 2);
                if (func.matches("Coords")) {
                    Coordsmat = (String) tablemodel.getValueAt(i, 0);
                }
                if (func.matches("RGB")) {
                    RGBmat = (String) tablemodel.getValueAt(i, 0);
                }
                if (func.matches("R")) {
                    Rmat = (String) tablemodel.getValueAt(i, 0);
                }
                if (func.matches("G")) {
                    Gmat = (String) tablemodel.getValueAt(i, 0);
                }
                if (func.matches("B")) {
                    Bmat = (String) tablemodel.getValueAt(i, 0);
                }
            }
            if (this.jRadioButtonNormal.isSelected() && !Coordsmat.matches("") && !RGBmat.matches("")) {
                HashMap<String, MLArray> maps = MatlabIO.readMAT(currentFile.toString());
                MLNumericArray<Double> ids = (MLNumericArray<Double>) maps.get(Coordsmat);
                MLNumericArray<Double> values = (MLNumericArray<Double>) maps.get(RGBmat);
                LinkedHashMap<String, Double> map = new LinkedHashMap<>();
                for (int i = 0; i < ids.getM(); i++) {
                    int c1 = ids.getReal(i, 0).intValue() - 1;
                    int c2 = ids.getReal(i, 1).intValue() - 1;
                    int c3 = ids.getReal(i, 2).intValue() - 1;
                    String coord = c1 + "_" + c2 + "_" + c3;
                    double val = values.getReal(i);
                    map.put(coord, val);
                }
                modelProvider.getModel().getColorMap().setColorMapValues(map, this.jCheckBoxJustSelected.isSelected(),"Matlab - "+RGBmat);
            } else if (this.jRadioButtonTriColor.isSelected() && !Coordsmat.matches("")
                    && !Rmat.matches("") && !Gmat.matches("") && !Bmat.matches("")) {
                HashMap<String, MLArray> maps = MatlabIO.readMAT(currentFile.toString());
                MLNumericArray<Double> ids = (MLNumericArray<Double>) maps.get(Coordsmat);
                MLNumericArray<Double> valR = (MLNumericArray<Double>) maps.get(Rmat);
                MLNumericArray<Double> valG = (MLNumericArray<Double>) maps.get(Gmat);
                MLNumericArray<Double> valB = (MLNumericArray<Double>) maps.get(Bmat);
                LinkedHashMap<String, double[]> map = new LinkedHashMap<>();
                for (int i = 0; i < ids.getM(); i++) {
                    int c1 = ids.getReal(i, 0).intValue() - 1;
                    int c2 = ids.getReal(i, 1).intValue() - 1;
                    int c3 = ids.getReal(i, 2).intValue() - 1;
                    String coord = c1 + "_" + c2 + "_" + c3;
                    double[] val = new double[]{valR.getReal(i), valG.getReal(i), valB.getReal(i)};
                    map.put(coord, val);
                }
                modelProvider.getModel().getColorMap().setColorMapValuesTriChannel(map, this.jCheckBoxJustSelected.isSelected());
            }
        }
    }//GEN-LAST:event_jButtonUpdateMapActionPerformed

    private void jTextFieldFileMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextFieldFileMouseClicked
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Open MAT file");
        FileNameExtensionFilter filter = new FileNameExtensionFilter("MATLAB", "mat");
        fileChooser.setFileFilter(filter);

        if (currentFile != null) {
            fileChooser.setSelectedFile(currentFile);
        }
        File selected_file;

        int result = fileChooser.showOpenDialog(this);
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                int rows = tablemodel.getRowCount();
                if (rows > 0) {
                    for (int i = 0; i < rows; i++) {
                        tablemodel.removeRow(0);
                    }
                }
                selected_file = fileChooser.getSelectedFile();
                if (selected_file != null) {
                    this.currentFile = fileChooser.getSelectedFile();
                    this.jTextFieldFile.setText(selected_file.toString());

                    HashMap<String, MLArray> maps = MatlabIO.readMAT(selected_file.toString());
                    Set keys = maps.keySet();
                    Iterator<String> iter = keys.iterator();

                    while (iter.hasNext()) {
                        String key = iter.next();
                        MLArray array = maps.get(key);
                        String dims = array.getM() + "x" + array.getN();
                        tablemodel.addRow(new Object[]{array.name, dims, "No Function"});
                    }

                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jTextFieldFileMouseClicked

    private void jTextFieldFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldFileActionPerformed
    }//GEN-LAST:event_jTextFieldFileActionPerformed

    private void jCheckBoxJustSelectedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxJustSelectedActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jCheckBoxJustSelectedActionPerformed

    private void jButtonResetFunctionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResetFunctionsActionPerformed
        int rows = tablemodel.getRowCount();
        if (rows > 0) {
            for (int i = 0; i < rows; i++) {
                tablemodel.setValueAt("No Function", i, 2);
            }
        }
    }//GEN-LAST:event_jButtonResetFunctionsActionPerformed
    /**
     * @param args the command line arguments
     */
//    public static void main(String args[]) {
//        /* Set the Nimbus look and feel */
//        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
//        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
//         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
//         */
//        try {
//            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
//                if ("Nimbus".equals(info.getName())) {
//                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
//                    break;
//                }
//            }
//        } catch (ClassNotFoundException ex) {
//            java.util.logging.Logger.getLogger(PopupMatlabReader.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (InstantiationException ex) {
//            java.util.logging.Logger.getLogger(PopupMatlabReader.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (IllegalAccessException ex) {
//            java.util.logging.Logger.getLogger(PopupMatlabReader.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
//            java.util.logging.Logger.getLogger(PopupMatlabReader.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        }
//        //</editor-fold>
//
//        /* Create and display the form */
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new PopupMatlabReader().setVisible(true);
//            }
//        });
//    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButtonResetFunctions;
    private javax.swing.JButton jButtonUpdateMap;
    private javax.swing.JCheckBox jCheckBoxJustSelected;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JRadioButton jRadioButtonNormal;
    private javax.swing.JRadioButton jRadioButtonTriColor;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextFieldFile;
    // End of variables declaration//GEN-END:variables
}
