/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.report;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;
import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.spectrim.model.GlobalModel;
import org.spectrim.popups.jMRUIResultsMapListener;
import org.spectrim.settings.ReportSettings;

/**
 *
 * @author Giezi updated JSlotboom
 */
public class CstmReportFrame extends StdReportFrame 
{

    public CstmReportFrame( int panelType, GlobalModel csimodel, jMRUIResultsMapListener mapListener, File... filePrset ) 
    {
        super( panelType, csimodel, mapListener, false );
        JMenuItem savePreset = new JMenuItem( );
        savePreset.setText( "Save as preset..." );
        savePreset.addActionListener( new java.awt.event.ActionListener( ) 
        {
                public void actionPerformed( java.awt.event.ActionEvent evt ) 
                {
                    jMenuItemSavePresetActionPerformed( evt );
                }
            });
        super.getJMenuBar( ).getMenu( 0 ).add( savePreset );
        
        JMenuItem loadPreset = new JMenuItem( );
        loadPreset.setText( "Load preset..." );
        loadPreset.addActionListener( new java.awt.event.ActionListener( ) 
        {
                public void actionPerformed( java.awt.event.ActionEvent evt ) 
                {
                    jMenuItemLoadPresetActionPerformed( );
                }
            });
        super.getJMenuBar( ).getMenu( 0 ).add( loadPreset );
        
        if( filePrset.length > 0 )
        {
            jMenuItemLoadPresetActionPerformed( filePrset );
        }
        
    }

    private void jMenuItemSavePresetActionPerformed(java.awt.event.ActionEvent evt) {
        System.out.println( "*****************************" );
        ArrayList<String> lvlPrst = new ArrayList<>( );
        ArrayList<String> typePrst = new ArrayList<>( );
        ArrayList<String> metabPrst = new ArrayList<>( );
        ( (CstmReportPanel)super.getContainerPanel( ) ).nameComponents( lvlPrst, typePrst, metabPrst );
        try 
        {
            FileWriter writer = new FileWriter( choosePrstSavingPath( ) );
            for( int i = 0; i < lvlPrst.size( );i++ ) 
            {
                writer.write( lvlPrst.get(i) + "\n" );
                writer.write( typePrst.get(i) + "\n" );
                writer.write( metabPrst.get(i) + "\n" );
              }
            writer.close( );
        } catch ( IOException ex ) 
        {
            System.out.println( "Couldn't save preset for some obscure reason (damn it!)" );
        }
        System.out.println( "\ndone" );
    }
    
    private void jMenuItemLoadPresetActionPerformed( File... filePrset ) 
    {
        ArrayList<String> cmdLevel = new ArrayList<>();
        ArrayList<String> cmdType = new ArrayList<>();
        ArrayList<String> metabType = new ArrayList<>();
        if( filePrset.length > 0 )
            loadPreset( filePrset[0], cmdLevel, cmdType, metabType );
        else
            loadPreset( openFileChooser( ),cmdLevel, cmdType, metabType );
        for( String cmd: cmdLevel )
        {
            System.out.println(cmd);
        }
        for( String cmd: cmdType )
        {
            System.out.println( cmd );
        }
        ( (CstmReportPanel)super.getContainerPanel( ) ).removeAll( );
        constructPanel( (CstmReportPanel)super.getContainerPanel( ), cmdLevel, cmdType, metabType );
    }
    
    private void loadPreset( File fileName, ArrayList<String> cmdLevel, 
                             ArrayList<String> cmdType, ArrayList<String> metabType )
    {
        try 
        {
            Scanner scanner = new Scanner( fileName );
            scanner.useDelimiter( "\n" );
            while( scanner.hasNext( ) )
            {
                cmdLevel.add( scanner.next( ) );
                cmdType.add( scanner.next( ) );
                metabType.add( scanner.next( ) );
            }
            scanner.close( );
        } 
        catch ( FileNotFoundException ex ) 
        {
            System.err.println( "Couldn't load preset for some obscure reason (damn it!)" );
        }
    }

    private void constructPanel( CstmReportPanel pnl, ArrayList<String> cmdLevel, 
                                 ArrayList<String> cmdType, 
                                 ArrayList<String> metabType )
    {
        ArrayList<String> cmdLevelTmp   = new ArrayList<>( );
        ArrayList<String> cmdTypeTmp    = new ArrayList<>( );
        ArrayList<String> metabTypeTmp  = new ArrayList<>( );
        ArrayList<String> cmdLevelTmp2  = new ArrayList<>( );
        ArrayList<String> cmdTypeTmp2   = new ArrayList<>( );
        ArrayList<String> metabTypeTmp2 = new ArrayList<>( );
        boolean hasTwo = false;
        int breakingVal = 0;
        String cmd;
        try 
        {
            cmd = cmdType.get( 0 ).split( "\\.", 2 )[0];
            for ( int j = 0; j < cmdLevel.size( ); j++ ) 
            {
                cmdLevelTmp.add( cmdLevel.get( j ).split("\\.",2 )[1] );
                cmdTypeTmp.add( cmdType.get( j ).split("\\.",2 )[1] );
                metabTypeTmp.add( metabType.get( j ) );
                try
                {
                    if ( cmdLevel.get( j ).split( "\\.", 2 )[1].charAt(0) != cmdLevel.get( ( j + 1 )%cmdLevel.size( ) ).split( "\\." ,2 )[1].charAt( 0 )
                       && cmdType.get( j ).split( "\\.", 2 )[0].matches( cmdType.get(( j + 1 ) % cmdLevel.size( ) ).split( "\\.",2 )[0] ) )
                {
                    hasTwo = true;
                    breakingVal = j + 1;
                    break;
                }
                }
                catch ( Exception e ) 
                {
                    //
                }
            }
        } catch ( Exception e ) 
        {
           cmd = cmdType.get( 0 );
           metabTypeTmp = metabType;
        }
        
        if( hasTwo )
        {
            System.out.println( "split: " + breakingVal );
            for( int j = breakingVal; j < cmdLevel.size( ); j++ )
            {
                cmdLevelTmp2.add( cmdLevel.get( j ).split( "\\.",2 )[1] );
                cmdTypeTmp2.add( cmdType.get( j ).split( "\\.",2 )[1] );
                metabTypeTmp2.add( metabType.get( j ) );
            }
            CstmReportPanel[] pnls = addPanel( pnl, cmd );
            if( pnls != null )
            {
                constructPanel( pnls[0], cmdLevelTmp, cmdTypeTmp, metabTypeTmp );
            }
            if(pnls.length > 1)
            {
                constructPanel( pnls[1], cmdLevelTmp2, cmdTypeTmp2, metabTypeTmp2 );
            }
        }
        else
        {
            if( cmd.matches( CstmReportPanel.HORIZONTAL ) || cmd.matches( CstmReportPanel.VERTICAL ) )
                constructPanel( pnl, cmdLevelTmp, cmdTypeTmp, metabTypeTmp );
            else
            {
                CstmReportPanel[] pnls = addPanel( pnl, cmd, metabTypeTmp.get( 0 ) );
                if(pnls != null)
                {
                    constructPanel( pnls[0], cmdLevelTmp, cmdTypeTmp, metabTypeTmp );
                }
            }
        }
    }
    
    private CstmReportPanel[] addPanel( CstmReportPanel pnl, 
                                        String pnlTypeToadd, 
                                        String... metabType )
    {
        System.out.println( "Switching: " + pnlTypeToadd );
        switch( pnlTypeToadd )
        {
            case CstmReportPanel.EMPTY:
                                        return null;
            case CstmReportPanel.HORIZONTAL:
                                        return pnl.splitHorizontal();
            case CstmReportPanel.VERTICAL:
                                        return pnl.splitVertical();
            case CstmReportPanel.SPECRED:
                                        pnl.addSpectraPanel( CstmReportPanel.REDSPCPNL );
                                        return null;
            case CstmReportPanel.SPECBLU:
                                        pnl.addSpectraPanel( CstmReportPanel.BLUSPCPNL );
                                        return null;
            case CstmReportPanel.SPECBOT:
                                        pnl.addSpectraPanel(CstmReportPanel.BOTSPCPNL);
                                        return null;
            case CstmReportPanel.LOCH:
                                        pnl.addLocalizersH();
                                        return null;
            case CstmReportPanel.LOCV:
                                        pnl.addLocalizersV();
                                        return null;
            case CstmReportPanel.OVER:
                                        pnl.addOverview();
                                        this.repaint();
                                        this.revalidate();
                                        ( ( ReportOverviewPanel )pnl.getComponent( 0 ) ).resetZoom(  );
                                        ( ( ReportOverviewPanel )pnl.getComponent( 0 ) ).repaint( );
                                        return null;
            case CstmReportPanel.TABLE:
                                        pnl.addMetabTable();
                                        return null;
            case CstmReportPanel.MAP:
                                        pnl.addMetabMap(metabType[0]);
                                        this.repaint();
                                        this.revalidate();
                                        ( ( ReportMetaboliteMapPanel )pnl.getComponent( 0 ) ).resetZoom( );
                                        ( ( ReportMetaboliteMapPanel )pnl.getComponent( 0 ) ).focusOnExcitedVoxels( );
                                        ( ( ReportMetaboliteMapPanel )pnl.getComponent( 0 ) ).repaint( );
                                        return null;
            case CstmReportPanel.RATIO:
                                        pnl.addMetabRatioMap( metabType[0]);
                                        this.repaint( );
                                        this.revalidate( );
                                        ( ( ReportMetaboliteRatioMapPanel )pnl.getComponent( 0 ) ).resetZoom( );
                                        ( ( ReportMetaboliteRatioMapPanel )pnl.getComponent( 0 ) ).focusOnExcitedVoxels( );
                                        ( ( ReportMetaboliteRatioMapPanel )pnl.getComponent( 0 ) ).repaint( );
                                        return null;
            default:
                                        System.out.println( "Not Supported!" );
                                        return null;
        }
    }
    
    private File openFileChooser( )
    {
        
        JFileChooser jFileChooserLoadPrst = new JFileChooser( );
        jFileChooserLoadPrst.setFileSelectionMode( JFileChooser.FILES_ONLY );
        jFileChooserLoadPrst.setCurrentDirectory( ReportSettings.getInstance( ).getPrstsPath( ) );
        FileNameExtensionFilter filter = new FileNameExtensionFilter( "RPRST FILES", "rprst", "rprst" );
        jFileChooserLoadPrst.setFileFilter( filter );
        int returnVal = jFileChooserLoadPrst.showOpenDialog( this );
        if ( returnVal == JFileChooser.APPROVE_OPTION ) 
        {
            return jFileChooserLoadPrst.getSelectedFile( );
        } 
        else 
        {
            return null;
        }
    }
    
    private File choosePrstSavingPath( )
    {
        JFileChooser jFileChooserSavePrst = new JFileChooser( );
        jFileChooserSavePrst.setSelectedFile( new File( ReportSettings.getInstance( ).getPrstsPath( ).toString( ) + File.separator + "myNewPreset.rprst" ) );
        FileNameExtensionFilter filter = new FileNameExtensionFilter( "RPRST FILES", "rprst", "rprst" );
        jFileChooserSavePrst.setFileFilter( filter );
        int returnVal = jFileChooserSavePrst.showSaveDialog( this );
        if ( returnVal == JFileChooser.APPROVE_OPTION ) 
        {
            String filePath = jFileChooserSavePrst.getCurrentDirectory( ).toString( ) + File.separator + jFileChooserSavePrst.getSelectedFile( ).getName( ).split( "\\." )[0] + ".rprst";
            return new File( filePath );
        } 
        else 
        {
            return new File( "myNewPreset.prst" );
        }
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
