/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.report;

import java.awt.Color;
import java.util.ArrayList;
import org.spectrim.model.GlobalModel;
import org.spectrim.view.LocalizerPanel;

/**
 *
 * @author Giezi updated JSlotboom
 */
public class ReportLocalizerPanels extends javax.swing.JPanel 
{

    LocalizerPanel Loc1;
    LocalizerPanel Loc2;
    LocalizerPanel Loc3;

    /**
     * Creates new form ReportLocalizerPanels.
     */
    public ReportLocalizerPanels( ) 
    {
        initComponents( );
    }

    public void initPanels( GlobalModel csimodel ) 
    {
        ArrayList<LocalizerPanel> locList;
        locList = csimodel.getLocalizerList( );

        Loc1 = new LocalizerPanel( );
        Loc2 = new LocalizerPanel( );
        Loc3 = new LocalizerPanel( );

        GlobalModel panelModel = new GlobalModel( csimodel );

        ((LocalizerPanel) Loc1).setImageInfo( locList.get( 0 ).getImageInfo( ) );
        ((LocalizerPanel) Loc2).setImageInfo( locList.get( 1 ).getImageInfo( ) );
        ((LocalizerPanel) Loc3).setImageInfo( locList.get( 2 ).getImageInfo( ) );

        int side = Math.max(this.getWidth( ) / 3, this.getHeight( ) / 3);
        side = Math.min( side, this.getWidth( ) );
        side = Math.min( side, this.getHeight( ) );

        jPanelLoc1.setSize( side, side );
        jPanelLoc2.setSize( side, side );
        jPanelLoc3.setSize( side, side );

        panelModel.addLocalizerPanel( ( (LocalizerPanel) Loc1 ) );
        panelModel.addLocalizerPanel( ( (LocalizerPanel) Loc2 ) );
        panelModel.addLocalizerPanel( ( (LocalizerPanel) Loc3 ) );

        Loc1.setSize( side, side );
        Loc2.setSize( side, side );
        Loc3.setSize( side, side );

        setLocalizer( Loc1 );
        setLocalizer( Loc2 );
        setLocalizer( Loc3 );

        if ( !panelModel.isSpectraNull( ) ) 
        {
            if ( jPanelLoc1.getComponentCount( ) == 0 ) 
            {
                LocalizerPanel loc = panelModel.getBlankLocalizerTransversal( );
                panelModel.addLocalizerPanel( loc );
                setLocalizer(loc);

            }
            if (jPanelLoc2.getComponentCount() == 0) 
            {
                LocalizerPanel loc = panelModel.getBlankLocalizerCoronal( );
                panelModel.addLocalizerPanel( loc );
                setLocalizer( loc );
            }
            if (jPanelLoc3.getComponentCount() == 0) 
            {
                LocalizerPanel loc = panelModel.getBlankLocalizerSagital( );
                panelModel.addLocalizerPanel( loc );
                setLocalizer( loc );
            }
        }
    }

    private void setLocalizer( LocalizerPanel loc ) 
    {
        switch ( loc.getImageInfo( ).getOrientation( ) ) {
            case TRANS:
                            jPanelLoc1.add( loc );
                            break;
            case COR:
                            jPanelLoc2.add( loc );
                            break;
            case SAG:
                            jPanelLoc3.add( loc );
                            break;
        }
    }

    private void setMisingLocalizers( ) 
    {

    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanelLoc1 = new org.spectrim.view.LocalizerPanel();
        jPanelLoc2 = new org.spectrim.view.LocalizerPanel();
        jPanelLoc3 = new org.spectrim.view.LocalizerPanel();

        setPreferredSize(new java.awt.Dimension(166, 500));
        setLayout(new java.awt.GridLayout(1, 0));

        jPanelLoc1.setBackground(new java.awt.Color(0, 0, 0));
        jPanelLoc1.setPreferredSize(new java.awt.Dimension(166, 166));
        add(jPanelLoc1);

        jPanelLoc2.setBackground(new java.awt.Color(0, 0, 0));
        jPanelLoc2.setPreferredSize(new java.awt.Dimension(166, 166));
        add(jPanelLoc2);

        jPanelLoc3.setBackground(new java.awt.Color(0, 0, 0));
        jPanelLoc3.setPreferredSize(new java.awt.Dimension(166, 166));
        add(jPanelLoc3);
    }// </editor-fold>//GEN-END:initComponents

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanelLoc1;
    private javax.swing.JPanel jPanelLoc2;
    private javax.swing.JPanel jPanelLoc3;
    // End of variables declaration//GEN-END:variables
}
