/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.report;

import java.awt.Color;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import org.spectrim.model.GlobalModel;
import org.spectrim.popups.jMRUIResultsMapListener;
import org.spectrim.view.ImageViewerPanel;

/**
 *
 * @author Giezi updated JSlotboom
 */
public class ReportMetaboliteRatioMapPanel extends ImageViewerPanel  
{

    public ReportMetaboliteRatioMapPanel( ) 
    {
        super( );
    }
    
    public void displayMap( String metabName1, String metabName2, 
                            GlobalModel csimodelIn, 
                            jMRUIResultsMapListener mapListener )
    {
        int metabIndex1 = getMetaboliteIndex( metabName1, mapListener );
        int metabIndex2 = getMetaboliteIndex( metabName2, mapListener );
        
        if( metabIndex1 != 289 && metabIndex2 != 289 )
        {
            ImageViewerPanel oldPnl = csimodelIn.getImageViewer( );
            csimodelIn.setImageViewer( this );
            mapListener.setColorMapfromjMRUIResultsRatio( metabIndex1, 0, 
                                                          metabIndex2, 0, false, 
                                                          "report-" + 
                                                          metabName1 + 
                                                          "/" + metabName2 );
            
            GlobalModel csimodel = new GlobalModel( csimodelIn );
            autoWindowing( );
            setModel( csimodel );
            csimodel.setGridTransparency( 0.0f );
            resetZoom( );
            focusOnExcitedVoxels( );
            getModel( ).clearVoxelSelection( );
            setMouseSelectionActive( false );
            csimodelIn.setImageViewer( oldPnl );
        }
        else
        {
            JLabel label1 = new JLabel( "<html><h1>Not Found!</h1></html>", SwingConstants.CENTER );
            label1.setBounds( this.getWidth( )/2 - 200, this.getHeight( ) / 2 - 10, 400, 100 );
            label1.setForeground( Color.red );
            this.add( label1 );
        }
        
        JLabel label1 = new JLabel( "<html><h1>" + metabName1 + " - " + metabName2 + "</h1></html>", SwingConstants.CENTER );
        label1.setVerticalAlignment( SwingConstants.CENTER );
        label1.setBounds( this.getWidth( )/2 - 200, 20, 400, 100 );
        label1.setForeground( Color.red );
        this.add( label1 );
    }
    
    private int getMetaboliteIndex( String metabName, 
                                    jMRUIResultsMapListener mapListener )
    {
        String[] names = mapListener.getMetabolitesNames( );
        int index = 289;
        for( int i = 0; i < names.length; i++ )
        {
            if( names[i].toUpperCase( ).contains( metabName.toUpperCase( ) ) )
                index = i;
        }
        return index;
    }
}
