/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.settings.processing;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import org.spectrim.settings.SettingsGUI;

/**
 *
 * @author nunopbarros
 */
public class QuantificationActionUI extends javax.swing.JDialog {

    QuantificationAction object;
    SettingsGUI parent;
    int number;
    File currentFile = new File("");

    private DefaultTableModel tablemodel;

    /**
     * Creates new form QuantificationActionUI.
     * @param parent
     * @param object
     * @param number
     */
    public QuantificationActionUI( SettingsGUI parent, QuantificationAction object, int number ) 
    {
        super( parent, true );
        
        if ( object.getQuantificationType( ).compareTo( QuantificationAction. QUANTIFICATION_TDFDFIT ) == 0 ) 
        {
            parent.addQuantificationActionUI( object, number );
            dispose( );
        }
        else
        {
            initComponents( );
            this.parent = parent;
            this.object = object;
            this.number = number;

            this.jTextFieldName.setText( object.getName( ) );
            this.jTextFieldMlFile.setText( object.getMlFile( ) );
            this.jTextFieldOpFile.setText( object.getOpFile( ) );

            this.jRadioButtonManual.setSelected( object.getMlFileSelectionMode( ) == QuantificationAction.MANUAL );
            this.jRadioButtonML.setSelected( object.getMlFileSelectionMode( ) == QuantificationAction.ML );
            this.jRadioButtonMRUI.setSelected( object.getMlFileSelectionMode( ) == QuantificationAction.MRUI );

            tablemodel = (DefaultTableModel) this.jTable1.getModel( );

            ArrayList<MruiFile> mruiFiles = object.getMruiFiles( );

            for ( MruiFile mrui : mruiFiles ) 
            {
                tablemodel.addRow( new Object[]{ mrui.isActive( ), mrui.getName( ), mrui.getSpins( ), mrui.getMruiFile( ) } );
            }

            this.jTable1.getSelectionModel( ).addListSelectionListener(new ListSelectionListener() {
                @Override
                public void valueChanged( ListSelectionEvent e ) 
                {
                    jButtonRemoveMruiFile.setEnabled( jRadioButtonMRUI.isSelected( ) && 
                                                      !jTable1.getSelectionModel( ).isSelectionEmpty( ) );
                }
            } );

            updateEnabledStatus( );
            pack( );
            setLocationRelativeTo( parent );
            setVisible( true );
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jTextFieldName = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldOpFile = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldMlFile = new javax.swing.JTextField();
        jRadioButtonML = new javax.swing.JRadioButton();
        jRadioButtonMRUI = new javax.swing.JRadioButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        jButtonCancel = new javax.swing.JButton();
        jButtonSave = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jSeparator2 = new javax.swing.JSeparator();
        jPanel2 = new javax.swing.JPanel();
        jButtonRemoveMruiFile = new javax.swing.JButton();
        jButtonAddMruiFile = new javax.swing.JButton();
        jRadioButtonManual = new javax.swing.JRadioButton();
        jButtonSelectMlFile = new javax.swing.JButton();
        jButtonSelectOpFile = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Quantification Action Editor");
        setMinimumSize(new java.awt.Dimension(100, 100));
        getContentPane().setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jTextFieldName, gridBagConstraints);

        jLabel1.setText("Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        getContentPane().add(jLabel1, gridBagConstraints);

        jLabel2.setText("QUEST options file (.op)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        getContentPane().add(jLabel2, gridBagConstraints);

        jTextFieldOpFile.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jTextFieldOpFile, gridBagConstraints);

        jLabel3.setText("Metabolite model file (.ml)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        getContentPane().add(jLabel3, gridBagConstraints);

        jTextFieldMlFile.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jTextFieldMlFile, gridBagConstraints);

        buttonGroup1.add(jRadioButtonML);
        jRadioButtonML.setText("Use .ml file (does not allow dynamic metabolite selection)");
        jRadioButtonML.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMLActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(15, 0, 0, 0);
        getContentPane().add(jRadioButtonML, gridBagConstraints);

        buttonGroup1.add(jRadioButtonMRUI);
        jRadioButtonMRUI.setText("Use .mrui files (allows dynamic selection of the metabolites that are used in each execution)");
        jRadioButtonMRUI.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMRUIActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(15, 0, 0, 0);
        getContentPane().add(jRadioButtonMRUI, gridBagConstraints);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Active", "Metabolite Name", "#Spins", "File (.mrui)"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Boolean.class, java.lang.String.class, java.lang.Integer.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                true, true, true, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable1.setColumnSelectionAllowed(true);
        jScrollPane1.setViewportView(jTable1);
        jTable1.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        if (jTable1.getColumnModel().getColumnCount() > 0) {
            jTable1.getColumnModel().getColumn(0).setPreferredWidth(50);
            jTable1.getColumnModel().getColumn(0).setMaxWidth(60);
            jTable1.getColumnModel().getColumn(1).setPreferredWidth(120);
            jTable1.getColumnModel().getColumn(1).setMaxWidth(180);
            jTable1.getColumnModel().getColumn(2).setPreferredWidth(60);
            jTable1.getColumnModel().getColumn(2).setMaxWidth(80);
        }

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        getContentPane().add(jScrollPane1, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(jButtonCancel, gridBagConstraints);

        jButtonSave.setText("Save");
        jButtonSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(jButtonSave, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(jPanel1, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 5, 0);
        getContentPane().add(jSeparator1, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        getContentPane().add(jSeparator2, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jButtonRemoveMruiFile.setText("Remove Selected File(s)");
        jButtonRemoveMruiFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRemoveMruiFileActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jButtonRemoveMruiFile, gridBagConstraints);

        jButtonAddMruiFile.setText("Add .mrui File(s)");
        jButtonAddMruiFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddMruiFileActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jButtonAddMruiFile, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        getContentPane().add(jPanel2, gridBagConstraints);

        buttonGroup1.add(jRadioButtonManual);
        jRadioButtonManual.setText("Select .ml file manually in each execution");
        jRadioButtonManual.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonManualActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(15, 0, 0, 0);
        getContentPane().add(jRadioButtonManual, gridBagConstraints);

        jButtonSelectMlFile.setText("Select File");
        jButtonSelectMlFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSelectMlFileActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        getContentPane().add(jButtonSelectMlFile, gridBagConstraints);

        jButtonSelectOpFile.setText("Select File");
        jButtonSelectOpFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSelectOpFileActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        getContentPane().add(jButtonSelectOpFile, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveActionPerformed
        if (jTextFieldName.getText().trim().matches("")) {
            JOptionPane.showMessageDialog(this, "Please provide a valid name.", "Invalid Name", JOptionPane.WARNING_MESSAGE);
            this.jTextFieldName.requestFocus();
        } else if (parent.isQuantificationActionNameRepeated(jTextFieldName.getText(), number)) {
            JOptionPane.showMessageDialog(this, "The chosen name is already in use.", "Invalid Name", JOptionPane.WARNING_MESSAGE);
            this.jTextFieldName.requestFocus();
        } else if (tablemodel.getRowCount() == 0 && this.jRadioButtonMRUI.isSelected()) {
            JOptionPane.showMessageDialog(this, "Please add an .mrui file for each metabolite to be considered in the metabolite model.", ".mrui file(s) not provided", JOptionPane.WARNING_MESSAGE);
            this.jButtonAddMruiFile.requestFocus();
        } else if (this.jTextFieldMlFile.getText().trim().matches("") && this.jRadioButtonML.isSelected()) {
            JOptionPane.showMessageDialog(this, "Please provide a metabolite model (.ml file).", ".ml file not provided", JOptionPane.WARNING_MESSAGE);
            this.jButtonSelectMlFile.requestFocus();
        } else {
            object.setName(jTextFieldName.getText().trim());
            if (this.jRadioButtonML.isSelected()) {
                object.setMlFileSelectionMode(QuantificationAction.ML);
            } else if (this.jRadioButtonMRUI.isSelected()) {
                object.setMlFileSelectionMode(QuantificationAction.MRUI);
            } else {
                object.setMlFileSelectionMode(QuantificationAction.MANUAL);
            }
            object.setMlFile(this.jTextFieldMlFile.getText());
            object.setOpFile(this.jTextFieldOpFile.getText());
            ArrayList<MruiFile> mruiFiles = new ArrayList<>();

            for (int i = 0; i < tablemodel.getRowCount(); i++) {
                mruiFiles.add(new MruiFile((String) tablemodel.getValueAt(i, 1),
                        (int) tablemodel.getValueAt(i, 2), (String) tablemodel.getValueAt(i, 3), (boolean) tablemodel.getValueAt(i, 0)));
            }
            object.setMruiFiles(mruiFiles);
            parent.addQuantificationActionUI(object, number);
            this.dispose();
        }
    }//GEN-LAST:event_jButtonSaveActionPerformed

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        this.dispose();
    }//GEN-LAST:event_jButtonCancelActionPerformed

    private void jButtonSelectOpFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSelectOpFileActionPerformed
        String file;
        if (object.getOpFile().matches("")) {
            file = parent.selectFile(currentFile.toString(), "op");
        } else {
            file = parent.selectFile(object.getOpFile(), "op");
        }
        if ((new File(file)).exists() && file.endsWith(".op")) {
            this.jTextFieldOpFile.setText(file);
            object.setOpFile(file);
            currentFile = (new File(file)).getParentFile();
        }
    }//GEN-LAST:event_jButtonSelectOpFileActionPerformed

    private void jButtonSelectMlFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSelectMlFileActionPerformed
        String file;
        if (object.getMlFile().matches("")) {
            file = parent.selectFile(currentFile.toString(), "ml");
        } else {
            file = parent.selectFile(object.getMlFile(), "ml");
        }
        if ((new File(file)).exists() && file.endsWith(".ml")) {
            this.jTextFieldMlFile.setText(file);
            object.setMlFile(file);
            currentFile = (new File(file)).getParentFile();
        }
    }//GEN-LAST:event_jButtonSelectMlFileActionPerformed

    private void jButtonAddMruiFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddMruiFileActionPerformed
        JFileChooser jFileChooser = new JFileChooser();
        jFileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        jFileChooser.setCurrentDirectory(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("mrui Files", "mrui".toUpperCase(), "mrui");
        jFileChooser.setFileFilter(filter);
        jFileChooser.setMultiSelectionEnabled(true);

        int returnVal = jFileChooser.showOpenDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File[] files = jFileChooser.getSelectedFiles();
            for (File file : files) {
                if (file.exists()) {
                    MruiFile mruiFile = new MruiFile(file.toString());
                    this.tablemodel.addRow(new Object[]{mruiFile.isActive(), mruiFile.getName(), mruiFile.getSpins(), file.toString()});
                    currentFile = file.getParentFile();
                }
            }
        }


    }//GEN-LAST:event_jButtonAddMruiFileActionPerformed

    private void jButtonRemoveMruiFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRemoveMruiFileActionPerformed
        
        int[] selection = this.jTable1.getSelectedRows( );
        for (int i = 0; i < selection.length; i++) 
        {
            selection[i] = jTable1.convertRowIndexToModel( selection[i] );
        }
        Arrays.sort( selection );
        for ( int i = ( selection.length - 1 ); i >= 0; i-- ) 
        {
            tablemodel.removeRow( selection[i] );
        }
    }//GEN-LAST:event_jButtonRemoveMruiFileActionPerformed

    private void jRadioButtonManualActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonManualActionPerformed
        updateEnabledStatus( );
    }//GEN-LAST:event_jRadioButtonManualActionPerformed

    private void jRadioButtonMLActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMLActionPerformed
        updateEnabledStatus( );
    }//GEN-LAST:event_jRadioButtonMLActionPerformed

    private void jRadioButtonMRUIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMRUIActionPerformed
        updateEnabledStatus( );
    }//GEN-LAST:event_jRadioButtonMRUIActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButtonAddMruiFile;
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonRemoveMruiFile;
    private javax.swing.JButton jButtonSave;
    private javax.swing.JButton jButtonSelectMlFile;
    private javax.swing.JButton jButtonSelectOpFile;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JRadioButton jRadioButtonML;
    private javax.swing.JRadioButton jRadioButtonMRUI;
    private javax.swing.JRadioButton jRadioButtonManual;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextFieldMlFile;
    private javax.swing.JTextField jTextFieldName;
    private javax.swing.JTextField jTextFieldOpFile;
    // End of variables declaration//GEN-END:variables

    private void updateEnabledStatus( )
    {
        this.jTextFieldMlFile.setEnabled( this.jRadioButtonML.isSelected( ) );
        this.jTable1.setEnabled( this.jRadioButtonMRUI.isSelected( ) );
        this.jButtonAddMruiFile.setEnabled( this.jRadioButtonMRUI.isSelected( ) );
        this.jButtonRemoveMruiFile.setEnabled( this.jRadioButtonMRUI.isSelected( ) && 
                                               !jTable1.getSelectionModel( ).isSelectionEmpty( ) );
    }

}
