/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.settings.processing;

import java.util.ArrayList;
import java.util.Arrays;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;
import org.spectrim.settings.ProcessingSettings;

/**
 *
 * @author nunopbarros
 */
public class ShiftCorrectionOptionsEditor extends JDialog {

    private DefaultTableModel tableModelLibrary;
    private DefaultTableModel tableModelUsed;
    PreprocessingActionUI parent;

    /**
     * Creates new form PopupShiftCorrection
     *
     * @param parent
     * @param usedPeaks
     * @param SNR
     * @param minPPM
     * @param maxPPM
     * @param maxLocalShift
     */
    public ShiftCorrectionOptionsEditor(PreprocessingActionUI parent, ArrayList<ReferencePeak> usedPeaks,
            double SNR, double minPPM, double maxPPM, double maxLocalShift) {
        super(parent, true);
        initComponents();
        this.parent = parent;
        tableModelLibrary = (DefaultTableModel) this.jTablePeaksLibrary.getModel();
        tableModelUsed = (DefaultTableModel) this.jTablePeaksUsed.getModel();

        for (ReferencePeak peak : usedPeaks) {
            this.tableModelUsed.addRow(new Object[]{peak.getName(), peak.getTargetppm(), peak.getMinppm(), peak.getMaxppm(), peak.getMultiplicity()});
        }

        for (ReferencePeak peak : ProcessingSettings.getInstance().getReferencePeaks()) {
            this.tableModelLibrary.addRow(new Object[]{peak.getName(), peak.getTargetppm(), peak.getMinppm(), peak.getMaxppm(), peak.getMultiplicity()});
        }

        jFormattedTextFieldSNRThreshold.setValue(SNR);
        jFormattedTextFieldMinPPM.setValue(minPPM);
        jFormattedTextFieldMaxPPM.setValue(maxPPM);
        jFormattedTextFieldMaxLocalShift.setValue(maxLocalShift);

        pack();
        setLocationRelativeTo(parent);
        setVisible(true);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jButtonMoreInfo = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jFormattedTextFieldSNRThreshold = new javax.swing.JFormattedTextField();
        jLabel2 = new javax.swing.JLabel();
        jFormattedTextFieldMinPPM = new javax.swing.JFormattedTextField();
        jFormattedTextFieldMaxPPM = new javax.swing.JFormattedTextField();
        jLabel4 = new javax.swing.JLabel();
        jFormattedTextFieldMaxLocalShift = new javax.swing.JFormattedTextField();
        jPanel2 = new javax.swing.JPanel();
        jButtonOK = new javax.swing.JButton();
        jButtonCancel = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTablePeaksLibrary = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        jButtonAddPeakLibrary = new javax.swing.JButton();
        jButtonDeletePeakLibrary = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jSeparator2 = new javax.swing.JSeparator();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTablePeaksUsed = new javax.swing.JTable();
        jLabel3 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jButtonUseSelectedPeaks = new javax.swing.JButton();
        jButtonDoNotUsePeaks = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Freq. Shift Correction Options");
        setAlwaysOnTop(true);
        setPreferredSize(new java.awt.Dimension(800, 500));
        getContentPane().setLayout(new java.awt.GridBagLayout());

        jButtonMoreInfo.setForeground(new java.awt.Color(0, 0, 204));
        jButtonMoreInfo.setText("More Info...");
        jButtonMoreInfo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMoreInfoActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(jButtonMoreInfo, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("SNR Threshold:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(jLabel1, gridBagConstraints);

        jFormattedTextFieldSNRThreshold.setText("10");
        jFormattedTextFieldSNRThreshold.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldSNRThresholdActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 44;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(jFormattedTextFieldSNRThreshold, gridBagConstraints);

        jLabel2.setText(" PPM range:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        jPanel1.add(jLabel2, gridBagConstraints);

        jFormattedTextFieldMinPPM.setText("0.5");
        jFormattedTextFieldMinPPM.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMinPPMActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 35;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(jFormattedTextFieldMinPPM, gridBagConstraints);

        jFormattedTextFieldMaxPPM.setText("3.4");
        jFormattedTextFieldMaxPPM.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMaxPPMActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 35;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 0);
        jPanel1.add(jFormattedTextFieldMaxPPM, gridBagConstraints);

        jLabel4.setText("Max Local Shift:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        jPanel1.add(jLabel4, gridBagConstraints);

        jFormattedTextFieldMaxLocalShift.setText("0.1");
        jFormattedTextFieldMaxLocalShift.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMaxLocalShiftActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 46;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(jFormattedTextFieldMaxLocalShift, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 0);
        getContentPane().add(jPanel1, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jButtonOK.setText("OK");
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jButtonOK, gridBagConstraints);

        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jButtonCancel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LAST_LINE_END;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(jPanel2, gridBagConstraints);

        jTablePeaksLibrary.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Name", "Target PPM", "Min PPM", "Max PPM", "Multiplicity"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Double.class, java.lang.Double.class, java.lang.Double.class, java.lang.Integer.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jScrollPane4.setViewportView(jTablePeaksLibrary);
        jTablePeaksLibrary.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        getContentPane().add(jScrollPane4, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        jButtonAddPeakLibrary.setText("Add new peak to Library");
        jButtonAddPeakLibrary.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddPeakLibraryActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel3.add(jButtonAddPeakLibrary, gridBagConstraints);

        jButtonDeletePeakLibrary.setText("Delete selected peaks from Library");
        jButtonDeletePeakLibrary.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDeletePeakLibraryActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel3.add(jButtonDeletePeakLibrary, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        getContentPane().add(jPanel3, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        getContentPane().add(jSeparator1, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        getContentPane().add(jSeparator2, gridBagConstraints);

        jTablePeaksUsed.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Name", "Target PPM", "Min PPM", "Max PPM", "Multiplicity"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Double.class, java.lang.Double.class, java.lang.Double.class, java.lang.Integer.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jScrollPane5.setViewportView(jTablePeaksUsed);
        jTablePeaksUsed.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        getContentPane().add(jScrollPane5, gridBagConstraints);

        jLabel3.setText("Reference Peaks Library:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LAST_LINE_START;
        getContentPane().add(jLabel3, gridBagConstraints);

        jLabel5.setText("Peaks Used for Alignment in Pre-Processing Action:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LAST_LINE_START;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(jLabel5, gridBagConstraints);

        jButtonUseSelectedPeaks.setText("Use selected peaks");
        jButtonUseSelectedPeaks.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonUseSelectedPeaksActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_END;
        getContentPane().add(jButtonUseSelectedPeaks, gridBagConstraints);

        jButtonDoNotUsePeaks.setText("Do not use selected peaks");
        jButtonDoNotUsePeaks.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDoNotUsePeaksActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_END;
        getContentPane().add(jButtonDoNotUsePeaks, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    protected void addRowTableModel(String name, double target, double min, double max, double multiplicity) {
        tableModelLibrary.addRow(new Object[]{name, target, min, max, multiplicity});
        if (tableModelLibrary.getRowCount() > 0) {
            jButtonOK.setEnabled(true);
        }
    }


    private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
        stopEditingTables();
        if (tableModelUsed.getRowCount() > 0) {
            ArrayList<ReferencePeak> usedPeaks = new ArrayList<>();
            ArrayList<ReferencePeak> libraryPeaks = new ArrayList<>();
            boolean everythingOK = true;
            for (int i = 0; i < this.tableModelLibrary.getRowCount(); i++) {
                ReferencePeak peakAux = new ReferencePeak((String) tableModelLibrary.getValueAt(i, 0),
                        (Double) tableModelLibrary.getValueAt(i, 1), (Double) tableModelLibrary.getValueAt(i, 2),
                        (Double) tableModelLibrary.getValueAt(i, 3), (Integer) tableModelLibrary.getValueAt(i, 4));
                if (peakAux.getMinppm() >= peakAux.getMaxppm()) {
                    everythingOK = false;
                    break;
                }
                libraryPeaks.add(peakAux);
            }

            for (int i = 0; i < this.tableModelUsed.getRowCount() && everythingOK; i++) {
                ReferencePeak peakAux = new ReferencePeak((String) tableModelUsed.getValueAt(i, 0),
                        (Double) tableModelUsed.getValueAt(i, 1), (Double) tableModelUsed.getValueAt(i, 2),
                        (Double) tableModelUsed.getValueAt(i, 3), (Integer) tableModelUsed.getValueAt(i, 4));
                if (peakAux.getMinppm() >= peakAux.getMaxppm()) {
                    everythingOK = false;
                    break;
                }
                usedPeaks.add(peakAux);
            }

            if (getMinPPM() >= getMaxPPM()) {
                everythingOK = false;
            }
            if (everythingOK) {
                parent.setFreqShiftCorrection(usedPeaks, getSNRthreshold(),
                        getMinPPM(), getMaxPPM(), getMaxLocalShift());
                ProcessingSettings.getInstance().setReferencePeaks(libraryPeaks);
                ProcessingSettings.getInstance().saveProperties();
                this.dispose();
            } else {
                JOptionPane.showMessageDialog(this, "Please check PPM ranges. Detected min values >= to max value of range.", "Invalid PPM ranges", JOptionPane.WARNING_MESSAGE);
            }
        } else {
            JOptionPane.showMessageDialog(this, "List of Reference Peaks used for alignment is empty.", "No Reference Peaks", JOptionPane.WARNING_MESSAGE);
        }
    }//GEN-LAST:event_jButtonOKActionPerformed

    private void jFormattedTextFieldSNRThresholdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldSNRThresholdActionPerformed

    }//GEN-LAST:event_jFormattedTextFieldSNRThresholdActionPerformed

    private void jFormattedTextFieldMinPPMActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMinPPMActionPerformed

    }//GEN-LAST:event_jFormattedTextFieldMinPPMActionPerformed

    private void jFormattedTextFieldMaxLocalShiftActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMaxLocalShiftActionPerformed

    }//GEN-LAST:event_jFormattedTextFieldMaxLocalShiftActionPerformed

    private void jFormattedTextFieldMaxPPMActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMaxPPMActionPerformed

    }//GEN-LAST:event_jFormattedTextFieldMaxPPMActionPerformed

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        this.dispose();
    }//GEN-LAST:event_jButtonCancelActionPerformed

    private void jButtonMoreInfoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMoreInfoActionPerformed
        JOptionPane.showMessageDialog(this,
                "<html>Frequency shift correction is an important pre-processing step to guarantee good results in quantification.<br>"
                + "This step should allow the user to bring the different metabolite peaks closer to the ppm value that these <br>"
                + "have in the metabolite model used. For this to happen the user can provide reference metabolite peaks that <br>"
                + "will be searched for in the provided intervals, and whose shift will be measured and considered for the aligment<br>"
                + "of the spectra. By pressing \"Use selected peaks\", the selected peaks from the Reference Peak Library are added<br>"
                + "to the list of peaks that will be used as reference for the alignment. To further tune the alignment, the user can<br>"
                + "change the different parameters of each peak, as well as the following parameters:<br><br>"
                + "<b>SNR Threshold:</b> minimum SNR value of a peak found in one of the target ppm intervals for its shift to be <br>"
                + "considered for aligment.<br>"
                + "<b>PPM range:</b> global range used to fine tune the alignment between the different spectra of an MRSI grid.<br>"
                + "(Should contain all important peaks. In water-suppressed spectra, the region close to the residual water peak <br>"
                + "should not be considered. Regions with no visible metabolites should also be excluded.)<br>"
                + "<b>Max Local Shift:</b> maximum absolute shift difference allowed between the different voxels of an MRSI grid.<br>"
                        + "<br><br>Note: The multiplicity column should be filled with 1, for singlets, 2, for doublets, etc.</html>", "Frequency Shift Correction", JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_jButtonMoreInfoActionPerformed

    private void jButtonAddPeakLibraryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddPeakLibraryActionPerformed
        tableModelLibrary.addRow(new Object[]{"New Peak", 0d, 0d, 0d, 1});
    }//GEN-LAST:event_jButtonAddPeakLibraryActionPerformed

    private void jButtonDeletePeakLibraryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDeletePeakLibraryActionPerformed
        int confirm = JOptionPane.showOptionDialog(this, "Delete selected items? (Changes will only affect the Reference Peak Library after pressing OK.)", "Delete Confirmation", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, null);
        if (confirm == 0) {
            int[] selection = this.jTablePeaksLibrary.getSelectedRows();
            for (int i = 0; i < selection.length; i++) {
                selection[i] = jTablePeaksLibrary.convertRowIndexToModel(selection[i]);
            }
            Arrays.sort(selection);
            for (int i = (selection.length - 1); i >= 0; i--) {
                tableModelLibrary.removeRow(selection[i]);
            }
        }
    }//GEN-LAST:event_jButtonDeletePeakLibraryActionPerformed

    private void jButtonUseSelectedPeaksActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonUseSelectedPeaksActionPerformed
        stopEditingTables();
        for (int i : this.jTablePeaksLibrary.getSelectedRows()) {
            this.tableModelUsed.addRow(new Object[]{tableModelLibrary.getValueAt(i, 0),
                tableModelLibrary.getValueAt(i, 1), tableModelLibrary.getValueAt(i, 2),
                tableModelLibrary.getValueAt(i, 3), tableModelLibrary.getValueAt(i, 4)});
        }
    }//GEN-LAST:event_jButtonUseSelectedPeaksActionPerformed

    private void jButtonDoNotUsePeaksActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDoNotUsePeaksActionPerformed
        int[] selection = this.jTablePeaksUsed.getSelectedRows();
        for (int i = 0; i < selection.length; i++) {
            selection[i] = jTablePeaksUsed.convertRowIndexToModel(selection[i]);
        }
        Arrays.sort(selection);
        for (int i = (selection.length - 1); i >= 0; i--) {
            tableModelUsed.removeRow(selection[i]);
        }
    }//GEN-LAST:event_jButtonDoNotUsePeaksActionPerformed

    private double getSNRthreshold() {
        return ((Number) this.jFormattedTextFieldSNRThreshold.getValue()).doubleValue();
    }

    private double getMinPPM() {
        return ((Number) this.jFormattedTextFieldMinPPM.getValue()).doubleValue();
    }

    private double getMaxPPM() {
        return ((Number) this.jFormattedTextFieldMaxPPM.getValue()).doubleValue();
    }

    private double getMaxLocalShift() {
        return ((Number) this.jFormattedTextFieldMaxLocalShift.getValue()).doubleValue();
    }

    private void stopEditingTables() {
        TableCellEditor editor = this.jTablePeaksLibrary.getCellEditor();
        if (editor != null) {
            editor.stopCellEditing();
        }
        editor = this.jTablePeaksUsed.getCellEditor();
        if (editor != null) {
            editor.stopCellEditing();
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAddPeakLibrary;
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonDeletePeakLibrary;
    private javax.swing.JButton jButtonDoNotUsePeaks;
    private javax.swing.JButton jButtonMoreInfo;
    protected javax.swing.JButton jButtonOK;
    private javax.swing.JButton jButtonUseSelectedPeaks;
    protected javax.swing.JFormattedTextField jFormattedTextFieldMaxLocalShift;
    protected javax.swing.JFormattedTextField jFormattedTextFieldMaxPPM;
    protected javax.swing.JFormattedTextField jFormattedTextFieldMinPPM;
    protected javax.swing.JFormattedTextField jFormattedTextFieldSNRThreshold;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JTable jTablePeaksLibrary;
    private javax.swing.JTable jTablePeaksUsed;
    // End of variables declaration//GEN-END:variables
}
