/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.spectra;

import org.spectrim.model.GlobalModel;
import java.util.HashMap;

/**
 *
 * @author nunopbarros
 */
public class FittedSpectra extends Spectra implements Cloneable 
{

    FittedSpectra( GlobalModel model, HashMap<String, Spectrum> data, 
                   int vectorsize, int zerofillingsize, double spectralWidth,
                   double resonanceFrequency, double ppmReference, int gridsize1, 
                   int gridsize2, int gridsize3, double[] xAxisTD,
                   double[] xAxisFDppm, double[] xAxisFDHz, double specScaleFD, 
                   HashMap<String, Double> qscores, Domain domain, 
                   CombinationFunction combfunc) 
    {
        super( model, data, vectorsize, zerofillingsize, spectralWidth, 
               resonanceFrequency, ppmReference, 
               gridsize1, gridsize2, gridsize3, xAxisTD,
               xAxisFDppm, xAxisFDHz, specScaleFD, 
               qscores, domain, combfunc, false );
    }

    @Override
    public FittedSpectra clone( ) 
    {
        return new FittedSpectra( model, data, vectorsize, zerofillingsize, 
                                  spectralWidth, resonanceFrequency, ppmReference, 
                                  gridsize1, gridsize2, gridsize3, xAxisTD,
                                  xAxisFDppm, xAxisFDHz, specScaleFD, qscores, 
                                  defaultDomain, defaultCombinationFunction );
    }

    @Override
    public void setSpectrum( float[] absFID, float[] dispFID, String ID ) 
    {
        if ( data.containsKey( ID ) ) 
        {
            float noiseFD = data.get( ID ).getNoiseStdDevFD( );
            float noiseTD = data.get( ID ).getNoiseStdDevTD( );
            double reference = data.get( ID ).getReference( );
            vectorsize = absFID.length;
            zerofillingsize = 0;
            Spectrum spct = new Spectrum( absFID, dispFID, this );
            spct.setNoiseStdFD( noiseFD );
            spct.setNoiseStdTD( noiseTD );
            spct.setReference( reference );
            data.put( ID,spct );
        }
    }
}
