/*
 * File: $Id: FitModelTreeListener.java,v 1.1.1.1 2006/04/19 09:38:49 hans Exp $
 * History
 * Date: 06.06.2003 2003, 1:57    Authors: Hans Slotboom
 * Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */
 

package org.spectrim.tdfdfit;

import javax.swing.event.TreeModelListener;
import javax.swing.event.TreeModelEvent;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 *
 * @author  hans
 */
public class FitModelTreeListener implements TreeModelListener 
{
    
    /** 
     * Creates a new instance of FitModelTreeListener 
     */
    public FitModelTreeListener( )
    {
    }
    
    @Override
    public void treeNodesChanged( TreeModelEvent e ) 
    {
        
        DefaultMutableTreeNode node;
        node = (DefaultMutableTreeNode)
                 ( e.getTreePath( ).getLastPathComponent( ) );
        
        /*
         * If the event lists children, then the changed
         * node is the child of the node we've already
         * gotten.  Otherwise, the changed node and the
         * specified node are the same.
         */
        try 
        {
            int index = e.getChildIndices( )[0];
            node = (DefaultMutableTreeNode)( node.getChildAt( index ) );
        }
        catch ( NullPointerException exc ) 
        {
            
        }
                
        System.out.println( "The user has finished editing the node." );
        System.out.println( "New value: " + node.getUserObject( ) );
    }
    
    @Override
    public void treeNodesInserted( TreeModelEvent treeModelEvent ) 
    {
        System.out.println("treeNodesInserted");
    }
    
    @Override
    public void treeNodesRemoved( TreeModelEvent treeModelEvent ) 
    {
        System.out.println("treeNodesRemoved");
    }
    
    @Override
    public void treeStructureChanged( TreeModelEvent treeModelEvent ) 
    {
        System.out.println("treeStructureChanged");
    }
    
}
