/*
 * FittingSumOfSpectrumSeriesRangeDefiner.java
 *
 * Created on March 6, 2006, 10:15 AM
 */

package org.spectrim.tdfdfit;

import java.util.LinkedList;
import java.util.Iterator;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


/**
 *
 * @author  hans
 */
public class FittingSumOfSpectrumSeriesRangeDefiner extends javax.swing.JFrame {
    
    /** Creates new form FittingSumOfSpectrumSeriesRangeDefiner */
    public FittingSumOfSpectrumSeriesRangeDefiner( int seriesSize ) 
    {
        initComponents();
        
        m_minimumValueDefinitionSlider.setMinimum(1);
        m_minimumValueDefinitionSlider.setMaximum(seriesSize);
        m_maximumValueDefinitionSlider.setMinimum(1);
        m_maximumValueDefinitionSlider.setMaximum(seriesSize);
        
        m_minimumValueDefinitionSlider.setValue(1);
        m_maximumValueDefinitionSlider.setValue(seriesSize);
        
        m_minimumValueDefinitionSlider.setMajorTickSpacing(10);
        m_minimumValueDefinitionSlider.setMinorTickSpacing(1);
        m_minimumValueDefinitionSlider.setPaintTicks(true);
        m_minimumValueDefinitionSlider.setPaintLabels(true);
        
        m_maximumValueDefinitionSlider.setMajorTickSpacing(10);
        m_maximumValueDefinitionSlider.setMinorTickSpacing(1);
        m_maximumValueDefinitionSlider.setPaintTicks(true);
        m_maximumValueDefinitionSlider.setPaintLabels(true);
        
        pack( );
        
        setVisible(true);
        
    }
    
    /**
     * Returns the minimum of the series range
     */
    public int getMinimumOfSeriesRange( )
    {
        return m_minimumValueDefinitionSlider.getValue( );
    }

    /**
     * Returns the minimum of the series range
     */
    public int getMaximumOfSeriesRange( )
    {
        return m_maximumValueDefinitionSlider.getValue( );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_maximumValueDefinitionSlider = new javax.swing.JSlider();
        m_minimumofRangeLabel = new javax.swing.JLabel();
        m_maximumOfRangeLabel = new javax.swing.JLabel();
        m_minimumValueDefinitionSlider = new javax.swing.JSlider();
        m_cancelButton = new javax.swing.JButton();
        m_okButton = new javax.swing.JButton();
        m_minimumTextField = new javax.swing.JTextField();
        m_maximumTextField = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Define Spectral Series Sum Range");

        m_maximumValueDefinitionSlider.setPaintLabels(true);
        m_maximumValueDefinitionSlider.setPaintTicks(true);
        m_maximumValueDefinitionSlider.setSnapToTicks(true);
        m_maximumValueDefinitionSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                m_maximumValueDefinitionSliderStateChanged(evt);
            }
        });

        m_minimumofRangeLabel.setText("Minimum spectrum number");

        m_maximumOfRangeLabel.setText(" Maximum spectrum number");

        m_minimumValueDefinitionSlider.setPaintLabels(true);
        m_minimumValueDefinitionSlider.setPaintTicks(true);
        m_minimumValueDefinitionSlider.setSnapToTicks(true);
        m_minimumValueDefinitionSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                m_minimumValueDefinitionSliderStateChanged(evt);
            }
        });

        m_cancelButton.setText("Cancel");
        m_cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_cancelButtonActionPerformed(evt);
            }
        });

        m_okButton.setText("OK");
        m_okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_okButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(layout.createSequentialGroup()
                                .add(m_maximumOfRangeLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 183, Short.MAX_VALUE)
                                .add(16, 16, 16)
                                .add(m_maximumValueDefinitionSlider, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 249, Short.MAX_VALUE))
                            .add(layout.createSequentialGroup()
                                .add(8, 8, 8)
                                .add(m_minimumofRangeLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 201, Short.MAX_VALUE)
                                .add(15, 15, 15)
                                .add(m_minimumValueDefinitionSlider, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                    .add(layout.createSequentialGroup()
                        .add(113, 113, 113)
                        .add(m_cancelButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE)
                        .add(90, 90, 90)
                        .add(m_okButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(40, 40, 40)))
                .add(22, 22, 22)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(m_minimumTextField)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, m_maximumTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 49, Short.MAX_VALUE))
                .add(33, 33, 33))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(44, 44, 44)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(m_minimumValueDefinitionSlider, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(layout.createSequentialGroup()
                                .add(m_minimumofRangeLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .add(10, 10, 10)))
                        .add(33, 33, 33))
                    .add(layout.createSequentialGroup()
                        .add(m_minimumTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_maximumValueDefinitionSlider, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(m_maximumOfRangeLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(10, 10, 10))
                    .add(m_maximumTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(35, 35, 35)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(m_cancelButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(m_okButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    
    /**
     * Is called whenever the user presses the Cancel button
     */
    private void m_cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_cancelButtonActionPerformed
        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, CANCEL_EVENT, "" ) );
        }
        dispose( );
    }//GEN-LAST:event_m_cancelButtonActionPerformed

    /**
     * Is called whenever the user presses the OK button
     */
    private void m_okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_okButtonActionPerformed
        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, OK_EVENT, "" ) );
        }
        dispose( );        // TODO add your handling code here:
    }//GEN-LAST:event_m_okButtonActionPerformed

    /**
     * Is called whenever the user moves the maximum value definition slider
     */
    private void m_maximumValueDefinitionSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_m_maximumValueDefinitionSliderStateChanged
        m_maximumValueDefinitionSlider.setToolTipText( "current value = " + m_maximumValueDefinitionSlider.getValue( ) );
        m_maximumTextField.setText( "" + m_maximumValueDefinitionSlider.getValue( ) );
    }//GEN-LAST:event_m_maximumValueDefinitionSliderStateChanged

    /**
     * Is called whenever the user moves the minimum value definition slider
     */
    private void m_minimumValueDefinitionSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_m_minimumValueDefinitionSliderStateChanged
        m_minimumValueDefinitionSlider.setToolTipText( "current value = " + m_minimumValueDefinitionSlider.getValue( ) );
        m_minimumTextField.setText( "" + m_minimumValueDefinitionSlider.getValue( ) );
    }//GEN-LAST:event_m_minimumValueDefinitionSliderStateChanged
    
    /**
     * Adds an actionlistener to the list of action listeners who are notified
     * when something happens within this object
     */
    public void addActionListener( ActionListener e )
    {
	m_listeners.add( e );
    } 
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FittingSumOfSpectrumSeriesRangeDefiner( 2 ).setVisible( true );
            }
        });
    }
    
    
    
    private LinkedList<ActionListener> m_listeners = new LinkedList<ActionListener>( );
    
    // Possible Events
    public final static int CANCEL_EVENT = 0;
    public final static int OK_EVENT = 1;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JButton m_cancelButton;
    public javax.swing.JLabel m_maximumOfRangeLabel;
    public javax.swing.JTextField m_maximumTextField;
    public javax.swing.JSlider m_maximumValueDefinitionSlider;
    public javax.swing.JTextField m_minimumTextField;
    public javax.swing.JSlider m_minimumValueDefinitionSlider;
    public javax.swing.JLabel m_minimumofRangeLabel;
    public javax.swing.JButton m_okButton;
    // End of variables declaration//GEN-END:variables
    
    // For proper serialization
    private static final long serialVersionUID = 6482324598121223L;
}
