/*
 * File: $Id: SingleVoxelSpectrumViewerFrame.java,v 1.1.1.1 2006/04/19 09:38:51 hans Exp $
 * History
 * Date: 04.03.2003  Authors: Hans Slotboom  
 *
 * Changes:
 *
 * Copyright (C) 2003-2006 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

/*
 * SingleVoxelSpectrumViewerFrame.java
 *
 * Created on April 5, 2006, 3:20 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.spectrim.tdfdfit;


import org.spectrim.lib.StatusPanel;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.JFrame;
import javax.swing.JPanel;
import org.spectrim.dicom.DicomDirectory;
import org.spectrim.model.GlobalModel;

/**
 *
 * @author hans
 */
public class SingleVoxelSpectrumViewerFrame extends JFrame
{
    
    /** 
     * Creates a new instance of SingleVoxelSpectrumViewerFrame. 
     * @param listLinkedList
     * @param ddir
     */
    public SingleVoxelSpectrumViewerFrame( LinkedList<SingleVoxelMeasuredSpectralData> listLinkedList, DicomDirectory ddir, GlobalModel model ) 
    {
        
        setDefaultCloseOperation( javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE );
        
        // Add window listener necessary to handle the window closing 
        // event properly
        addWindowListener( 
            new WindowAdapter( )
            {
                public void windowClosing( WindowEvent event )
                {
                   dispose( );
                }
            }
        );
        
        m_collectionPanel = new JPanel( );
        m_collectionPanel.setLayout( new BorderLayout( ) );
        
        m_svsViewer = new MRMeasuredClinicalSVSSpectrumViewer( "Single Voxel Data", this, ddir, model );
        
        Iterator it = listLinkedList.iterator( );
        int i = 1;
        while ( it.hasNext( ) )
        {
            SingleVoxelMeasuredSpectralData svsData = (SingleVoxelMeasuredSpectralData)it.next( );
            
            m_svsViewer.addSpectralDataSet( "" + i++, svsData, true );
        }
        
        m_collectionPanel.setMinimumSize( new Dimension( 300, 300 ) );
        m_collectionPanel.add( m_svsViewer );
        
        getContentPane( ).setLayout( new BorderLayout( ) );
        getContentPane( ).add( m_collectionPanel, BorderLayout.CENTER );
        
        m_svsViewer.enablePrinting( true );
        
        m_statusPanel = new StatusPanel( this );
        m_svsViewer.setStatusPanel( m_statusPanel );
        
        getContentPane( ).add( m_statusPanel, BorderLayout.SOUTH );
        
        pack( );
        
        setVisible( true );
        
    }
    
    
    // Attributes
    JPanel m_collectionPanel;
    private final MRMeasuredClinicalSVSSpectrumViewer m_svsViewer;
    private final StatusPanel m_statusPanel;
    
    // For proper serialization
    private static final long serialVersionUID = 9982236692319213L;
    
}
