/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.tdfdfit;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.io.File;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.KeyStroke;
import org.spectrim.tdfdfit.quantitativeresults.MetaboliteRelaxationTimesDatabase;

/**
 *
 * @author Johannes Slotboom <johannes.slotboom at insel.ch>
 */
public class TDFDFitDefaultRuntimeSettingsDefinitionFrame extends javax.swing.JFrame 
{


    /**
     * Creates new form TDFDFitDefaultRuntimeSettingsDefinitionFrame.
     * @param parent
     */
    public TDFDFitDefaultRuntimeSettingsDefinitionFrame( JFrame parent ) 
    {
        
        initComponents( );
        
        TDFDFittingDefaults fDefs = TDFDFittingDefaults.getInstance( );
        fDefs.load( );
        
        if ( fDefs.get( TDFDFittingDefaults.FittingTolerance ) == null )
        {
            fDefs.setProperty( TDFDFittingDefaults.FittingTolerance, "" + m_default_ftol );
            fDefs.save( );
        }
        double ftol = (new Double( "" + fDefs.get( TDFDFittingDefaults.FittingTolerance ) ) ).doubleValue( );
        m_fittingToleranceTextField.setText( "" + ftol );
        
        ///////////////////////////////////////////////////////////////////////
        if ( fDefs.get( TDFDFittingDefaults.FittingMode ) == null )
        {
            fDefs.setProperty( TDFDFittingDefaults.FittingMode, "" + m_default_fittingMode );
            fDefs.save( );
        }
        
        if ( ((String)( fDefs.get( TDFDFittingDefaults.FittingMode ) ) ).contains( "1" ) == true )
        {
            m_fittingModeComboBox.setSelectedIndex( 0 );
            m_numberOfLineshapeCoefficientsToFitTextField.setEditable(false);
        }
        if ( ((String)( fDefs.get( TDFDFittingDefaults.FittingMode ) ) ).contains( "2" ) == true )
        {
            m_fittingModeComboBox.setSelectedIndex( 1 );
            m_numberOfLineshapeCoefficientsToFitTextField.setEditable(false);
        }
        if ( ((String)( fDefs.get( TDFDFittingDefaults.FittingMode ) ) ).contains( "3" ) == true )
        {
            m_fittingModeComboBox.setSelectedIndex( 2 );
            m_numberOfLineshapeCoefficientsToFitTextField.setEditable( true );
        }
        
        ///////////////////////////////////////////////////////////////////////
        if ( fDefs.get( TDFDFittingDefaults.TDFDFitVerbosity ) == null )
        {
            fDefs.setProperty( TDFDFittingDefaults.TDFDFitVerbosity, "" + m_default_verbosity );
            fDefs.save( );
        }

        // Set the GUI
        if ( ((String)( fDefs.get( TDFDFittingDefaults.TDFDFitVerbosity ) ) ).compareTo( "0" ) == 0 )
        {
            m_verbosityComboBox.setSelectedIndex( 0 );
        }
        if ( ((String)( fDefs.get( TDFDFittingDefaults.TDFDFitVerbosity ) ) ).compareTo( "1" ) == 0 )
        {
            m_verbosityComboBox.setSelectedIndex( 1 );
        }
        if ( ((String)( fDefs.get( TDFDFittingDefaults.TDFDFitVerbosity ) ) ).compareTo( "2" ) == 0 )
        {
            m_verbosityComboBox.setSelectedIndex( 2 );
        }
        if ( ((String)( fDefs.get( TDFDFittingDefaults.TDFDFitVerbosity ) ) ).compareTo( "3" ) == 0 )
        {
            m_verbosityComboBox.setSelectedIndex( 3 );
        }
        if ( ((String)( fDefs.get( TDFDFittingDefaults.TDFDFitVerbosity ) ) ).compareTo( "4" ) == 0 )
        {
            m_verbosityComboBox.setSelectedIndex( 4 );
        }
        
        ////////////////////////////////////////////////////////////////////////
        if ( fDefs.get( TDFDFittingDefaults.ShowInfoOfComponent ) == null )
        {
            // Set the default value to 1 : a model should at least have 1 line.
            fDefs.setProperty( TDFDFittingDefaults.ShowInfoOfComponent, "" + 1 );
            fDefs.save( );
        }
        
        ///////////////////////////////////////////////////////////////////////
        if ( fDefs.get( TDFDFittingDefaults.ShowInfoOfComponent ) == null )
        {
            fDefs.setProperty( TDFDFittingDefaults.ShowInfoOfComponent, "" + 1 );
            fDefs.save( );
        }
        
        m_showLineNumberTextField.setText( fDefs.getProperty( TDFDFittingDefaults.ShowInfoOfComponent ) );
        
        ///////////////////////////////////////////////////////////////////////
        if ( fDefs.get( TDFDFittingDefaults.CalculateErrorsAfterFit ) == null )
        {
            fDefs.setProperty( TDFDFittingDefaults.CalculateErrorsAfterFit, "no" );
            fDefs.save( );
        }
        
        if ( ((String)fDefs.get( TDFDFittingDefaults.CalculateErrorsAfterFit ) ).compareTo( "yes" ) == 0 )
        {
            m_calcErrorsComboBox.setSelectedIndex( 1 );
        }
        else
        {
            m_calcErrorsComboBox.setSelectedIndex( 0 );
        }
        
        if ( fDefs.get( TDFDFittingDefaults.NumberOfLineShapeFourierCoefficientsToFit ) == null )
        {
             fDefs.setProperty( TDFDFittingDefaults.NumberOfLineShapeFourierCoefficientsToFit, "" + m_defaultNumberOfFourierCoefficientsToFit ); 
             fDefs.save( );
        }
        else
        {
            m_numberOfLineshapeCoefficientsToFitTextField.setText( "" + fDefs.get( TDFDFittingDefaults.NumberOfLineShapeFourierCoefficientsToFit ) );
        }
        
        // Initialize second tab
        // Read the possibly avaiable preset values, and show them
        m_patientDatabasePathValue.setText( fDefs.getProperty( TDFDFittingDefaults.PATIENT_DATABASE_ROOT_PATH, System.getProperty( "user.dir" ) ) );
        m_tdfdfitInstallationPathValue.setText( fDefs.getProperty( TDFDFittingDefaults.TDFDFIT_INSTALLATION_PATH, System.getProperty( "user.dir" ) ) );
        m_tdfdfitModelsBasePathValue.setText( fDefs.getProperty( TDFDFittingDefaults.TDFDFIT_MODELS_BASE_PATH, System.getProperty( "user.dir" ) ) );
        m_tdfdfitExecutableNameValue.setText( fDefs.getProperty( TDFDFittingDefaults.TDFDFIT_EXECUTABLE_NAME, System.getProperty( "user.dir" ) ) );
        m_tdfdfitRelaxationTimeDataBaseFileReferenceValue.setText( fDefs.getProperty( TDFDFittingDefaults.TDFDFIT_RELAXATION_TIMES_DATABASE_PATH_AND_FILE, System.getProperty( "user.dir" ) ) );
        m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue.setText( fDefs.getProperty( TDFDFittingDefaults.TDFDFIT_NORMAL_VALUES_CONCENTRATIONS_PATH, System.getProperty( "user.dir" ) ) );
    
        // Initialize the third tab
        
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        
        String dBasePath= tdfdFitDefaults.getProperty( TDFDFittingDefaults.PATIENT_DATABASE_ROOT_PATH );
        this.m_currentPatientDirectoryValueLabel.setText( dBasePath );
        
        m_deleteDotParFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_PAR );
        if ( m_deleteDotParFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        else
        {
            if ( m_deleteDotParFile.compareTo( "yes" ) == 0 )
            {
                this.m_deleteDotParFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteVerboseDotParFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_VERBOSE_PAR );
        if ( m_deleteVerboseDotParFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        else
        {
            if ( m_deleteVerboseDotParFile.compareTo( "yes" ) == 0 )
            {
                this.m_deleteVerboseParFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteDotParFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_PAR );
        if ( m_deleteDotParFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        else
        {
            if ( m_deleteDotParFile.compareTo( "yes" ) == 0 )
            {
                this.m_deleteDotParFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN );
        if ( m_deleteBinFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        else
        {
            if ( m_deleteBinFile.compareTo( "yes" ) == 0 )
            {
                this.m_deleteDotBinFileCheckBox.setSelected( true );
            }
        }
    
        m_deleteBinFitFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT );
        if ( m_deleteBinFitFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT, "no" );
        }
        else
        {
            if ( m_deleteBinFitFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotFitFileCheckBox.setSelected( true );
            }
        }
        
        
        m_deleteBinFit0File = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT0 );
        if ( m_deleteBinFit0File == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "no" );
        }
        else
        {
            if ( m_deleteBinFit0File.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotFit0FileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinOrgFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ORG );
        if ( m_deleteBinOrgFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ORG, "no" );
        }
        else
        {
            if ( m_deleteBinOrgFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotOrgFileCheckBox.setSelected( true );
            }
        }
        
        
        m_deleteBinFitresFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FITRES );
        if ( m_deleteBinFitresFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "no" );
        }
        else
        {
            if ( m_deleteBinFitresFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotFitResFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinResFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_RES );
        if ( m_deleteBinResFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_RES, "no" );
        }
        else
        {
            if ( m_deleteBinResFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotResFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinCororgFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_CORORG );
        if ( m_deleteBinCororgFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "no" );
        }
        else
        {
            if ( m_deleteBinCororgFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotCorOrgFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinExlFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_EXL );
        if ( m_deleteBinExlFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_EXL, "no" );
        }
        else
        {
            if ( m_deleteBinExlFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotExlFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinNLN0File = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_NLN0 );
        if ( m_deleteBinNLN0File == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "no" );
        }
        else
        {
            if ( m_deleteBinNLN0File.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotnln0FileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinMatFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_MAT );
        if ( m_deleteBinMatFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_MAT, "no" );
        }
        else
        {
            if ( m_deleteBinMatFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotMatFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinErrFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ERR );
        if ( m_deleteBinErrFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ERR, "no" );
        }
        else
        {
            if ( m_deleteBinErrFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotErrFileCheckBox.setSelected( true );
            }
        }
       
        
        // ==================================================================
        // Single file storage handling
        // ==================================================================


        m_store2OneBinFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN );
        if ( m_store2OneBinFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        else
        {
            if ( m_store2OneBinFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinFileCheckBox2.setSelected( true );
            }
        }

        m_store2OneBinFitFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT );
        if ( m_store2OneBinFitFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT, "no" );
        }
        else
        {
            if ( m_store2OneBinFitFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotFitFileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinFit0File = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT0 );
        if ( m_store2OneBinFit0File == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "no" );
        }
        else
        {
            if ( m_store2OneBinFit0File.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotFit0FileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinOrgFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ORG );
        if ( m_store2OneBinOrgFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ORG, "no" );
        }
        else
        {
            if ( m_store2OneBinOrgFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotOrgFileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinFitresFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FITRES );
        if ( m_store2OneBinFitresFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "no" );
        }
        else
        {
            if ( m_store2OneBinFitresFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotFitResFileCheckBox.setSelected( true );
            }
        }
        
        m_store2OneBinResFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_RES );
        if ( m_store2OneBinResFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_RES, "no" );
        }
        else
        {
            if ( m_store2OneBinResFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotResFileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinCororgFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_CORORG );
        if ( m_store2OneBinCororgFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "no" );
        }
        else
        {
            if ( m_store2OneBinCororgFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinExlFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_EXL );
        if ( m_store2OneBinExlFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_EXL, "no" );
        }
        else
        {
            if ( m_store2OneBinExlFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotExlFileCheckBox1.setSelected( true );
            }
        }
        
        m_store2OneBinNLN0File = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_NLN0 );
        if ( m_store2OneBinNLN0File == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "no" );
        }
        else
        {
            if ( m_store2OneBinNLN0File.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotnln0FileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinMatFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_MAT );
        if ( m_store2OneBinMatFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_MAT, "no" );
        }
        else
        {
            if ( m_store2OneBinMatFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotMatFileCheckBox1.setSelected( true );
            }
        }
        
        m_store2OneBinErrFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ERR );
        if ( m_store2OneBinErrFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ERR, "no" );
        }
        else
        {
            if ( m_store2OneBinErrFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotErrFileCheckBox1.setSelected( true );
            }
        }
        // Save the changes in the settings file.
        tdfdFitDefaults.save( );

        // Put the dialog nicely in the middle of its parent
        
        
        
        Point centerParent;
        centerParent = new Point( parent.getX( ) + ( parent.getWidth( ) / 2 ) - this.getWidth( ) / 2,
                                  parent.getY( ) + ( parent.getHeight( ) / 2 ) - this.getHeight( ) / 2 );
        
        setTitle( "TDFDFit runtime settings" );
        
        setLocation( centerParent );
        setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );
        
        
        getRootPane( ).setDefaultButton( m_applyNewTDFDFitRuntimeValuesButton );
        
        Action applyAndExit = new AbstractAction( ) 
        {
            @Override
            public void actionPerformed( ActionEvent e ) 
            {
                applySettings( );
            }
        };

        Action exitWithoutChange = new AbstractAction( ) 
        {
            @Override
            public void actionPerformed( ActionEvent e )
            {
               dispose( );
            }
        };

        getRootPane( ).getInputMap( ).put( KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0),
                                            "applyAndExit" );
        
        getRootPane( ).getActionMap( ).put( "applyAndExit",
                                            applyAndExit  );

        getRootPane( ).getInputMap( ).put( KeyStroke.getKeyStroke( KeyEvent.VK_ESCAPE, 0),
                                           "Cancel and quit" );
        
        getRootPane( ).getActionMap( ).put( "Cancel and quit",
                                            exitWithoutChange );
       
        
        setVisible( true );
        this.pack( );
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        m_applyNewTDFDFitRuntimeValuesButton = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel3 = new javax.swing.JPanel();
        m_tdfdfitLInstallationPathLabel = new javax.swing.JLabel();
        m_tdfdfitInstallationPathValue = new javax.swing.JLabel();
        m_changeTDFDFitInstallationPathButton1 = new javax.swing.JButton();
        m_patientDatabsePathLabel = new javax.swing.JLabel();
        m_patientDatabasePathValue = new javax.swing.JLabel();
        m_changePatientDatabasePathButton = new javax.swing.JButton();
        m_changeTDFDFitModelsBasePathButton = new javax.swing.JButton();
        m_tdfdfitModelsBasePathValue = new javax.swing.JLabel();
        m_tfdfitProjectPathLabel = new javax.swing.JLabel();
        m_tdfdfitExecutableNameLabel = new javax.swing.JLabel();
        m_tdfdfitExecutableNameValue = new javax.swing.JLabel();
        m_changeTDFDFitExecutableNameButton = new javax.swing.JButton();
        m_tdfdfitRelaxationTimeDataBaseFileReferenceValueLabel = new javax.swing.JLabel();
        m_tdfdfitRelaxationTimeDataBaseFileReferenceValue = new javax.swing.JLabel();
        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton = new javax.swing.JButton();
        m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValueLabel = new javax.swing.JLabel();
        m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue = new javax.swing.JLabel();
        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton1 = new javax.swing.JButton();
        m_baselineNodesBaseDirectoryLabel = new javax.swing.JLabel();
        m_baselineNodesBaseDirectoryValue = new javax.swing.JLabel();
        m_splineNodeModelRootDirectory = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        m_deleteAfterFittingPanel = new javax.swing.JPanel();
        m_deleteDotBinFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotFitFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotFit0FileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotFitResFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotResFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotOrgFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotCorOrgFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotnln0FileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotMatFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotErrFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotExlFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotParFileCheckBox = new javax.swing.JCheckBox();
        m_deleteVerboseParFileCheckBox = new javax.swing.JCheckBox();
        m_storeToOneOutputFilePanel = new javax.swing.JPanel();
        m_storeToOneOutputFileDotBinDotFitResFileCheckBox = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotFit0FileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotResFileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotOrgFileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotnln0FileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotMatFileCheckBox1 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotErrFileCheckBox1 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotExlFileCheckBox1 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinFileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotFitFileCheckBox2 = new javax.swing.JCheckBox();
        jPanel5 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        m_currentPatientDirectoryLabel = new javax.swing.JLabel();
        m_currentPatientDirectoryValueLabel = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        m_deletePatientDirectoryButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        m_fittingToleranceLabel = new javax.swing.JLabel();
        m_fittingToleranceTextField = new javax.swing.JTextField();
        m_fitModeLabel = new javax.swing.JLabel();
        m_fittingModeComboBox = new javax.swing.JComboBox<>();
        jLabel1 = new javax.swing.JLabel();
        m_verbosityComboBox = new javax.swing.JComboBox<>();
        jLabel2 = new javax.swing.JLabel();
        m_showLineNumberTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        m_calcErrorsComboBox = new javax.swing.JComboBox<>();
        jLabel4 = new javax.swing.JLabel();
        m_numberOfLineshapeCoefficientsToFitTextField = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(1024, 720));
        setPreferredSize(new java.awt.Dimension(1024, 720));

        jPanel2.setMinimumSize(new java.awt.Dimension(1000, 680));
        jPanel2.setPreferredSize(new java.awt.Dimension(1000, 680));

        m_applyNewTDFDFitRuntimeValuesButton.setText("Apply and quit");
        m_applyNewTDFDFitRuntimeValuesButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applyNewTDFDFitRuntimeValuesButtonActionPerformed(evt);
            }
        });
        jPanel2.add(m_applyNewTDFDFitRuntimeValuesButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        jTabbedPane1.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jTabbedPane1.setMinimumSize(new java.awt.Dimension(940, 631));
        jTabbedPane1.setPreferredSize(new java.awt.Dimension(940, 631));

        m_tdfdfitLInstallationPathLabel.setText("TDFDFit installation path    :");

        m_tdfdfitInstallationPathValue.setText("tdfdfit installation path goes here!");

        m_changeTDFDFitInstallationPathButton1.setText("Change");
        m_changeTDFDFitInstallationPathButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_changeTDFDFitInstallationPathButton1ActionPerformed(evt);
            }
        });

        m_patientDatabsePathLabel.setText("Patient database root path  :");

        m_patientDatabasePathValue.setText("patient database path goes here!");

        m_changePatientDatabasePathButton.setText("Change");
        m_changePatientDatabasePathButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_changePatientDatabasePathButtonActionPerformed(evt);
            }
        });

        m_changeTDFDFitModelsBasePathButton.setText("Change");
        m_changeTDFDFitModelsBasePathButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_changeTDFDFitModelsBasePathButtonActionPerformed(evt);
            }
        });

        m_tdfdfitModelsBasePathValue.setText("tdfdfit model path goes here!");

        m_tfdfitProjectPathLabel.setText("TDFDFit models root path   :");

        m_tdfdfitExecutableNameLabel.setText("TDFDFit executable name   :");

        m_tdfdfitExecutableNameValue.setText("tdfdfit executable name goes here!");

        m_changeTDFDFitExecutableNameButton.setText("Change");
        m_changeTDFDFitExecutableNameButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_changeTDFDFitExecutableNameButtonActionPerformed(evt);
            }
        });

        m_tdfdfitRelaxationTimeDataBaseFileReferenceValueLabel.setText("TDFDFit T1, T2 dBase path  :");

        m_tdfdfitRelaxationTimeDataBaseFileReferenceValue.setText("tdfdfit model path goes here!");

        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton.setText("Change");
        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_tdfdfitRelaxationTimeDataBaseFileReferenceButtonActionPerformed(evt);
            }
        });

        m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValueLabel.setText("TDFDFit normal metabolite concentration path  :");

        m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue.setText("tdfdfit normal metabolite values goes here");

        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton1.setText("Change");
        m_tdfdfitRelaxationTimeDataBaseFileReferenceButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_tdfdfitRelaxationTimeDataBaseFileReferenceButton1ActionPerformed(evt);
            }
        });

        m_baselineNodesBaseDirectoryLabel.setText("Baseline spline model root path :");

        m_baselineNodesBaseDirectoryValue.setText("baseline spline node panel goes here!");

        m_splineNodeModelRootDirectory.setText("Change");
        m_splineNodeModelRootDirectory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_splineNodeModelRootDirectoryActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValueLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue, javax.swing.GroupLayout.DEFAULT_SIZE, 398, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceButton1))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceValueLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceValue, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceButton))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addComponent(m_tfdfitProjectPathLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_tdfdfitModelsBasePathValue, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_changeTDFDFitModelsBasePathButton))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addComponent(m_patientDatabsePathLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_patientDatabasePathValue, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_changePatientDatabasePathButton))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(m_tdfdfitLInstallationPathLabel)
                                .addGap(18, 18, 18)
                                .addComponent(m_tdfdfitInstallationPathValue, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(m_tdfdfitExecutableNameLabel)
                                .addGap(18, 18, 18)
                                .addComponent(m_tdfdfitExecutableNameValue, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_changeTDFDFitExecutableNameButton)
                            .addComponent(m_changeTDFDFitInstallationPathButton1)))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(m_baselineNodesBaseDirectoryLabel)
                        .addGap(18, 18, 18)
                        .addComponent(m_baselineNodesBaseDirectoryValue, javax.swing.GroupLayout.DEFAULT_SIZE, 473, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_splineNodeModelRootDirectory)))
                .addGap(260, 260, 260))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(31, 31, 31)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_tdfdfitLInstallationPathLabel)
                    .addComponent(m_tdfdfitInstallationPathValue)
                    .addComponent(m_changeTDFDFitInstallationPathButton1))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_tdfdfitExecutableNameLabel)
                    .addComponent(m_tdfdfitExecutableNameValue)
                    .addComponent(m_changeTDFDFitExecutableNameButton))
                .addGap(11, 11, 11)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_patientDatabsePathLabel)
                    .addComponent(m_patientDatabasePathValue)
                    .addComponent(m_changePatientDatabasePathButton))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_tfdfitProjectPathLabel)
                    .addComponent(m_tdfdfitModelsBasePathValue)
                    .addComponent(m_changeTDFDFitModelsBasePathButton))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceValueLabel)
                    .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceValue)
                    .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceButton))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValueLabel)
                    .addComponent(m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue)
                    .addComponent(m_tdfdfitRelaxationTimeDataBaseFileReferenceButton1))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_baselineNodesBaseDirectoryLabel)
                    .addComponent(m_baselineNodesBaseDirectoryValue)
                    .addComponent(m_splineNodeModelRootDirectory))
                .addContainerGap(304, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("TDFDFit path settings", jPanel3);

        m_deleteAfterFittingPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Delete TDFDFit output file types"));

        m_deleteDotBinFileCheckBox.setText("[Filename].bin");
        m_deleteDotBinFileCheckBox.setEnabled(false);
        m_deleteDotBinFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotFitFileCheckBox.setText("[Filename].fit");
        m_deleteDotBinDotFitFileCheckBox.setEnabled(false);
        m_deleteDotBinDotFitFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotFitFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotFit0FileCheckBox.setText("[Filename].fit0");
        m_deleteDotBinDotFit0FileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotFit0FileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotFitResFileCheckBox.setText("[Filename].fitres");
        m_deleteDotBinDotFitResFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotFitResFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotResFileCheckBox.setText("[Filename].bin.res");
        m_deleteDotBinDotResFileCheckBox.setEnabled(false);
        m_deleteDotBinDotResFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotResFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotOrgFileCheckBox.setText("[Filename].org");
        m_deleteDotBinDotOrgFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotOrgFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotCorOrgFileCheckBox.setText("[Filename].cororg");
        m_deleteDotBinDotCorOrgFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotCorOrgFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotnln0FileCheckBox.setText("[Filename].nln0");
        m_deleteDotBinDotnln0FileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotnln0FileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotMatFileCheckBox.setText("[Filename].mat");
        m_deleteDotBinDotMatFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotMatFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotErrFileCheckBox.setText("[Filename].err");
        m_deleteDotBinDotErrFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotErrFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotExlFileCheckBox.setText("[Filename].exl");
        m_deleteDotBinDotExlFileCheckBox.setEnabled(false);
        m_deleteDotBinDotExlFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotExlFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotParFileCheckBox.setText("[Filename].par");
        m_deleteDotParFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotParFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteVerboseParFileCheckBox.setText("[Filename]verbose.par");
        m_deleteVerboseParFileCheckBox.setEnabled(false);
        m_deleteVerboseParFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteVerboseParFileCheckBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout m_deleteAfterFittingPanelLayout = new javax.swing.GroupLayout(m_deleteAfterFittingPanel);
        m_deleteAfterFittingPanel.setLayout(m_deleteAfterFittingPanelLayout);
        m_deleteAfterFittingPanelLayout.setHorizontalGroup(
            m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                        .addComponent(m_deleteDotBinDotResFileCheckBox)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                        .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_deleteDotBinDotFitFileCheckBox)
                            .addComponent(m_deleteDotBinDotFitResFileCheckBox)
                            .addComponent(m_deleteDotBinDotOrgFileCheckBox)
                            .addComponent(m_deleteDotBinDotFit0FileCheckBox)
                            .addComponent(m_deleteDotBinFileCheckBox))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 399, Short.MAX_VALUE)
                        .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_deleteDotBinDotExlFileCheckBox)
                            .addComponent(m_deleteDotBinDotCorOrgFileCheckBox)
                            .addComponent(m_deleteDotBinDotnln0FileCheckBox)
                            .addComponent(m_deleteDotBinDotMatFileCheckBox)
                            .addComponent(m_deleteDotBinDotErrFileCheckBox))
                        .addGap(125, 125, 125)
                        .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_deleteDotParFileCheckBox)
                            .addComponent(m_deleteVerboseParFileCheckBox))))
                .addContainerGap())
        );
        m_deleteAfterFittingPanelLayout.setVerticalGroup(
            m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                        .addGap(37, 37, 37)
                        .addComponent(m_deleteDotBinDotFitFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotFitResFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotOrgFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotFit0FileCheckBox))
                    .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                        .addComponent(m_deleteDotParFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteVerboseParFileCheckBox))
                    .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                        .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(m_deleteDotBinDotCorOrgFileCheckBox)
                            .addComponent(m_deleteDotBinFileCheckBox))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotExlFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotnln0FileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotMatFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotErrFileCheckBox)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(m_deleteDotBinDotResFileCheckBox)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_storeToOneOutputFilePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Store MRSI TDFDFit result data in one file"));

        m_storeToOneOutputFileDotBinDotFitResFileCheckBox.setText("[Filename].bin.fitres");
        m_storeToOneOutputFileDotBinDotFitResFileCheckBox.setEnabled(false);
        m_storeToOneOutputFileDotBinDotFitResFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotFitResFileCheckBoxActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotFit0FileCheckBox2.setText("[Filename].bin.fit0");
        m_storeToOneOutputFileDotBinDotFit0FileCheckBox2.setEnabled(false);
        m_storeToOneOutputFileDotBinDotFit0FileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotFit0FileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotResFileCheckBox2.setText("[Filename].bin.res");
        m_storeToOneOutputFileDotBinDotResFileCheckBox2.setEnabled(false);
        m_storeToOneOutputFileDotBinDotResFileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotResFileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotOrgFileCheckBox2.setText("[Filename].bin.org");
        m_storeToOneOutputFileDotBinDotOrgFileCheckBox2.setEnabled(false);
        m_storeToOneOutputFileDotBinDotOrgFileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotOrgFileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2.setText("[Filename].bin.cororg");
        m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2.setEnabled(false);
        m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotnln0FileCheckBox2.setText("[Filename].bin.nln0");
        m_storeToOneOutputFileDotBinDotnln0FileCheckBox2.setEnabled(false);
        m_storeToOneOutputFileDotBinDotnln0FileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotnln0FileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotMatFileCheckBox1.setText("[Filename].bin.mat");
        m_storeToOneOutputFileDotBinDotMatFileCheckBox1.setEnabled(false);
        m_storeToOneOutputFileDotBinDotMatFileCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotMatFileCheckBox1ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotErrFileCheckBox1.setText("[Filename].bin.err");
        m_storeToOneOutputFileDotBinDotErrFileCheckBox1.setEnabled(false);
        m_storeToOneOutputFileDotBinDotErrFileCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotErrFileCheckBox1ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotExlFileCheckBox1.setSelected(true);
        m_storeToOneOutputFileDotBinDotExlFileCheckBox1.setText("[Filename].bin.exl");
        m_storeToOneOutputFileDotBinDotExlFileCheckBox1.setEnabled(false);
        m_storeToOneOutputFileDotBinDotExlFileCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotExlFileCheckBox1ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinFileCheckBox2.setSelected(true);
        m_storeToOneOutputFileDotBinFileCheckBox2.setText("[Filename].bin");
        m_storeToOneOutputFileDotBinFileCheckBox2.setEnabled(false);
        m_storeToOneOutputFileDotBinFileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinFileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotFitFileCheckBox2.setSelected(true);
        m_storeToOneOutputFileDotBinDotFitFileCheckBox2.setText("[Filename].bin.fit");
        m_storeToOneOutputFileDotBinDotFitFileCheckBox2.setEnabled(false);
        m_storeToOneOutputFileDotBinDotFitFileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotFitFileCheckBox2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout m_storeToOneOutputFilePanelLayout = new javax.swing.GroupLayout(m_storeToOneOutputFilePanel);
        m_storeToOneOutputFilePanel.setLayout(m_storeToOneOutputFilePanelLayout);
        m_storeToOneOutputFilePanelLayout.setHorizontalGroup(
            m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_storeToOneOutputFilePanelLayout.createSequentialGroup()
                .addGap(98, 98, 98)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_storeToOneOutputFileDotBinDotResFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotFit0FileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotFitFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotOrgFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotFitResFileCheckBox))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_storeToOneOutputFileDotBinDotErrFileCheckBox1)
                    .addComponent(m_storeToOneOutputFileDotBinDotMatFileCheckBox1)
                    .addComponent(m_storeToOneOutputFileDotBinDotnln0FileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotExlFileCheckBox1))
                .addGap(168, 168, 168))
        );
        m_storeToOneOutputFilePanelLayout.setVerticalGroup(
            m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_storeToOneOutputFilePanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_storeToOneOutputFileDotBinFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_storeToOneOutputFileDotBinDotFitFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotExlFileCheckBox1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_storeToOneOutputFileDotBinDotFit0FileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotnln0FileCheckBox2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_storeToOneOutputFileDotBinDotOrgFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotMatFileCheckBox1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_storeToOneOutputFileDotBinDotFitResFileCheckBox)
                    .addComponent(m_storeToOneOutputFileDotBinDotErrFileCheckBox1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(m_storeToOneOutputFileDotBinDotResFileCheckBox2)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("Delete all results in patient output directory"));

        m_currentPatientDirectoryLabel.setText("Patient output file directory :");

        m_currentPatientDirectoryValueLabel.setText("Patient output folder not defined!");

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_currentPatientDirectoryLabel)
                .addGap(18, 18, 18)
                .addComponent(m_currentPatientDirectoryValueLabel)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_currentPatientDirectoryLabel)
                    .addComponent(m_currentPatientDirectoryValueLabel))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_deletePatientDirectoryButton.setText("Delete all files in patient output file directory");
        m_deletePatientDirectoryButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deletePatientDirectoryButtonActionPerformed(evt);
            }
        });
        jPanel7.add(m_deletePatientDirectoryButton);

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jPanel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(m_storeToOneOutputFilePanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(m_deleteAfterFittingPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_deleteAfterFittingPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_storeToOneOutputFilePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("TDFDFit output file handling", jPanel4);

        m_fittingToleranceLabel.setText("Fitting tolerance");
        m_fittingToleranceLabel.setToolTipText("Tolerance of conjugate gradients minimization algorithm.");

        m_fittingToleranceTextField.setText("1.0E-007");
        m_fittingToleranceTextField.setToolTipText("Tolerance of conjugate gradients minimization algorithm.");

        m_fitModeLabel.setText("Fitting mode");

        m_fittingModeComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "1. - Normal fit.", "2. - Reference linshape fit.", "3. - Line shape fourier coefficients." }));
        m_fittingModeComboBox.setToolTipText("<html> In which fit mode tdfdfit should operate <BR>   fitmode = 1 : no reference lineshape fit : straight forward parameter fit  <BR>    fitmode = 2 : a reference lineshape is expected having the name  <b>filenametofit.ref</b>  <BR>    fitmode = 3 : line shape fourier coefficients are determined in this mode </html>");

        jLabel1.setText("Verbosity");

        m_verbosityComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0. - No output at all.", "1. - Minimal text output.", "2. - Function and derivative information provided. ", "3. - More detailed information provided.", "4. - Most information provided (useful during modelling)." }));

        jLabel2.setText("Show line#");
        jLabel2.setToolTipText("Show parameter information of line# during fitting if verbosity setting > 1.");

        m_showLineNumberTextField.setText("1");
        m_showLineNumberTextField.setToolTipText("Show parameter information of line# during fitting if verbosity setting > 1.");

        jLabel3.setText("Calculate errors");

        m_calcErrorsComboBox.setEditable(true);
        m_calcErrorsComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "no", "yes" }));

        jLabel4.setText("Number of lineshape coefficients ");

        m_numberOfLineshapeCoefficientsToFitTextField.setText("10");
        m_numberOfLineshapeCoefficientsToFitTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_numberOfLineshapeCoefficientsToFitTextFieldActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_fittingToleranceLabel)
                    .addComponent(m_fitModeLabel)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 311, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(1, 1, 1)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(m_fittingModeComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(m_fittingToleranceTextField)
                            .addComponent(m_verbosityComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(m_showLineNumberTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 351, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(m_calcErrorsComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(m_numberOfLineshapeCoefficientsToFitTextField))
                .addGap(157, 157, 157))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(46, 46, 46)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_fittingToleranceLabel)
                    .addComponent(m_fittingToleranceTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_fitModeLabel)
                    .addComponent(m_fittingModeComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(m_verbosityComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(m_showLineNumberTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(m_calcErrorsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(m_numberOfLineshapeCoefficientsToFitTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("TDFDFit runtime", jPanel1);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.PAGE_START);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_applyNewTDFDFitRuntimeValuesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applyNewTDFDFitRuntimeValuesButtonActionPerformed
        
        applySettings( );
    }//GEN-LAST:event_m_applyNewTDFDFitRuntimeValuesButtonActionPerformed

    private void applySettings( )
    {
        TDFDFittingDefaults fDefs = TDFDFittingDefaults.getInstance( );
        fDefs.load( );
        if ( isNumeric( m_fittingToleranceTextField.getText( ) ) == true )
        {
            fDefs.setProperty( TDFDFittingDefaults.FittingTolerance , "" + new Double( m_fittingToleranceTextField.getText( ) ) );
        }
        else
        {
             fDefs.setProperty( TDFDFittingDefaults.FittingTolerance , "1.0E-007" );
        }
        
        if ( isNumeric( this.m_numberOfLineshapeCoefficientsToFitTextField.getText( ) ) == true )
        {
            fDefs.setProperty( TDFDFittingDefaults.NumberOfLineShapeFourierCoefficientsToFit , "" + new Integer( m_numberOfLineshapeCoefficientsToFitTextField.getText( ) ) );
        }
        else
        {
             fDefs.setProperty( TDFDFittingDefaults.NumberOfLineShapeFourierCoefficientsToFit , "0" );
        }
        
        fDefs.setProperty( TDFDFittingDefaults.FittingMode, "" + ( m_fittingModeComboBox.getSelectedIndex( ) + 1 ) );
        fDefs.setProperty( TDFDFittingDefaults.TDFDFitVerbosity, "" + m_verbosityComboBox.getSelectedIndex( ) );
        
        if ( isNumeric( m_showLineNumberTextField.getText( ) ) == true )
        {
            fDefs.setProperty( TDFDFittingDefaults.ShowInfoOfComponent , "" + new Integer( m_showLineNumberTextField.getText( ) ) );
        }
        
        if ( m_calcErrorsComboBox.getSelectedIndex( ) == 1 )
        {        
            fDefs.setProperty( TDFDFittingDefaults.CalculateErrorsAfterFit, "yes" );
        }
        else
        {
            fDefs.setProperty( TDFDFittingDefaults.CalculateErrorsAfterFit, "no" );
        }
        
        // make persistent
        fDefs.save( );
        this.dispose( );
    }
    
    
    
    
    
    
    private void m_numberOfLineshapeCoefficientsToFitTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_numberOfLineshapeCoefficientsToFitTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_numberOfLineshapeCoefficientsToFitTextFieldActionPerformed

    private void m_changeTDFDFitInstallationPathButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_changeTDFDFitInstallationPathButton1ActionPerformed
        defineTDFDFitInstallationPath( );
    }//GEN-LAST:event_m_changeTDFDFitInstallationPathButton1ActionPerformed

    private void m_changePatientDatabasePathButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_changePatientDatabasePathButtonActionPerformed
        definePatientDatabaseRootPath( );
    }//GEN-LAST:event_m_changePatientDatabasePathButtonActionPerformed

    private void m_changeTDFDFitModelsBasePathButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_changeTDFDFitModelsBasePathButtonActionPerformed
        defineTDFDModelsBasePath( );
    }//GEN-LAST:event_m_changeTDFDFitModelsBasePathButtonActionPerformed

    private void m_changeTDFDFitExecutableNameButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_changeTDFDFitExecutableNameButtonActionPerformed
        defineTDFDFitExecutableName( );
    }//GEN-LAST:event_m_changeTDFDFitExecutableNameButtonActionPerformed

    private void m_tdfdfitRelaxationTimeDataBaseFileReferenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_tdfdfitRelaxationTimeDataBaseFileReferenceButtonActionPerformed
        defineTDFDFitRelaxationTimesDatabaseFileReference( );
    }//GEN-LAST:event_m_tdfdfitRelaxationTimeDataBaseFileReferenceButtonActionPerformed

    private void m_tdfdfitRelaxationTimeDataBaseFileReferenceButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_tdfdfitRelaxationTimeDataBaseFileReferenceButton1ActionPerformed
        defineTDFDFitNormalMetaboliteValueDatabasePath( );
    }//GEN-LAST:event_m_tdfdfitRelaxationTimeDataBaseFileReferenceButton1ActionPerformed

    private void m_deleteDotBinFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinFileCheckBoxActionPerformed

        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        
        if ( m_deleteDotBinFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinFileCheckBoxActionPerformed

    private void m_deleteDotBinDotFitFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotFitFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotFitFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotFitFileCheckBoxActionPerformed

    private void m_deleteDotBinDotFit0FileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotFit0FileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotFit0FileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotFit0FileCheckBoxActionPerformed

    private void m_deleteDotBinDotFitResFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotFitResFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotFitResFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotFitResFileCheckBoxActionPerformed

    private void m_deleteDotBinDotResFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotResFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotResFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_RES, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_RES, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotResFileCheckBoxActionPerformed

    private void m_deleteDotBinDotOrgFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotOrgFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotOrgFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ORG, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ORG, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotOrgFileCheckBoxActionPerformed

    private void m_deleteDotBinDotCorOrgFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotCorOrgFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotCorOrgFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotCorOrgFileCheckBoxActionPerformed

    private void m_deleteDotBinDotnln0FileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotnln0FileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotnln0FileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotnln0FileCheckBoxActionPerformed

    private void m_deleteDotBinDotMatFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotMatFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotMatFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_MAT, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_MAT, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotMatFileCheckBoxActionPerformed

    private void m_deleteDotBinDotErrFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotErrFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotErrFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ERR, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ERR, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotErrFileCheckBoxActionPerformed

    private void m_deleteDotBinDotExlFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotExlFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotExlFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_EXL, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_EXL, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotExlFileCheckBoxActionPerformed

    private void m_deleteDotParFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotParFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if (  m_deleteDotParFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_PAR, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_PAR, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotParFileCheckBoxActionPerformed

    private void m_deleteVerboseParFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteVerboseParFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if (  this.m_deleteVerboseParFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_VERBOSE_PAR, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_VERBOSE_PAR, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteVerboseParFileCheckBoxActionPerformed

    private void m_storeToOneOutputFileDotBinDotFitResFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotFitResFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinDotFitResFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotFitResFileCheckBoxActionPerformed

    private void m_storeToOneOutputFileDotBinDotFit0FileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotFit0FileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinDotFit0FileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotFit0FileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotResFileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotResFileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinDotResFileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_RES, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_RES, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotResFileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotOrgFileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotOrgFileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinDotOrgFileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ORG, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ORG, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotOrgFileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotnln0FileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotnln0FileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if (  m_storeToOneOutputFileDotBinDotnln0FileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotnln0FileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotMatFileCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotMatFileCheckBox1ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        
        if (  m_storeToOneOutputFileDotBinDotMatFileCheckBox1.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_MAT, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_MAT, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotMatFileCheckBox1ActionPerformed

    private void m_storeToOneOutputFileDotBinDotErrFileCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotErrFileCheckBox1ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if (  m_storeToOneOutputFileDotBinDotErrFileCheckBox1.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ERR, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ERR, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotErrFileCheckBox1ActionPerformed

    private void m_storeToOneOutputFileDotBinDotExlFileCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotExlFileCheckBox1ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if (  m_storeToOneOutputFileDotBinDotExlFileCheckBox1.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_EXL, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_EXL, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotExlFileCheckBox1ActionPerformed

    private void m_storeToOneOutputFileDotBinFileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinFileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinFileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinFileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotFitFileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotFitFileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinDotFitFileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotFitFileCheckBox2ActionPerformed

    private void m_deletePatientDirectoryButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deletePatientDirectoryButtonActionPerformed
        
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        String patDataBasePath = tdfdFitDefaults.getProperty( TDFDFittingDefaults.PATIENT_DATABASE_ROOT_PATH );
        
        File patientDataBaseFolder = new File( patDataBasePath );
        if ( patientDataBaseFolder.exists( ) )
        {
            File[] filesInFolder = patientDataBaseFolder.listFiles( );
            
            
            int dialogButton = JOptionPane.YES_NO_OPTION;
            JOptionPane.showConfirmDialog( this, "You are about to delete " + filesInFolder.length + " files.\n Are you sure?","WARNING", dialogButton );
            if( dialogButton == JOptionPane.YES_OPTION ) 
            {
                for ( int i = 0; i < filesInFolder.length; i++ )
                {
                    filesInFolder[i].delete( );
                }
            }
            if ( dialogButton == JOptionPane.NO_OPTION ) 
            {
                  remove( dialogButton );
            }
        }
        
    }//GEN-LAST:event_m_deletePatientDirectoryButtonActionPerformed

    private void m_splineNodeModelRootDirectoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_splineNodeModelRootDirectoryActionPerformed
        
        
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultPathString = fdef.getProperty( TDFDFittingDefaults.BASELINE_SPLINE_MODEL_PATH );
        
        File baseLineSplineModelRootPath;
        if ( defaultPathString != null )
        {
            baseLineSplineModelRootPath = new File( defaultPathString );
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !baseLineSplineModelRootPath.exists( ) )
            {
                defaultPathString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultPathString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultPathString );
        
        fileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                
                                                def.setProperty( TDFDFittingDefaults.BASELINE_SPLINE_MODEL_PATH, selected_dir.getPath( ) );
                                                m_baselineNodesBaseDirectoryValue.setText( selected_dir.getPath( ) );
                                                def.save( );
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }

    }//GEN-LAST:event_m_splineNodeModelRootDirectoryActionPerformed
    
    
    /**
     * Defines the path where the TDFDFit executable is installed. 
     */
    private File defineTDFDFitInstallationPath( )
    {
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultPathString = fdef.getProperty( TDFDFittingDefaults.TDFDFIT_INSTALLATION_PATH );
        
        File defaultPatientDBRootPath;
        
        if ( defaultPathString != null )
        {   
            defaultPatientDBRootPath = new File( defaultPathString );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultPatientDBRootPath.exists( ) )
            {
                defaultPathString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultPathString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultPathString );
        
        fileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                
                                                def.setProperty( TDFDFittingDefaults.TDFDFIT_INSTALLATION_PATH, selected_dir.getPath( ) );
                                                m_tdfdfitInstallationPathValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_tdfdftExcutableInstallationPathSet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    
    
    /**
     * Defines the path in which the patient database is stored.
     */
    private File definePatientDatabaseRootPath( )
    {
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultPathString = fdef.getProperty( TDFDFittingDefaults.PATIENT_DATABASE_ROOT_PATH );
        
        File defaultPatientDBRootPath;
        if ( defaultPathString != null )
        {
            defaultPatientDBRootPath= new File( defaultPathString );
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultPatientDBRootPath.exists( ) )
            {
                defaultPathString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultPathString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultPathString );
        
        fileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                
                                                def.setProperty( "Patient database root path", selected_dir.getPath( ) );
                                                m_patientDatabasePathValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_patientDBDirectorySet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    
    /**
     * Defines the base path where the TDFDFit models are stored. 
     */
    private File defineTDFDModelsBasePath( )
    {
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultPathString = fdef.getProperty( TDFDFittingDefaults.TDFDFIT_MODELS_BASE_PATH );
        
        File defaultTDFDFitModelsPath;
        
        if ( defaultPathString != null )
        {   
            defaultTDFDFitModelsPath = new File( defaultPathString );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultTDFDFitModelsPath.exists( ) )
            {
                defaultPathString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultPathString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultPathString );
        
        fileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                def.setProperty( TDFDFittingDefaults.TDFDFIT_MODELS_BASE_PATH, selected_dir.getPath( ) );
                                                m_tdfdfitModelsBasePathValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_tdfdfitModelsBasePathDefined = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    
    
    /**
     * Defines the name of the TDFDFit executable. 
     */
    private File defineTDFDFitExecutableName( )
    {
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultPathString = fdef.getProperty( TDFDFittingDefaults.TDFDFIT_INSTALLATION_PATH );
        
        File defaultPatientDBRootPath;
        
        if ( defaultPathString != null )
        {   
            defaultPatientDBRootPath = new File( defaultPathString );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultPatientDBRootPath.exists( ) )
            {
                defaultPathString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultPathString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultPathString );
        
        fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_file = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_file = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                def.setProperty( TDFDFittingDefaults.TDFDFIT_EXECUTABLE_NAME, selected_file.getName( ) );
                                                m_tdfdfitExecutableNameValue.setText( selected_file.getPath( ) );
                                                def.save( );
                                                if ( selected_file != null )
                                                {
                                                    m_tdfdftExcutableNameSet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_file;
    }
    
    /**
     * Defines the base path where the relaxation times are stored. 
     */
    private File defineTDFDFitRelaxationTimesDatabaseFileReference( )
    {
        
        MetaboliteRelaxationTimesDatabase relaxationTimesDbase = MetaboliteRelaxationTimesDatabase.getInstance( );
        
        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultRelaxationTimesDBaseString = fdef.getProperty( TDFDFittingDefaults.TDFDFIT_RELAXATION_TIMES_DATABASE_PATH_AND_FILE );
        
        File defaultRelaxationTimesDBaseFileRef = new File( defaultRelaxationTimesDBaseString );
        
        if ( defaultRelaxationTimesDBaseFileRef != null )
        {   
            defaultRelaxationTimesDBaseFileRef = new File( defaultRelaxationTimesDBaseString );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultRelaxationTimesDBaseFileRef.exists( ) )
            {
                
                defaultRelaxationTimesDBaseString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultRelaxationTimesDBaseString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultRelaxationTimesDBaseString );
        
        fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                def.setProperty( TDFDFittingDefaults.TDFDFIT_RELAXATION_TIMES_DATABASE_PATH_AND_FILE, selected_dir.getPath( ) );
                                                m_tdfdfitRelaxationTimeDataBaseFileReferenceValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_tdfdfitRelaxationTimeDataBaseFileReferenceSet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    
    /**
     * Defines the path to the location in the file system where the metabolite
     * normal values are located.
     * @return 
     */
    private File defineTDFDFitNormalMetaboliteValueDatabasePath( )
    {

        TDFDFittingDefaults fdef = TDFDFittingDefaults.getInstance( );
        fdef.load( );
        
        String defaultNormalValueConcentrationsTimesDBaseString = fdef.getProperty( TDFDFittingDefaults.TDFDFIT_NORMAL_VALUES_CONCENTRATIONS_PATH );
        
        File defaultNormalValueConcentrationDBaseFileRef = new File( defaultNormalValueConcentrationsTimesDBaseString );
        
        if ( defaultNormalValueConcentrationDBaseFileRef != null )
        {   
            defaultNormalValueConcentrationDBaseFileRef = new File( defaultNormalValueConcentrationsTimesDBaseString );
        
            // check whether previous directory was deleted ; if yes set path back to
            // user.home directory
            if ( !defaultNormalValueConcentrationDBaseFileRef.exists( ) )
            {
                defaultNormalValueConcentrationsTimesDBaseString = System.getProperty( "user.home" );
            }
        }
        else
        {
            defaultNormalValueConcentrationsTimesDBaseString = System.getProperty( "user.home" );
        }
        
        JFileChooser fileChooser = new JFileChooser( defaultNormalValueConcentrationsTimesDBaseString );
        
        fileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        
        int result = fileChooser.showOpenDialog( this );
        
        File selected_dir = new File( "" );
        
        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                
                                                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                                                def.load( );
                                                
                                                def.setProperty( TDFDFittingDefaults.TDFDFIT_NORMAL_VALUES_CONCENTRATIONS_PATH, selected_dir.getPath( ) );
                                                m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue.setText( selected_dir.getPath( ) );
                                                def.save( );
                                                if ( selected_dir != null )
                                                {
                                                    m_tdfdfitNormalConcentrationValueDatabaseSet = true;
                                                }
            
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }
        
        return selected_dir;
    }
    
    
    /**
     * Returns whether a String is numeric or not.
     * @param str
     * @return 
     */
    private boolean isNumeric( String strNum ) 
    {
        boolean ret = true;
        try 
        {

            Double.parseDouble( strNum );

        }
        catch ( NumberFormatException e ) 
        {
            ret = false;
        }
        
        return ret;
}
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(TDFDFitDefaultRuntimeSettingsDefinitionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(TDFDFitDefaultRuntimeSettingsDefinitionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(TDFDFitDefaultRuntimeSettingsDefinitionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(TDFDFitDefaultRuntimeSettingsDefinitionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new TDFDFitDefaultRuntimeSettingsDefinitionFrame().setVisible(true);
//            }
//        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton m_applyNewTDFDFitRuntimeValuesButton;
    private javax.swing.JLabel m_baselineNodesBaseDirectoryLabel;
    private javax.swing.JLabel m_baselineNodesBaseDirectoryValue;
    private javax.swing.JComboBox<String> m_calcErrorsComboBox;
    private javax.swing.JButton m_changePatientDatabasePathButton;
    private javax.swing.JButton m_changeTDFDFitExecutableNameButton;
    private javax.swing.JButton m_changeTDFDFitInstallationPathButton1;
    private javax.swing.JButton m_changeTDFDFitModelsBasePathButton;
    private javax.swing.JLabel m_currentPatientDirectoryLabel;
    private javax.swing.JLabel m_currentPatientDirectoryValueLabel;
    private javax.swing.JPanel m_deleteAfterFittingPanel;
    private javax.swing.JCheckBox m_deleteDotBinDotCorOrgFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotErrFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotExlFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotFit0FileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotFitFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotFitResFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotMatFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotOrgFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotResFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotnln0FileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotParFileCheckBox;
    private javax.swing.JButton m_deletePatientDirectoryButton;
    private javax.swing.JCheckBox m_deleteVerboseParFileCheckBox;
    private javax.swing.JLabel m_fitModeLabel;
    private javax.swing.JComboBox<String> m_fittingModeComboBox;
    private javax.swing.JLabel m_fittingToleranceLabel;
    private javax.swing.JTextField m_fittingToleranceTextField;
    private javax.swing.JTextField m_numberOfLineshapeCoefficientsToFitTextField;
    private javax.swing.JLabel m_patientDatabasePathValue;
    private javax.swing.JLabel m_patientDatabsePathLabel;
    private javax.swing.JTextField m_showLineNumberTextField;
    private javax.swing.JButton m_splineNodeModelRootDirectory;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotErrFileCheckBox1;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotExlFileCheckBox1;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotFit0FileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotFitFileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotFitResFileCheckBox;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotMatFileCheckBox1;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotOrgFileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotResFileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotnln0FileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinFileCheckBox2;
    private javax.swing.JPanel m_storeToOneOutputFilePanel;
    private javax.swing.JLabel m_tdfdfitExecutableNameLabel;
    private javax.swing.JLabel m_tdfdfitExecutableNameValue;
    private javax.swing.JLabel m_tdfdfitInstallationPathValue;
    private javax.swing.JLabel m_tdfdfitLInstallationPathLabel;
    private javax.swing.JLabel m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValue;
    private javax.swing.JLabel m_tdfdfitMetaboliteNormalValuesBaseFileReferenceValueLabel;
    private javax.swing.JLabel m_tdfdfitModelsBasePathValue;
    private javax.swing.JButton m_tdfdfitRelaxationTimeDataBaseFileReferenceButton;
    private javax.swing.JButton m_tdfdfitRelaxationTimeDataBaseFileReferenceButton1;
    private javax.swing.JLabel m_tdfdfitRelaxationTimeDataBaseFileReferenceValue;
    private javax.swing.JLabel m_tdfdfitRelaxationTimeDataBaseFileReferenceValueLabel;
    private javax.swing.JLabel m_tfdfitProjectPathLabel;
    private javax.swing.JComboBox<String> m_verbosityComboBox;
    // End of variables declaration//GEN-END:variables

    // Attributes
    private double      m_default_ftol         = 1.0E-7;
    private int         m_default_fittingMode  = 0;
    private int         m_default_verbosity    = 0;
    private int         m_defaultNumberOfFourierCoefficientsToFit = 10;
    
    private boolean     m_patientDBDirectorySet = false;
    private boolean     m_tdfdftExcutableInstallationPathSet = false;
    private boolean     m_tdfdfitModelsBasePathDefined = false;
    private boolean     m_tdfdftExcutableNameSet = false;
    private boolean     m_tdfdfitRelaxationTimeDataBaseFileReferenceSet = false;
    private boolean     m_tdfdfitNormalConcentrationValueDatabaseSet = false;
    
    private String m_deleteDotParFile;
    private final String m_deleteVerboseDotParFile;
    
    
    private final String m_deleteBinFile;
    private final String m_deleteBinFitFile;
    private final String m_deleteBinFit0File;
    private final String m_deleteBinOrgFile;
    private final String m_deleteBinFitresFile;
    private final String m_deleteBinResFile;
    private final String m_deleteBinCororgFile;
    private final String m_deleteBinExlFile;
    private final String m_deleteBinNLN0File;
    private final String m_deleteBinMatFile;
    private final String m_deleteBinErrFile;
    
    private final String m_store2OneBinFile;
    private final String m_store2OneBinFitFile;
    private final String m_store2OneBinFit0File;
    private final String m_store2OneBinOrgFile;
    private final String m_store2OneBinFitresFile;
    private final String m_store2OneBinResFile;
    private final String m_store2OneBinCororgFile;
    private final String m_store2OneBinExlFile;
    private final String m_store2OneBinNLN0File;
    private final String m_store2OneBinMatFile;
    private final String m_store2OneBinErrFile;

}