/*
 * TimeSeriesQuantificationOptionsDefiner.java
 *
 * Created on October 25, 2006, 10:35 AM
 */

package org.spectrim.tdfdfit;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.JFrame;

/**
 *
 * @author  hans
 */
public class TimeSeriesQuantificationOptionsDefiner extends javax.swing.JFrame {
    
    /** Creates new form TimeSeriesQuantificationOptionsDefiner */
    public TimeSeriesQuantificationOptionsDefiner( JFrame parent ) 
    {
        initComponents( );
         
        // Put the Dialog nicely in the middle of its parent
        Point parentLoc = parent.getLocation( );
        Point centerParent = new Point( parent.getX( ) + parent.getWidth( ) / 2,
                                        parent.getY( ) + parent.getHeight( ) / 2 );
	
        setLocation( centerParent );
        setVisible( true );
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_filteringTypeButtonGroup = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        m_movingMedianFilter = new javax.swing.JRadioButton();
        m_movingAverageFilter = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        m_filterSizeSelector = new javax.swing.JSpinner();
        m_simpleAveragingFilter = new javax.swing.JRadioButton();
        jPanel2 = new javax.swing.JPanel();
        m_applyButton = new javax.swing.JButton();
        m_cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        m_filteringTypeButtonGroup.add(m_movingMedianFilter);
        m_movingMedianFilter.setText("Moving median");
        m_movingMedianFilter.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        m_movingMedianFilter.setMargin(new java.awt.Insets(0, 0, 0, 0));

        m_filteringTypeButtonGroup.add(m_movingAverageFilter);
        m_movingAverageFilter.setSelected(true);
        m_movingAverageFilter.setText("Moving average");
        m_movingAverageFilter.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        m_movingAverageFilter.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jLabel1.setText("Filter size");

        m_filterSizeSelector.setValue(1);

        m_filteringTypeButtonGroup.add(m_simpleAveragingFilter);
        m_simpleAveragingFilter.setSelected(true);
        m_simpleAveragingFilter.setText("Simple Average ");
        m_simpleAveragingFilter.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        m_simpleAveragingFilter.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(m_simpleAveragingFilter)
                        .add(69, 69, 69)
                        .add(m_movingMedianFilter)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 65, Short.MAX_VALUE)
                        .add(m_movingAverageFilter))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_filterSizeSelector, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 347, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .add(19, 19, 19)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(m_filterSizeSelector, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 48, Short.MAX_VALUE)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_movingMedianFilter)
                    .add(m_movingAverageFilter)
                    .add(m_simpleAveragingFilter))
                .add(27, 27, 27))
        );

        m_applyButton.setText("Apply");
        m_applyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applyButtonActionPerformed(evt);
            }
        });

        m_cancelButton.setText("Cancel");
        m_cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_cancelButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(44, 44, 44)
                .add(m_cancelButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 200, Short.MAX_VALUE)
                .add(m_applyButton)
                .add(61, 61, 61))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_applyButton)
                    .add(m_cancelButton))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_applyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applyButtonActionPerformed
        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, APPLY_EVENT, "" ) );
        }
        dispose( );
    }//GEN-LAST:event_m_applyButtonActionPerformed

    private void m_cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_cancelButtonActionPerformed
        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, CANCEL_EVENT, "" ) );
        }
        dispose( );
    }//GEN-LAST:event_m_cancelButtonActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        dispose( );
    }//GEN-LAST:event_formWindowClosing
    
    /**
     * Returns the filter size defined by the user
     */
    public int getFilterSize( )
    {
        return ((Integer)m_filterSizeSelector.getValue( )).intValue( );
    }
    
     /**
     * Returns the filter type defined by the user
     */
    public int getFilterType( )
    {
        
        int returnValue = -1;
        
        if ( m_movingMedianFilter.isSelected() == true )
        {
            returnValue = MOVING_MEDIAN_FILTERING;
        }
        if ( this.m_movingAverageFilter.isSelected( ) == true  )
        {
            returnValue = MOVING_AVERAGE_FILTERING;
        }
        if ( this.m_simpleAveragingFilter.isSelected( ) == true  )
        {
            returnValue = this.SIMPLE_AVERAGE_FILTERING;
        }
        
        return returnValue;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main( String args[] ) 
    {
        java.awt.EventQueue.invokeLater(new Runnable( ) 
        {
            public void run() 
            {
                new TimeSeriesQuantificationOptionsDefiner( null ).setVisible( true );
            }
        });
    }
    
    // own code
    
    /**
     * Adds an actionlistener to the list of action listeners who are notified
     * when something happens within this object
     */
    public void addActionListener( ActionListener e )
    {
	m_listeners.add( e );
    } 
    
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton m_applyButton;
    private javax.swing.JButton m_cancelButton;
    private javax.swing.JSpinner m_filterSizeSelector;
    private javax.swing.ButtonGroup m_filteringTypeButtonGroup;
    private javax.swing.JRadioButton m_movingAverageFilter;
    private javax.swing.JRadioButton m_movingMedianFilter;
    private javax.swing.JRadioButton m_simpleAveragingFilter;
    // End of variables declaration//GEN-END:variables
    
    
    // Attributes
    private LinkedList<ActionListener> m_listeners = new LinkedList<ActionListener>( );
    
    // Possible filter Types
    public final static int MOVING_MEDIAN_FILTERING = 0;
    public final static int MOVING_AVERAGE_FILTERING = 1;
    public final static int SIMPLE_AVERAGE_FILTERING = 2;
    
    // Possible Events
    public final static int CANCEL_EVENT = 0;
    public final static int APPLY_EVENT = 1;
    
    // For proper serialization
    private static final long serialVersionUID = 6332325998121223L;
}
