/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.utilities;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Composite;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JComponent;
import javax.swing.JLayer;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;
import javax.swing.Timer;
import javax.swing.plaf.LayerUI;

/**
 *
 * @author user
 */
//public class WaitLayerUI extends LayerUI implements ActionListener {
//
//    private boolean mIsRunning;
//    private boolean mIsFadingOut;
//    private Timer mTimer;
//    private int mAngle;
//    private int mFadeCount;
//    private int mFadeLimit = 10;
//    public JLayer jlayer;
//    
//    
//    public void setJLayer(JLayer jlayer){
//        this.jlayer = jlayer;
//    }
////    @Override
////    public void paint(Graphics g) {
////        int w = this.getWidth();
////        int h = this.getHeight();
////        super.paint(g); // Paint the view.
////        if (!mIsRunning) {
////            return;
////        }
////        Graphics2D g2 = (Graphics2D) g.create();
////        float fade = (float) mFadeCount / (float) mFadeLimit;
////        System.out.println(mFadeCount);
////        Composite urComposite = g2.getComposite(); // Gray it out.
////        g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1f * fade));
////        g2.fillRect(0, 0, w, h);
////        g2.setComposite(urComposite);
////        int s = Math.min(w, h) / 5;// Paint the wait indicator.
////        int cx = w / 2;
////        int cy = h / 2;
////        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
////        g2.setStroke(new BasicStroke(s / 4, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
////        g2.setPaint(Color.white);
////        g2.rotate(Math.PI * mAngle / 180, cx, cy);
////        for (int i = 0; i < 12; i++) {
////            float scale = (11.0f - (float) i) / 11.0f;
////            g2.drawLine(cx + s, cy, cx + s * 2, cy);
////            g2.rotate(-Math.PI / 6, cx, cy);
////            g2.setComposite(AlphaComposite.getInstance(
////                    AlphaComposite.SRC_OVER, scale * fade));
////        }
////        g2.dispose();
////    }
//
//    @Override
//    public void actionPerformed(ActionEvent e) {
//        if (mIsRunning) {
//            firePropertyChange("tick", 0, 1);
//            mAngle += 360/12;
//            if (mAngle >= 360) {
//                mAngle = 0;
//            }
//            if (mIsFadingOut) {
//                if (--mFadeCount == 0) {
//                    mIsRunning = false;
//                    mTimer.stop();
//                }
//            } else if (mFadeCount < mFadeLimit) {
//                mFadeCount++;
//            }
//        }
//    }
//
//    public void start() {
//        if (mIsRunning) {
//            return;
//        }
//        mIsRunning = true;// Run a thread for animation.
//        mIsFadingOut = false;
//        mFadeCount = 0;
//        int fps = 12;
//        int tick = 1000 / fps;
//        mTimer = new Timer(tick, this);
//        mTimer.start();
//    }
//
//    public void stop() {
//        mIsFadingOut = true;
//    }
//    
////    @Override
////    public void applyPropertyChange(PropertyChangeEvent pce, JLayer<JPanel> layer) {
////        if ("tick".equals(pce.getPropertyName())) {
////            repaint();
////        }
////    }
//
//}
public class WaitLayerUI extends LayerUI implements ActionListener
{

    private boolean mIsRunning;
    private boolean mIsFadingOut;
    private Timer mTimer;
    private int mAngle;
    private int mFadeCount;
    private int mFadeLimit = 15;

    @Override
    public void paint(Graphics g, JComponent c)
    {
        int w = c.getWidth();
        int h = c.getHeight();

        // Paint the view.
        super.paint(g, c);

        if (!mIsRunning)
        {
            return;
        }

        Graphics2D g2 = (Graphics2D) g.create();

        float fade = (float) mFadeCount / (float) mFadeLimit;
//         Gray it out.
        Composite urComposite = g2.getComposite();
        g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, .95f * fade));
        g2.fillRect(0, 0, w, h);
        g2.setComposite(urComposite);

        // Paint the wait indicator.
        int s = Math.min(w, h) / 5;
        int cx = w / 2;
        int cy = h / 2;
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setStroke(new BasicStroke(s / 8, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
        g2.setPaint(Color.white);
        g2.rotate(Math.PI * mAngle / 180, cx, cy);
        for (int i = 0; i < 12; i++)
        {
            float scale = (11.0f - (float) i) / 11.0f;
            g2.drawLine(cx + s, cy, cx + s * 2, cy);
            g2.rotate(-Math.PI / 6, cx, cy);
            g2.setComposite(AlphaComposite.getInstance(
                    AlphaComposite.SRC_OVER, scale * fade));
        }

        g2.dispose();
    }

    @Override
    public void actionPerformed(ActionEvent e)
    {
        if (mIsRunning)
        {
            firePropertyChange("tick", 0, 1);
            mAngle += 360/12;
            if (mAngle >= 360)
            {
                mAngle = 0;
            }
            if (mIsFadingOut)
            {
                if (--mFadeCount == 0)
                {
                    mIsRunning = false;
                    mTimer.stop();
                }
            }
            else if (mFadeCount < mFadeLimit)
            {
                mFadeCount++;
            }
        }
    }

    public void start()
    {
        if (mIsRunning)
        {
            return;
        }

        // Run a thread for animation.
        mIsRunning = true;
        mIsFadingOut = false;
        mFadeCount = 0;
        int fps = 24;
        int tick = 1000 / fps;
        mTimer = new Timer(tick, this);
        mTimer.start();
    }

    public void stop()
    {
        mIsFadingOut = true;
    }

    @Override
    public void applyPropertyChange(PropertyChangeEvent pce, JLayer l)
    {
        if ("tick".equals(pce.getPropertyName()))
        {
            l.repaint();
        }
    }
}